-- etomite_full.sql
-- 2008-04-22

-- edit by krteczek:
-- add colum `texy` to TABLE `{PREFIX}site_content`
-- 2008-06-13

-- edit by krteczek
-- patch to install error insert query
-- 2008-06-14

-- START::CREATE TABLE SECTION

CREATE TABLE `{PREFIX}active_users` (
  `internalKey` int(9) NOT NULL default '0',
  `username` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `lasthit` int(20) NOT NULL default '0',
  `id` int(10) default NULL,
  `action` varchar(10) collate utf8_unicode_ci NOT NULL default '',
  `ip` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`internalKey`)
) ENGINE=MyISAM COMMENT='Contains data about active users.';

CREATE TABLE `{PREFIX}documentgroup_names` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM COMMENT='Contains data used for access permissions.';

CREATE TABLE `{PREFIX}document_groups` (
  `id` int(10) NOT NULL auto_increment,
  `document_group` int(10) NOT NULL default '0',
  `document` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains data used for access permissions.';

CREATE TABLE `{PREFIX}keyword_xref` (
  `content_id` int(11) NOT NULL default '0',
  `keyword_id` int(11) NOT NULL default '0',
  KEY `content_id` (`content_id`),
  KEY `keyword_id` (`keyword_id`)
) ENGINE=MyISAM COMMENT='Cross reference bewteen keywords and content';

CREATE TABLE `{PREFIX}log_access` (
  `visitor` bigint(11) NOT NULL default '0',
  `document` bigint(11) NOT NULL default '0',
  `timestamp` int(20) NOT NULL default '0',
  `hour` tinyint(2) NOT NULL default '0',
  `weekday` tinyint(1) NOT NULL default '0',
  `referer` bigint(11) NOT NULL default '0',
  `entry` tinyint(1) NOT NULL default '0',
  KEY `visitor` (`visitor`),
  KEY `document` (`document`),
  KEY `timestamp` (`timestamp`),
  KEY `referer` (`referer`),
  KEY `entry` (`entry`),
  KEY `hour` (`hour`),
  KEY `weekday` (`weekday`)
) ENGINE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_hosts` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_operating_systems` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_referers` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_totals` (
  `today` date NOT NULL default '0000-00-00',
  `month` char(2) collate utf8_unicode_ci NOT NULL default '0',
  `piDay` int(11) NOT NULL default '0',
  `piMonth` int(11) NOT NULL default '0',
  `piAll` int(11) NOT NULL default '0',
  `viDay` int(11) NOT NULL default '0',
  `viMonth` int(11) NOT NULL default '0',
  `viAll` int(11) NOT NULL default '0',
  `visDay` int(11) NOT NULL default '0',
  `visMonth` int(11) NOT NULL default '0',
  `visAll` int(11) NOT NULL default '0'
) ENGINE=MyISAM COMMENT='Stores temporary logging information.';

CREATE TABLE `{PREFIX}log_user_agents` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_visitors` (
  `id` bigint(11) NOT NULL default '0',
  `os_id` bigint(11) NOT NULL default '0',
  `ua_id` bigint(11) NOT NULL default '0',
  `host_id` bigint(11) NOT NULL default '0',
  KEY `id` (`id`),
  KEY `os_id` (`os_id`),
  KEY `ua_id` (`ua_id`),
  KEY `host_id` (`host_id`)
) ENGINE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}manager_log` (
  `id` int(10) NOT NULL auto_increment,
  `timestamp` int(20) NOT NULL default '0',
  `internalKey` int(10) NOT NULL default '0',
  `username` varchar(255) collate utf8_unicode_ci default NULL,
  `action` int(10) NOT NULL default '0',
  `itemid` varchar(10) collate utf8_unicode_ci default '0',
  `itemname` varchar(255) collate utf8_unicode_ci default NULL,
  `message` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains a record of user interaction with Etomite.';

CREATE TABLE `{PREFIX}manager_users` (
  `id` int(10) NOT NULL auto_increment,
  `username` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `password` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=MyISAM COMMENT='Contains login information for Etomite users.';

CREATE TABLE `{PREFIX}membergroup_access` (
  `id` int(10) NOT NULL auto_increment,
  `membergroup` int(10) NOT NULL default '0',
  `documentgroup` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains data used for access permissions.';

CREATE TABLE `{PREFIX}membergroup_names` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM COMMENT='Contains data used for access permissions.';

CREATE TABLE `{PREFIX}member_groups` (
  `id` int(10) NOT NULL auto_increment,
  `user_group` int(10) NOT NULL default '0',
  `member` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains data used for access permissions.';

CREATE TABLE `{PREFIX}site_content` (
  `id` int(10) NOT NULL auto_increment,
  `type` varchar(20) collate utf8_unicode_ci NOT NULL default 'document',
  `contentType` varchar(50) collate utf8_unicode_ci NOT NULL default 'text/html',
  `pagetitle` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `longtitle` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `description` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `alias` varchar(100) collate utf8_unicode_ci default '',
  `published` int(1) NOT NULL default '0',
  `pub_date` int(20) NOT NULL default '0',
  `unpub_date` int(20) NOT NULL default '0',
  `parent` int(10) NOT NULL default '0',
  `isfolder` int(1) NOT NULL default '0',
  `content` mediumtext collate utf8_unicode_ci NOT NULL,
  `texy` mediumtext collate utf8_unicode_ci NOT NULL, 
  `richtext` tinyint(1) NOT NULL default '1',
  `template` int(10) NOT NULL default '1',
  `menuindex` int(10) NOT NULL default '0',
  `searchable` int(1) NOT NULL default '1',
  `cacheable` int(1) NOT NULL default '1',
  `createdby` int(10) NOT NULL default '0',
  `createdon` int(20) NOT NULL default '0',
  `editedby` int(10) NOT NULL default '0',
  `editedon` int(20) NOT NULL default '0',
  `deleted` int(1) NOT NULL default '0',
  `deletedon` int(20) NOT NULL default '0',
  `deletedby` int(10) NOT NULL default '0',
  `authenticate` int(1) NOT NULL default '0',
  `showinmenu` int(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `parent` (`parent`),
  FULLTEXT KEY `content_ft_idx` (`pagetitle`,`description`,`content`)
) ENGINE=MyISAM COMMENT='Contains the site''s document tree.';

CREATE TABLE `{PREFIX}site_htmlsnippets` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `description` varchar(255) collate utf8_unicode_ci NOT NULL default 'Chunk',
  `snippet` mediumtext collate utf8_unicode_ci NOT NULL,
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains the site''s chunks.';

CREATE TABLE `{PREFIX}site_keywords` (
  `id` int(11) NOT NULL auto_increment,
  `keyword` varchar(40) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `keyword` (`keyword`)
) ENGINE=MyISAM COMMENT='Site keyword list';

CREATE TABLE `{PREFIX}site_snippets` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `description` varchar(255) collate utf8_unicode_ci NOT NULL default 'Snippet',
  `snippet` mediumtext collate utf8_unicode_ci NOT NULL,
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM PACK_KEYS=0 COMMENT='Contains the site''s snippets.';

CREATE TABLE `{PREFIX}site_templates` (
  `id` int(10) NOT NULL auto_increment,
  `templatename` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `description` varchar(255) collate utf8_unicode_ci NOT NULL default 'Template',
  `content` mediumtext collate utf8_unicode_ci NOT NULL,
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM PACK_KEYS=0 COMMENT='Contains the site''s templates.';

CREATE TABLE `{PREFIX}system_settings` (
  `setting_name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `setting_value` varchar(250) collate utf8_unicode_ci NOT NULL default '',
  UNIQUE KEY `setting_name` (`setting_name`)
) ENGINE=MyISAM COMMENT='Contains Etomite settings.';

CREATE TABLE `{PREFIX}user_attributes` (
  `id` int(10) NOT NULL auto_increment,
  `internalKey` int(10) NOT NULL default '0',
  `fullname` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `role` int(10) NOT NULL default '0',
  `email` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `phone` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `mobilephone` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `blocked` int(1) NOT NULL default '0',
  `blockeduntil` int(11) NOT NULL default '0',
  `logincount` int(11) NOT NULL default '0',
  `lastlogin` int(11) NOT NULL default '0',
  `thislogin` int(11) NOT NULL default '0',
  `failedlogincount` int(10) NOT NULL default '0',
  `sessionid` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `userid` (`internalKey`)
) ENGINE=MyISAM COMMENT='Contains information about Etomite users.';

CREATE TABLE `{PREFIX}user_messages` (
  `id` int(10) NOT NULL auto_increment,
  `type` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `subject` varchar(60) collate utf8_unicode_ci NOT NULL default '',
  `message` text collate utf8_unicode_ci NOT NULL,
  `sender` int(10) NOT NULL default '0',
  `recipient` int(10) NOT NULL default '0',
  `private` tinyint(4) NOT NULL default '0',
  `postdate` int(20) NOT NULL default '0',
  `messageread` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains messages for the Etomite messaging system.';

CREATE TABLE `{PREFIX}user_roles` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `description` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `frames` int(1) NOT NULL default '0',
  `home` int(1) NOT NULL default '0',
  `view_document` int(1) NOT NULL default '0',
  `new_document` int(1) NOT NULL default '0',
  `save_document` int(1) NOT NULL default '0',
  `delete_document` int(1) NOT NULL default '0',
  `action_ok` int(1) NOT NULL default '0',
  `logout` int(1) NOT NULL default '0',
  `help` int(1) NOT NULL default '0',
  `messages` int(1) NOT NULL default '0',
  `new_user` int(1) NOT NULL default '0',
  `edit_user` int(1) NOT NULL default '0',
  `logs` int(1) NOT NULL default '0',
  `edit_parser` int(1) NOT NULL default '0',
  `save_parser` int(1) NOT NULL default '0',
  `edit_template` int(1) NOT NULL default '0',
  `settings` int(1) NOT NULL default '0',
  `credits` int(1) NOT NULL default '0',
  `new_template` int(1) NOT NULL default '0',
  `save_template` int(1) NOT NULL default '0',
  `delete_template` int(1) NOT NULL default '0',
  `edit_snippet` int(1) NOT NULL default '0',
  `new_snippet` int(1) NOT NULL default '0',
  `save_snippet` int(1) NOT NULL default '0',
  `delete_snippet` int(1) NOT NULL default '0',
  `empty_cache` int(1) NOT NULL default '0',
  `edit_document` int(1) NOT NULL default '0',
  `change_password` int(1) NOT NULL default '0',
  `error_dialog` int(1) NOT NULL default '0',
  `about` int(1) NOT NULL default '0',
  `file_manager` int(1) NOT NULL default '0',
  `save_user` int(1) NOT NULL default '0',
  `delete_user` int(1) NOT NULL default '0',
  `save_password` int(11) NOT NULL default '0',
  `edit_role` int(11) NOT NULL default '0',
  `save_role` int(11) NOT NULL default '0',
  `delete_role` int(11) NOT NULL default '0',
  `new_role` int(11) NOT NULL default '0',
  `access_permissions` int(1) NOT NULL default '0',
  `new_chunk` int(1) NOT NULL default '0',
  `save_chunk` int(1) NOT NULL default '0',
  `edit_chunk` int(1) NOT NULL default '0',
  `delete_chunk` int(1) NOT NULL default '0',
  `export_html` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM COMMENT='Contains information describing the Etomite user roles.';

-- END::CREATE TABLE SECTION


-- START::LOAD ADMIN USER INITIAL SETTINGS

INSERT INTO `{PREFIX}manager_users` VALUES (1, '{ADMIN}', MD5('{ADMINPASS}'));

INSERT INTO `{PREFIX}user_attributes` VALUES(1, 1, 'Administration account', 1, 'Your email goes here', '', '', 0, 0, 0, {TIMESTAMP}, {TIMESTAMP}, 0, '');

INSERT INTO `{PREFIX}user_roles` VALUES(1, 'Administrator', 'Site administrators have full access to all functions', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0);

-- END::LOAD ADMIN USER INITIAL SETTINGS


-- START::INSERT site_content DATA

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(1, 'document', 'text/html', 'Home', 'Fast, Free, and Infinitely Flexible', 'Introduction to Etomite', 'home', 1, 0, 0, 0, 0, '\r\n\r\n<p><strong>Welcome to Etomite!</strong></p>\r\n\r\n<p>This is the default installation site. If you''re reading this, it means you''ve successfully installed Etomite, and have also configured the site. Now all you need to do is to add your content, design a unique template for your site, perhaps write some snippets which make your site stand out (don''t forget to share them at the <a href="[~5~]">forums</a>), and, most of all, enjoy using Etomite!</p>\r\n\r\n<p>To log into the manager, point your browser to <a href="manager">yoursite/manager</a>.</p>\r\n\r\n<p>Please take some time to browse the rest of the pages included in this default installation. They are intended to give a brief overview of some of the capabilities of Etomite. Consider this to be your "sandbox" and feel free to play. You can''t really break anything to a point where it can''t be repaired. Any existing document can be re-used or deleted whenever you are ready to develop your site. As an alternative, you could simply Drag and Drop these documents into the Repository, or another unpublished folder, for future review.<br /></p>\r\n<br />\r\n\r\n', '\r\n\r\nWelcome to Etomite!\r\n#########################\r\n\r\nThis is the default installation site. If you''re reading this, it means you''ve successfully installed Etomite, and have also configured the site. Now all you need to do is to add your content, design a unique template for your site, perhaps write some snippets which make your site stand out (don''t forget to share them at the <a href="[~5~]">forums</a>), and, most of all, enjoy using Etomite!\r\n\r\nTo log into the manager, point your browser to "yoursite/manager":manager.\r\n\r\nPlease take some time to browse the rest of the pages included in this default installation. They are intended to give a brief overview of some of the capabilities of Etomite. Consider this to be your "sandbox" and feel free to play. You can''t really break anything to a point where it can''t be repaired. Any existing document can be re-used or deleted whenever you are ready to develop your site. As an alternative, you could simply Drag and Drop these documents into the Repository, or another unpublished folder, for future review.\r\n\r\n\r\n', 1, 1, 1, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(2, 'document', 'text/html', 'Repository', 'Un-Published Folder Document', 'Both published and un-published resources can be stored here.', '', 0, 0, 0, 0, 1, '<p>\r\nThis folder document is intended to be used as a storage repository only and should remain un-published. This is a handy place to store documents which are called indirectly, such as the 404 Error page.\r\n\r\n</p>', '\r\nThis folder document is intended to be used as a storage repository only and should remain un-published. This is a handy place to store documents which are called indirectly, such as the 404 Error page.\r\n\r\n', 1, 1, 7, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(3, 'document', 'text/html', 'Error 404 - Page Not Found', 'Unable to locate the page you requested.', 'The error page which is displayed when the requested page cannot be found', 'http404', 1, 0, 0, 2, 0, '<p><strong>404 Error - File not Found</strong></p>\r\n  <p>The page you''ve requested has not been found. You could try going back to the <a href="[~1~]">home page</a> to try to find what you were looking for from there.</p>', '404 Error - File not Found\r\n#####################\r\nThe page you''ve requested has not been found. You could try going back to the <a href="[~1~]">home page</a> to try to find what you were looking for from there.\r\n', 1, 1, 0, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(4, 'document', 'text/html', 'Search this site', 'Let us help you find what you''re looking for', 'This page allows you to search the site.', 'search', 1, 0, 0, 2, 0, '\r\n<p>Enter the words and phrases you would like to search for, and press the search button.<br /></p>\r\n  [[SearchForm]]\r\n\r\n', '\r\nEnter the words and phrases you would like to search for, and press the search button.\r\n\r\n  [[SearchForm]]\r\n\r\n', 1, 1, 7, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(5, 'reference', 'text/html', 'Etomite Forums', '', 'A link to the Etomite forums.', 'etomite-forums', 1, 0, 0, 33, 0, 'http://www.etomite.com/forums/', 'http://www.etomite.com/forums/', 0, 0, 5, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(6, 'document', 'text/html', 'Site statistics', 'Visitors statistics for this site', 'Page that shows some visitor statistics for the site.', 'stats', 1, 0, 0, 2, 0, '<p>This page shows the site''s visitor statistics per <strong>[[DateTime]]</strong>.<br />The first ever hit to the site to be recorded was on <strong>[[FirstHit]]</strong>.</p>\r\n[[GetStats]] ', 'This page shows the site''s visitor statistics per **[[DateTime]]**.\r\nThe first ever hit to the site to be recorded was on **[[FirstHit]]**\r\n\r\n[[GetStats]] ', 1, 1, 6, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(7, 'document', 'text/html', 'Installation Successful!', 'Your Etomite CMS powered website is working.', 'The fact that this page displays indicates that your installation and configuration was successful.', 'installed', 1, 0, 0, 8, 0, '\r\n\r\n<p>This is a news article to show:</p>\r\n\r\n<ul>\r\n<li>That the installation was successful</li>\r\n<li>The working of the NewsListing snippet </li></ul>\r\n<p>The NewsListing snippet is written into the document like this:</p>\r\n\r\n<p style="font-family: courier new,courier,monospace;">[ [NewsListing?newsid=[*parent*]] ]</p>\r\n   <!--FullStory-->\r\n<p>This calls the NewsListing snippet, and feeds it with a variable called newsid, which has a value of [*parent*]. The newsid variable is then used by the snippet so it knows where to look for news. This way, you can have as many different news sections, or blogs even, using just one snippet! Oh yeah, there''s not meant to be a space between the double [ and ] square bracket characters. Those were added to stop Etomite from thinking it needed to call the snippet here.</p>\r\n\r\n<p> </p>\r\n    [!DisplayCode?type=snippet&amp;name=NewsListing!]\r\n\r\n', '\r\n\r\nThis is a news article to show:\r\n\r\n\r\n- That the installation was successful\r\n- The working of the NewsListing snippet\r\n\r\nThe NewsListing snippet is written into the document like this:\r\n\r\n<p style="font-family: courier new,courier,monospace;">[ [NewsListing?newsid=[*parent*]] ]</p>\r\n   <!--FullStory-->\r\n\r\nThis calls the NewsListing snippet, and feeds it with a variable called newsid, which has a value of [*parent*]. The newsid variable is then used by the snippet so it knows where to look for news. This way, you can have as many different news sections, or blogs even, using just one snippet! Oh yeah, there''s not meant to be a space between the double [ and ] square bracket characters. Those were added to stop Etomite from thinking it needed to call the snippet here.\r\n\r\n\r\n    [!DisplayCode?type=snippet&amp;name=NewsListing!]\r\n\r\n', 1, 1, 1, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(8, 'document', 'text/html', 'News', 'News Article Summary', 'The following documents are intended to help introduce you to the Etomite Content Management System.', 'news', 1, 0, 0, 0, 1, '<h2>  [*description*]</h2><br />\r\n  <p>News Article List using the NewsListing snippet:</p>\r\n[[NewsListing?newsid=8]]', '[*description*]\r\n########################\r\n\r\nNews Article List using the NewsListing snippet:\r\n\r\n[[NewsListing?newsid=8]]', 1, 1, 2, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(9, 'document', 'text/html', 'What Next?', 'Where do we go form here?', 'Some suggestions on getting acquainted with Etomite.', 'what-next', 1, 0, 0, 8, 0, '\r\n<p>Here are several suggestions on how to proceed with getting acquainted with using the Etomite CMS. Once you start experimenting with the system you will discover that your imagination may be the only limiting factor when it comes to developing sites using Etomite.</p>\r\n  First, take some time to check out every part of the Etomite Manager. There is a lot more going on in there than meets the eye at first glance. The main menu contains many general site management related options.<br /><br />Next you might want to become familiar with the Document Tree section of the Etomite Manager. This is where you control the document hierarchy of your site. Clicking on a folder toggles it open or closed. Right clicking over a document title presents a context menu which contains several of the more frequently used document management actions. The menu also has a Drag-N-Drop feature for rearranging the documents within the document tree hierarchy.<br /><br />The real power of Etomite lies in the Manage Resources section. This section allows you to create your own page Templates, PHP code Snippets, HTML/Javascript Chunks, and manage Keywords. Take some time to look over the existing resources to get a better insight on how they relate to the overall functionality within Etomite.<br /><br />\r\n\r\n', '\r\nHere are several suggestions on how to proceed with getting acquainted with using the Etomite CMS. Once you start experimenting with the system you will discover that your imagination may be the only limiting factor when it comes to developing sites using Etomite.\r\n\r\n  First, take some time to check out every part of the Etomite Manager. There is a lot more going on in there than meets the eye at first glance. The main menu contains many general site management related options.\r\n\r\nNext you might want to become familiar with the Document Tree section of the Etomite Manager. This is where you control the document hierarchy of your site. Clicking on a folder toggles it open or closed. Right clicking over a document title presents a context menu which contains several of the more frequently used document management actions. The menu also has a Drag-N-Drop feature for rearranging the documents within the document tree hierarchy.\r\n\r\nThe real power of Etomite lies in the Manage Resources section. This section allows you to create your own page Templates, PHP code Snippets, HTML/Javascript Chunks, and manage Keywords. Take some time to look over the existing resources to get a better insight on how they relate to the overall functionality within Etomite.\r\n\r\n\r\n', 1, 1, 2, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(10, 'document', 'text/html', 'Help and Support', 'Where to find the answers you need.', 'Etomite is one of the best supported Open Source packages when it comes to timely rsponses to your concerns.', 'help-and-support', 1, 0, 0, 8, 0, '\r\n  When you have questions, and you almost certainly will, it''s nice to know that help is available. The Etomite support staff know the value of time which is why they make every possible effort to keep you moving forward with development of your projects.<br /><br />The first place to look whenever you have questions is in the documentation section of the Etomite website. The process of documenting the Etomite CMS is an ongoing task and we ask that anyone who has the ability, and desire, to donate their efforts towards enhancing our current documentation if at all possible.<br /><br />If the answers to your questions can''t be found in the documentation, or you need a bit more clarification regarding a specific issue, then you can try a search of the Etomite support forums. Please make every attempt to do thorough searches before posting a question that may have already been previously answered. There is also a Frequently Asked Question section which we attempt to keep up to date.<br /><br />When all else fails the Etomite support may even offer one-on-one support, including hands-on diagnosis and repair of stubborn issues. While the staff does not encourage users to ask for such levels of support the staffers may make the offer just to get you back in business faster.<br /><br />The Etomite community also has several members who work with Etomite almost exclusively and they may be willing to lend their expertise, for negotiable fees, should you require their services. This level of support ranges from site template conversions all the way to complete custom data management modules to extend Etomite to your needs.<br /><br />One thing is for certain - you will never be left feeling like nobody has even read your support request. Most support requests are acknowledged within hours, or even minutes, not days, and the support continues until the issue has been resolved.<br /><br />\r\n\r\n', '\r\n  When you have questions, and you almost certainly will, it''s nice to know that help is available. The Etomite support staff know the value of time which is why they make every possible effort to keep you moving forward with development of your projects.\r\n\r\nThe first place to look whenever you have questions is in the documentation section of the Etomite website. The process of documenting the Etomite CMS is an ongoing task and we ask that anyone who has the ability, and desire, to donate their efforts towards enhancing our current documentation if at all possible.\r\n\r\nIf the answers to your questions can''t be found in the documentation, or you need a bit more clarification regarding a specific issue, then you can try a search of the Etomite support forums. Please make every attempt to do thorough searches before posting a question that may have already been previously answered. There is also a Frequently Asked Question section which we attempt to keep up to date.\r\n\r\nWhen all else fails the Etomite support may even offer one-on-one support, including hands-on diagnosis and repair of stubborn issues. While the staff does not encourage users to ask for such levels of support the staffers may make the offer just to get you back in business faster.\r\n\r\nThe Etomite community also has several members who work with Etomite almost exclusively and they may be willing to lend their expertise, for negotiable fees, should you require their services. This level of support ranges from site template conversions all the way to complete custom data management modules to extend Etomite to your needs.\r\n\r\nOne thing is for certain - you will never be left feeling like nobody has even read your support request. Most support requests are acknowledged within hours, or even minutes, not days, and the support continues until the issue has been resolved.\r\n\r\n\r\n\r\n', 1, 1, 3, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(11, 'document', 'text/html', 'Contribute', 'Giving back to the Etomite community.', 'Contributions don''t always have to be monetary.', 'contribute', 1, 0, 0, 8, 0, '\r\nIf you find the Etomite CMS package useful then why not contribute back to the community. The level of contribution is up to you and there are several ways to do so.<br /><br />Keeping the support forums up and running, like everything else these days, takes money. You don''t get reliable hosting for free, as we have discovered, the hard way, in the past. ANY and ALL monetary contributions are greatly appreciated and no monetary contribution is too small. All monetary contributions are processed via PayPal so that personal information remains secure.<br /><br />Helping out with support issues in the support forums is yet another way to contribute back to the project. While you may not feel adept enough to lend a hand right at the start you may end up being able to share through your personal experiences of working with the Etomite software as time progresses. It is the dedication of its many users that makes Etomite what it is today.<br /><br />Contributions of page templates, PHP snippets, HTML or Javascript chunks, documentation, tutorials, or anything else you can think of would be graciously welcomed. Conversions and third-party integrations, while at the more advanced end of the spectrum, are yet another way that some members contribute.<br /><br />\r\n\r\n', '\r\nIf you find the Etomite CMS package useful then why not contribute back to the community. The level of contribution is up to you and there are several ways to do so.\r\n\r\nKeeping the support forums up and running, like everything else these days, takes money. You don''t get reliable hosting for free, as we have discovered, the hard way, in the past. ANY and ALL monetary contributions are greatly appreciated and no monetary contribution is too small. All monetary contributions are processed via PayPal so that personal information remains secure.\r\n\r\nHelping out with support issues in the support forums is yet another way to contribute back to the project. While you may not feel adept enough to lend a hand right at the start you may end up being able to share through your personal experiences of working with the Etomite software as time progresses. It is the dedication of its many users that makes Etomite what it is today.\r\n\r\nContributions of page templates, PHP snippets, HTML or Javascript chunks, documentation, tutorials, or anything else you can think of would be graciously welcomed. Conversions and third-party integrations, while at the more advanced end of the spectrum, are yet another way that some members contribute.\r\n\r\n\r\n\r\n', 1, 1, 4, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(12, 'document', 'text/html', 'Document Tags', 'Document Resource Tags', 'Document tags and their definitions.', 'doc-tags', 1, 0, 0, 20, 0, '\r\n\r\n<p>Right about now you may be wondering how Etomite can make your site development endeavor a more productive and exciting experience. There are several built-in Etomite resources which can make working with dynamic content a lot easier and we''ll sample some of those here.</p>\r\n\r\n<p>Etomite stores all document resources in the site_content database table and we can access any of the available data fields using the following resource tags. Each tag is followed by a brief explanation of the corresponding data fields general purpose. It should be noted, however, that only those fields fields requested in the database query will be available and several of the API functions only retrieve a subset of these fields by default. To display one of these data fields within a page template, document, or chunk, you would use the document tag format, <span style="font-weight: bold;">[ *field* ]</span>, and the parser will replace the tag with the data fields current value. As an example, by placing the <span style="font-weight: bold;">[ *pagetitle* ]</span> tag here in this sentence the parser will display <span style="font-weight: bold;">[*pagetitle*]</span>, the title of this page.</p>\r\n\r\n<table class="varList">\r\n<tbody>\r\n<tr>\r\n<th>Column</th>\r\n\r\n<th>Description</th>\r\n</tr>\r\n<tr>\r\n<td>id</td>\r\n<td>Returns the ID of the current page</td></tr>\r\n<tr>\r\n<td>type</td>\r\n<td>Currently Document or Reference (web link), but could be expanded in future releases</td></tr>\r\n<tr>\r\n<td>contentType</td>\r\n<td>This is the documents content-type which can be used to used for meta tag generation</td></tr>\r\n<tr>\r\n<td>pagetitle</td>\r\n<td>Returns the page title of the current page</td></tr>\r\n<tr>\r\n<td>longtitle</td>\r\n<td>Returns the long title of the current page</td></tr>\r\n<tr>\r\n<td>description</td>\r\n<td>Returns the description of the current page</td></tr>\r\n<tr>\r\n<td>alias</td>\r\n<td>The documents Alias name</td></tr>\r\n<tr>\r\n<td>published</td>\r\n<td>Whether the document is published or unpublished</td></tr>\r\n<tr>\r\n<td>pub_date</td>\r\n<td>A unix timestamp which determines when to publish a document when set</td></tr>\r\n<tr>\r\n<td>unpub_date</td>\r\n<td>A unix timestamp which determines when to unpublish a document when set</td></tr>\r\n<tr>\r\n<td>parent</td>\r\n<td>The current documents parent in the document tree</td></tr>\r\n<tr>\r\n<td>isfolder</td>\r\n<td>Whether this document is also a parent folder which can have child documents</td></tr>\r\n<tr>\r\n<td>content</td>\r\n<td>Returns the content of the current page</td></tr>\r\n<tr>\r\n<td>richtext</td>\r\n<td>Whether or not to use a WYSIWYG editor for maintaining this document</td></tr>\r\n<tr>\r\n<td>template</td>\r\n<td>The page template to use when rendering this document</td></tr>\r\n<tr>\r\n<td>menuindex</td>\r\n<td>This index is used for ordering within the document tree as a sub-sort of the documents parent</td></tr>\r\n<tr>\r\n<td>searchable</td>\r\n<td>Whether this document should be included in site searches, based on snippet logic</td></tr>\r\n<tr>\r\n<td>cacheable</td>\r\n<td>Whether this document should be cached</td></tr>\r\n<tr>\r\n<td>createdby</td>\r\n<td>The internalKey id of the user who created this document</td></tr>\r\n<tr>\r\n<td>createdon</td>\r\n<td>Unix timestamp representing when this document was originally created</td></tr>\r\n<tr>\r\n<td>editedby</td>\r\n<td>The internalKey id of the user who last edited this document</td></tr>\r\n<tr>\r\n<td>editedon</td>\r\n<td>Unix timestamp representing when this document was last edited</td></tr>\r\n<tr>\r\n<td>deleted</td>\r\n<td>Whether this document is flagged to be purged from the database</td></tr>\r\n<tr>\r\n<td>deletedon</td>\r\n<td>Unix timestamp representing when this document was flagged as deleted</td></tr>\r\n<tr>\r\n<td>deletedby</td>\r\n<td>The internalKey id of the user who flagged as deleted</td></tr>\r\n<tr>\r\n<td>authenticate</td>\r\n<td>Whether or not user authentication of this document should be performed by the parser or via snippet logic</td></tr>\r\n<tr>\r\n<td>showinmenu</td>\r\n<td>Boolean flag [0|1] which is used by several API functions, primarily to determine whether or not a document should be included in a menu.</td></tr></tbody></table>\r\n\r\n', '\r\n\r\n<p>Right about now you may be wondering how Etomite can make your site development endeavor a more productive and exciting experience. There are several built-in Etomite resources which can make working with dynamic content a lot easier and we''ll sample some of those here.</p>\r\n\r\n<p>Etomite stores all document resources in the site_content database table and we can access any of the available data fields using the following resource tags. Each tag is followed by a brief explanation of the corresponding data fields general purpose. It should be noted, however, that only those fields fields requested in the database query will be available and several of the API functions only retrieve a subset of these fields by default. To display one of these data fields within a page template, document, or chunk, you would use the document tag format, <span style="font-weight: bold;">[ *field* ]</span>, and the parser will replace the tag with the data fields current value. As an example, by placing the <span style="font-weight: bold;">[ *pagetitle* ]</span> tag here in this sentence the parser will display <span style="font-weight: bold;">[*pagetitle*]</span>, the title of this page.</p>\r\n\r\n<table class="varList">\r\n<tbody>\r\n<tr>\r\n<th>Column</th>\r\n\r\n<th>Description</th>\r\n</tr>\r\n<tr>\r\n<td>id</td>\r\n<td>Returns the ID of the current page</td></tr>\r\n<tr>\r\n<td>type</td>\r\n<td>Currently Document or Reference (web link), but could be expanded in future releases</td></tr>\r\n<tr>\r\n<td>contentType</td>\r\n<td>This is the documents content-type which can be used to used for meta tag generation</td></tr>\r\n<tr>\r\n<td>pagetitle</td>\r\n<td>Returns the page title of the current page</td></tr>\r\n<tr>\r\n<td>longtitle</td>\r\n<td>Returns the long title of the current page</td></tr>\r\n<tr>\r\n<td>description</td>\r\n<td>Returns the description of the current page</td></tr>\r\n<tr>\r\n<td>alias</td>\r\n<td>The documents Alias name</td></tr>\r\n<tr>\r\n<td>published</td>\r\n<td>Whether the document is published or unpublished</td></tr>\r\n<tr>\r\n<td>pub_date</td>\r\n<td>A unix timestamp which determines when to publish a document when set</td></tr>\r\n<tr>\r\n<td>unpub_date</td>\r\n<td>A unix timestamp which determines when to unpublish a document when set</td></tr>\r\n<tr>\r\n<td>parent</td>\r\n<td>The current documents parent in the document tree</td></tr>\r\n<tr>\r\n<td>isfolder</td>\r\n<td>Whether this document is also a parent folder which can have child documents</td></tr>\r\n<tr>\r\n<td>content</td>\r\n<td>Returns the content of the current page</td></tr>\r\n<tr>\r\n<td>richtext</td>\r\n<td>Whether or not to use a WYSIWYG editor for maintaining this document</td></tr>\r\n<tr>\r\n<td>template</td>\r\n<td>The page template to use when rendering this document</td></tr>\r\n<tr>\r\n<td>menuindex</td>\r\n<td>This index is used for ordering within the document tree as a sub-sort of the documents parent</td></tr>\r\n<tr>\r\n<td>searchable</td>\r\n<td>Whether this document should be included in site searches, based on snippet logic</td></tr>\r\n<tr>\r\n<td>cacheable</td>\r\n<td>Whether this document should be cached</td></tr>\r\n<tr>\r\n<td>createdby</td>\r\n<td>The internalKey id of the user who created this document</td></tr>\r\n<tr>\r\n<td>createdon</td>\r\n<td>Unix timestamp representing when this document was originally created</td></tr>\r\n<tr>\r\n<td>editedby</td>\r\n<td>The internalKey id of the user who last edited this document</td></tr>\r\n<tr>\r\n<td>editedon</td>\r\n<td>Unix timestamp representing when this document was last edited</td></tr>\r\n<tr>\r\n<td>deleted</td>\r\n<td>Whether this document is flagged to be purged from the database</td></tr>\r\n<tr>\r\n<td>deletedon</td>\r\n<td>Unix timestamp representing when this document was flagged as deleted</td></tr>\r\n<tr>\r\n<td>deletedby</td>\r\n<td>The internalKey id of the user who flagged as deleted</td></tr>\r\n<tr>\r\n<td>authenticate</td>\r\n<td>Whether or not user authentication of this document should be performed by the parser or via snippet logic</td></tr>\r\n<tr>\r\n<td>showinmenu</td>\r\n<td>Boolean flag [0|1] which is used by several API functions, primarily to determine whether or not a document should be included in a menu.</td></tr></tbody></table>\r\n\r\n', 1, 1, 5, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(13, 'document', 'text/html', 'New-E', 'Classic colors - contemporary design', 'Demonstration of the New-E page template', 'new-e', 1, 0, 0, 13, 0, '<h2>Fresh</h2>\r\n\r\n<p>New-E is a more contemporary take on the classic orange\r\nand blue theme. Brighter, bolder, and more standards compliant,\r\nNew-E is the new Etomite standard.</p>\r\n\r\n<p>Also a shout of thanks to Capertino for the layout inspiration!</p>', 'Fresh\r\n########\r\n\r\nNew-E is a more contemporary take on the classic orange\r\nand blue theme. Brighter, bolder, and more standards compliant,\r\nNew-E is the new Etomite standard.\r\n\r\nAlso a shout of thanks to Capertino for the layout inspiration!', 1, 1, 90, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(14, 'document', 'text/html', 'Search Results', 'This document contains the SearchResults snippet call', 'Displays the results of the SearchPrompt snippet', '', 1, 0, 0, 2, 0, '\r\n[!SearchResults!]\r\n\r\n', '\r\n[!SearchResults!]\r\n\r\n', 1, 1, 0, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(15, 'document', 'text/html', 'Site Map', 'Links to every page on this web site', 'Links to every page on this web site', 'site-map', 1, 0, 0, 0, 0, '[!ListSiteMap!] ', '[!ListSiteMap!] ', 1, 1, 5, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(16, 'document', 'text/xml', 'Google Site Map', '', '', 'google-sitemap', 1, 0, 0, 2, 0, '[!GoogleSiteMap_XML!]', '[!GoogleSiteMap_XML!]', 0, 2, 10, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(17, 'document', 'text/html', 'sideBanner', '', '', '', 0, 0, 0, 0, 0, '\r\n\r\n<p>If you enjoy Etomite and find it useful, please consider <a href="http://www.etomite.com/contribute.html" title="Contribute to Etomite">contributing</a>! Your contributions keep the Etomite project alive and make it the great CMS it is today.</p>\r\n\r\n\r\n', '\r\n\r\nIf you enjoy Etomite and find it useful, please consider "contributing .(Contribute to Etomite)":http://www.etomite.com/contribute.html! Your contributions keep the Etomite project alive and make it the great CMS it is today.\r\n\r\n\r\n', 1, 1, 6, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`,`showinmenu`) VALUES(18, 'document', 'text/html', 'Test1', '', '', '', 1, 0, 0, 21, 0, '\r\n<span style="font-weight: bold;">Copyright:</span> [!Copyright!]<br /><span style="font-weight: bold;"></span><span style="font-weight: bold;">DateTimePlus:</span> [!DateTimePlus!]<br /><span style="font-weight: bold;">FirtsHit:</span> [!FirstHit!]<br /><span style="font-weight: bold;">GetAuthorData:</span> [!GetAuthorData?internalKey=[*editedby*]&amp;field=fullname!]<br /><span style="font-weight: bold;">GetDocContent:</span> [!GetDocContent?id=25!]<br /><span style="font-weight: bold;"></span><span style="font-weight: bold;"></span><span style="font-weight: bold;"></span><span style="font-weight: bold;">PageTrail:</span> [!PageTrail!]<br /><span style="font-weight: bold;">PoweredBy:</span> [!PoweredBy!]<br /><span style="font-weight: bold;">SiteUpdate:</span> [!SiteUpdate!]<br /><span style="font-weight: bold;">SummaryList:</span> [!SummaryList?ids=8!]<br /><span style="font-weight: bold;">ListDocuments:</span> [!ListDocuments?ids=8!]<br /><span style="font-weight: bold;"></span><span style="font-weight: bold;">NewsListing:</span> [!NewsListing?newsid=8!]<br /><span style="font-weight: bold;"></span>\r\n\r\n', '\r\n**Copyright:** [!Copyright!]\r\n**DateTimePlus:** [!DateTimePlus!]\r\n**FirtsHit:** [!FirstHit!]\r\n**GetAuthorData:** [!GetAuthorData?internalKey=[*editedby*]&amp;field=fullname!]\r\n**GetDocContent:** [!GetDocContent?id=25!]\r\n**PageTrail:** [!PageTrail!]\r\n**PoweredBy:** [!PoweredBy!]\r\n**SiteUpdate:** [!SiteUpdate!]\r\n**SummaryList:** [!SummaryList?ids=8!]\r\n**ListDocuments:** [!ListDocuments?ids=8!]\r\n**NewsListing:** [!NewsListing?newsid=8!]\r\n\r\n\r\n', 1, 1, 5, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(19, 'document', 'text/html', 'sideBanner', '', '', '', 0, 0, 0, 21, 0, '<p>This is a section-specific sidebar that is being used to demonstrate how multiple sidebars can be used throughout a site.<br /></p>\r\n                                \r\n\r\n', 'This is a section-specific sidebar that is being used to demonstrate how multiple sidebars can be used throughout a site.\r\n\r\n\r\n', 1, 1, 4, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(20, 'document', 'text/html', 'Resources', 'Overview of Etomite resources', 'These are the components that make your work easier.', 'resources', 1, 0, 0, 0, 1, '\r\n<p>Wondering about the sub-menu that just appeared on the left? It''s built using ListMenu, one of the many menu-generating snippets available to Etomite.</p>\r\n\r\n<p>The menu will automatically update to show this document''s children when you create sub-documents underneath any document; and using CSS styles, you can control how it looks.</p>\r\n\r\n<p>You can hide any documents in your Etomite website by de-selecting the "Show in menu" setting, un-publishing a document, or of course, deleting a document.</p>\r\n     \r\n\r\n', '\r\nWondering about the sub-menu that just appeared on the left? It''s built using ListMenu, one of the many menu-generating snippets available to Etomite.\r\n\r\nThe menu will automatically update to show this document''s children when you create sub-documents underneath any document; and using CSS styles, you can control how it looks.\r\n\r\nYou can hide any documents in your Etomite website by de-selecting the "Show in menu" setting, un-publishing a document, or of course, deleting a document.\r\n\r\n\r\n', 1, 1, 3, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(21, 'document', 'text/html', 'Testing DateTimePlus', 'Testing DateTimePlus Long Title', 'This is the description', 'Test', 1, 0, 0, 23, 0, '\r\n  Testing DateTimePlus to see if it displays the year as <font size="3">[!DateTimePlus?format=Y!]</font>\r\n\r\n', '\r\n Testing DateTimePlus to see if it displays the year as **[!DateTimePlus?format=Y!]**\r\n\r\n', 1, 1, 1, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(22, 'document', 'text/html', 'Overview', 'Tapping into the powers of Etomite', 'Some simple tips that can make site development easy and fun.', 'overview', 1, 0, 0, 21, 0, '<p>Right about now you may be wondering how Etomite can make your site development endeavor a more productive and exciting experience. There are several built-in Etomite resources which can make working with dynamic content a lot easier and we''ll sample some of those here.</p>\r\n<p>Etomite stores all document resources in the site_content database table and we can access any of the available data fields using the following resource tags. Each tag is followed by a brief explanation of the corresponding data fields general purpose. It should be noted, however, that only those fields fields requested in the database query will be available and several of the API functions only retrieve a subset of these fields by default. To display one of these data fields within a page template, document, or chunk, you would use the document tag format, [*field*], and the parser will replace the tag with the data fields current value. As an example, by placing the [*pagetitle*] tag here in this sentence the parser will display <span style="font-weight: bold;">Overview</span>, the title of this page.</p>\r\n<br /><dl class="table-display">&nbsp; <dt>id</dt>&nbsp; <dd>Returns the ID of the current page</dd>&nbsp; <dt>type</dt>&nbsp; <dd>Currently Document or Reference (web link), but could be expanded in future releases</dd>&nbsp; <dt>contentType</dt>&nbsp; <dd>This is the documents content-type which can be used to used for meta tag generation</dd>&nbsp; <dt>pagetitle</dt>&nbsp; <dd>Returns the page title of the current page</dd>&nbsp; <dt>longtitle</dt>&nbsp; <dd>Returns the long title of the current page</dd>&nbsp; <dt>description</dt>&nbsp; <dd>Returns the description of the current page</dd>&nbsp; <dt>alias</dt>&nbsp; <dd>The documents Alias name</dd>&nbsp; <dt>published</dt>&nbsp; <dd>Whether the document is published or unpublished</dd>&nbsp; <dt>pub_date</dt>&nbsp; <dd>A unix timestamp which determines when to publish a document when set</dd>&nbsp; <dt>unpub_date</dt>&nbsp; <dd>A unix timestamp which determines when to unpublish a document when set</dd>&nbsp; <dt>parent</dt>&nbsp; <dd>The current documents parent in the document tree</dd>&nbsp; <dt>isfolder</dt>&nbsp; <dd>Whether this document is also a parent folder which can have child documents</dd>&nbsp; <dt>content</dt>&nbsp; <dd>Returns the content of the current page</dd>&nbsp; <dt>richtext</dt>&nbsp; <dd>Whether or not to use a WYSIWYG editor for maintaining this document</dd>&nbsp; <dt>template</dt>&nbsp; <dd>The page template to use when rendering this document</dd>&nbsp; <dt>menuindex</dt>&nbsp; <dd>This index is used for ordering within the document tree as a sub-sort of the documents parent</dd>&nbsp; <dt>searchable</dt>&nbsp; <dd>Whether this document should be included in site searches, based on snippet logic</dd>&nbsp; <dt>cacheable</dt>&nbsp; <dd>Whether this document should be cached</dd>&nbsp; <dt>createdby</dt>&nbsp; <dd>The internalKey id of the user who created this document</dd>&nbsp; <dt>createdon</dt>&nbsp; <dd>Unix timestamp representing when this document was originally created</dd>&nbsp; <dt>editedby</dt>&nbsp; <dd>The internalKey id of the user who last edited this document</dd>&nbsp; <dt>editedon</dt>&nbsp; <dd>Unix timestamp representing when this document was last edited</dd>&nbsp; <dt>deleted</dt>&nbsp; <dd>Whether this document is flagged to be purged from the database</dd>&nbsp; <dt>deletedon</dt>&nbsp; <dd>Unix timestamp representing when this document was flagged as deleted</dd>&nbsp; <dt>deletedby</dt>&nbsp; <dd>The internalKey id of the user who flagged as deleted</dd>&nbsp; <dt>authenticate</dt>&nbsp; <dd>Whether or not user authentication of this document should be performed by the parser or via snippet logic</dd>&nbsp; <dt>showinmenu</dt>&nbsp; <dd>Boolean flag [0|1] which is used by several API functions, primarily to determine whether or not a document should be included in a menu.</dd></dl>', '\r\nRight about now you may be wondering how Etomite can make your site development endeavor a more productive and exciting experience. There are several built-in Etomite resources which can make working with dynamic content a lot easier and we''ll sample some of those here.\r\n\r\nEtomite stores all document resources in the site_content database table and we can access any of the available data fields using the following resource tags. Each tag is followed by a brief explanation of the corresponding data fields general purpose. It should be noted, however, that only those fields fields requested in the database query will be available and several of the API functions only retrieve a subset of these fields by default. To display one of these data fields within a page template, document, or chunk, you would use the document tag format, [*field*], and the parser will replace the tag with the data fields current value. As an example, by placing the [*pagetitle*] tag here in this sentence the parser will display **Overview**, the title of this page.\r\n\r\nid::\r\n - Returns the ID of the current page\r\ntype::\r\n - Currently Document or Reference (web link), but could be expanded in future releases\r\ncontentType::\r\n - This is the documents content-type which can be used to used for meta tag generation\r\npagetitle::\r\n - Returns the page title of the current page\r\nlongtitle::\r\n - Returns the long title of the current page\r\ndescription::\r\n - Returns the description of the current page\r\nalias::\r\n - The documents Alias name\r\npublished::\r\n - Whether the document is published or unpublished\r\npub_date::\r\n - A unix timestamp which determines when to publish a document when set\r\nunpub_date::\r\n - A unix timestamp which determines when to unpublish a document when set\r\nparent::\r\n - The current documents parent in the document tree\r\nisfolder::\r\n - Whether this document is also a parent folder which can have child documents\r\ncontent::\r\n - Returns the content of the current page\r\nrichtext::\r\n - Whether or not to use a WYSIWYG editor for maintaining this document\r\ntemplate::\r\n - The page template to use when rendering this document\r\nmenuindex::\r\n - This index is used for ordering within the document tree as a sub-sort of the documents parent\r\nsearchable::\r\n - Whether this document should be included in site searches, based on snippet logic\r\ncacheable::\r\n - Whether this document should be cached\r\ncreatedby::\r\n - The internalKey id of the user who created this document\r\ncreatedon::\r\n - Unix timestamp representing when this document was originally created\r\neditedby::\r\n - The internalKey id of the user who last edited this document\r\neditedon::\r\n - Unix timestamp representing when this document was last edited\r\neleted::\r\n - Whether this document is flagged to be purged from the database\r\ndeletedon::\r\n - Unix timestamp representing when this document was flagged as deleted\r\ndeletedby::\r\n - The internalKey id of the user who flagged as deleted\r\nauthenticate::\r\n - Whether or not user authentication of this document should be performed by the parser or via snippet logic\r\nshowinmenu::\r\n - Boolean flag [0|1] which is used by several API functions, primarily to determine whether or not a document should be included in a menu.\r\n\r\n',1, 1, 1, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(23, 'document', 'text/html', 'Child document', 'This is a child document', 'Some would call this a sub-page.', 'child-document', 1, 0, 0, 21, 1, '<p>This page exists to demonstrate how a sub-page can be handles in Etomite.</p>\r\n<p>You can have virtually endless pages in your Etomite website, and there are many menu snippets available to help you organize your pages and make them available to your visitors.</p>\r\n\r\n\r\n', 'This page exists to demonstrate how a sub-page can be handles in Etomite.\r\n\r\nYou can have virtually endless pages in your Etomite website, and there are many menu snippets available to help you organize your pages and make them available to your visitors.\r\n\r\n\r\n', 1, 1, 2, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(24, 'document', 'text/html', 'sideBanner', '', '', '', 0, 0, 0, 8, 0, '\r\n\r\n<p>This section demonstrates how Etomite can be used to display news articles for visitors to read. These articles may pertain to company news, new product introductions, or blog entries. The choice is yours.</p>\r\n\r\n<p>This explanatory text is being displayed by the <span style="font-weight: bold;">getSideBar</span> Snippet.</p>\r\n\r\n\r\nThe Search feature below is being displayed by the <span style="font-weight: bold;">SearchPrompt</span> Snippet.<br />', '\r\n\r\nThis section demonstrates how Etomite can be used to display news articles for visitors to read. These articles may pertain to company news, new product introductions, or blog entries. The choice is yours.\r\n\r\nThis explanatory text is being displayed by the **getSideBar** Snippet.\r\n\r\n\r\nThe Search feature below is being displayed by the **SearchPrompt** Snippet.\r\n\r\n', 1, 1, 6, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(25, 'document', 'text/html', 'Third-Level Page', 'This is a Third Level Page', 'This third-level page is here to demonstrate the capabilities of Etomite.', 'third-level-page', 1, 0, 0, 23, 0, '\r\n<p>This is a third-level page.</p>\r\n\r\n<p>The default Etomite template includes ListMenu snippet CSS styles to display documents up to four levels deep.\r\n\r\n\r\n', '\r\nThis is a third-level page.\r\n\r\nThe default Etomite template includes ListMenu snippet CSS styles to display documents up to four levels deep.\r\n\r\n\r\n', 1, 1, 0, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(26, 'document', 'text/html', 'Fourth-Level Page', 'This is a fourth-level document', 'This fourth-level page exists to demonstrate The capabilites of Etomtie', 'fourth-level-page', 1, 0, 0, 26, 0, '\r\n<p><strong>What is Etomite?</strong><br />Etomite is a Content Management  System, which allows you to remotely administer your website from  anywhere that you have an Internet Connection and a compatible  Web-Browser.</p>\r\n\r\n<p><strong>What makes Etomite Different?</strong><br />Etomite  is completely different in many ways - it allows the end user to  control virtually every aspect of their website, whether it be from  layout to how the Meta Tags are generated, making it the number one SEO  CMS.<br />If you are running Apache, and your host allows the use of  .htaccess files, then Etomite becomes even more SEO Friendly (Search  Engine Optimized), by allowing what we would call friendly urls - no  more question marks in the URL (Universal Resource Locater), but  virtual page names.</p>\r\n\r\n<p><strong>Is it possible to AJAX-ify the Content?</strong><br />Of  Course! Whatever you can do with content, you can do with Etomite.  Whether this be making AJAX Menus, or making some fancy effects within  the content, you can do it within Etomite. The only limit is your  imagination, and the amount of time you have to put in the work.  Etomite is the number one CMS Suitable for AJAX.</p>\r\n\r\n<p><strong>What is a CMS?</strong><br />In  the context of a Web site a CMS is a collection of tools designed to  allow the creation, modification organisation and removal of  information from a Web site. It is common for a CMS to require users to  have no knowledge of HTML in order to create new Web pages.</p>\r\n\r\n<p><strong>How much Does Etomite Cost?</strong><br />Etomite is OpenSource (GPL), which makes it free to use.</p>\r\n\r\n\r\n', '\r\n\r\nWhat is Etomite?\r\n###########################\r\n\r\nEtomite is a Content Management  System, which allows you to remotely administer your website from  anywhere that you have an Internet Connection and a compatible  Web-Browser.\r\n\r\nWhat makes Etomite Different?\r\n##########################\r\n\r\nEtomite  is completely different in many ways - it allows the end user to  control virtually every aspect of their website, whether it be from  layout to how the Meta Tags are generated, making it the number one SEO  CMS.<br />If you are running Apache, and your host allows the use of  .htaccess files, then Etomite becomes even more SEO Friendly (Search  Engine Optimized), by allowing what we would call friendly urls - no  more question marks in the URL (Universal Resource Locater), but  virtual page names.\r\n\r\nIs it possible to AJAX-ify the Content?\r\n###########################\r\n\r\nOf  Course! Whatever you can do with content, you can do with Etomite.  Whether this be making AJAX Menus, or making some fancy effects within  the content, you can do it within Etomite. The only limit is your  imagination, and the amount of time you have to put in the work.  Etomite is the number one CMS Suitable for AJAX.\r\n\r\nWhat is a CMS?\r\n#########################\r\n\r\nIn  the context of a Web site a CMS is a collection of tools designed to  allow the creation, modification organisation and removal of  information from a Web site. It is common for a CMS to require users to  have no knowledge of HTML in order to create new Web pages.\r\n\r\nHow much Does Etomite Cost?\r\n#####################################\r\n\r\nEtomite is OpenSource (GPL), which makes it free to use.\r\n\r\n\r\n', 1, 1, 0, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(27, 'document', 'text/html', 'Chunks', 'Chunk Resources', 'Chunks are internal HTML or Javascript code for use throughout your Etomite site.', 'chunks', 1, 0, 0, 20, 1, '\r\n<p> Chunks are blocks of HTML. This way you can write whole blocks of HTML code without  cluttering up your templates with HTML you''d rather keep separate.  Using the multiple pass processing, you can decide which Chunks should  be included in the page using snippets. They can only contain  HTML unless embedded PHP has been enabled within the Etomite  configuration panel, in which case PHP can be intermingled within the  HTML markup.</p>\r\n\r\n<p>Chunks are also useful for storing blocks of HTML that you want to  include in a snippet. This allows customisation of a snippet''s  presentation&nbsp; without having to modify the snippet code, allowing  snippet users (rather than authors) more scope for modifying the output  to their needs.</p>\r\n\r\n<p>Of course HTML can also contain javascript, so you can store your  javascript in a chunk too. Much easier than trying to write a piece of  javascript in the middle of a piece of PHP code, and making sure all  your quotes correctly match and have the effect you want. (It also  allows you to include the javascript while developing and testing, and  then move the actual script to an include once it all works.)<br /></p>\r\n<p>\r\n\r\nYou can read more about <a href="http://docs.etomite.com/development-chunks.html" target="_blank">Chunks</a> on the documentation site.</p>', '\r\nChunks are blocks of HTML. This way you can write whole blocks of HTML code without  cluttering up your templates with HTML you''d rather keep separate.  Using the multiple pass processing, you can decide which Chunks should  be included in the page using snippets. They can only contain  HTML unless embedded PHP has been enabled within the Etomite  configuration panel, in which case PHP can be intermingled within the  HTML markup.\r\n\r\nChunks are also useful for storing blocks of HTML that you want to  include in a snippet. This allows customisation of a snippet''s  presentation&nbsp; without having to modify the snippet code, allowing  snippet users (rather than authors) more scope for modifying the output  to their needs.</p>\r\n\r\n<p>Of course HTML can also contain javascript, so you can store your  javascript in a chunk too. Much easier than trying to write a piece of  javascript in the middle of a piece of PHP code, and making sure all  your quotes correctly match and have the effect you want. (It also  allows you to include the javascript while developing and testing, and  then move the actual script to an include once it all works.)\r\n\r\n\r\nYou can read more about <a href="http://docs.etomite.com/development-chunks.html" target="_blank">Chunks</a> on the documentation site.\r\n\r\n', 1, 1, 3, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(28, 'document', 'text/html', 'System Tags', 'System Variable Tags', 'These system tags can be useful throughout your site.', 'system-tags', 1, 0, 0, 20, 0, '\r\n\r\n<p>System tags contain Etomite configuration settings, which can be helpful at times, and can be used several different ways. Using the proper method at the proper time it is possible to either display the contents of a setting or to access it from within snippet code to make logic decisions.</p>\r\nSeveral of the tags can come in handy when creating documents for your site. For this mode of use you would wrap the setting name within opening [ ( and closing ) ] system variable tags. As an example, [ (site_name) ] would display <span style="font-weight: bold;">"[(site_name)]"</span> in place of the tag. These settings are also available for use within Snippets by using a call similar to <span style="font-weight: bold;">$etomite-&gt;config[''site_name'']</span> to access a specific variable. The list below has been abbreviated by excluding WYSIWYG editor specific settings and is subject to change without notice.<br /><br />\r\n<table class="varList"><caption style="font-weight: bold;">Etomite Configuration Settings</caption>\r\n<tbody>\r\n<tr>\r\n<th>Configuration Setting </th>\r\n\r\n<th>Description </th>\r\n</tr>\r\n<tr>\r\n<td> absolute_base_path </td>\r\n<td>Installation path calculated from the server root.<br /> </td></tr>\r\n<tr>\r\n<td> relative_base_path </td>\r\n<td> Installation path calculated from the working directory. </td></tr>\r\n<tr>\r\n<td> www_base_path </td>\r\n<td>Installation URL path to the working directory.<br /> </td></tr>\r\n<tr>\r\n<td> settings_version </td>\r\n<td> 1.0 : Currently installed version number.<br /> </td></tr>\r\n<tr>\r\n<td> date_format </td>\r\n<td> %Y-%m-%d : strftime() Date format string.<br /> </td></tr>\r\n<tr>\r\n<td> time_format </td> \r\n<td> %I:%M %p : strftime() Time format string. </td></tr>\r\n<tr>\r\n<td> server_offset_time </td>\r\n<td> 0 : Time offset between server and local times in +/-.<br /> </td></tr>\r\n<tr> \r\n<td> server_protocol </td>\r\n<td> http : Server protocol can be http or https.<br /> </td></tr>\r\n<tr>\r\n<td> manager_language </td>\r\n<td> english : The deafult manager language.<br /> </td></tr>\r\n<tr>\r\n<td> etomite_charset </td>\r\n<td> iso-8859-1 : The default character set.<br /> </td></tr>\r\n<tr>\r\n<td> site_name </td>\r\n<td> My Etomite Site : The name/title of your site.<br /> </td></tr>\r\n<tr>\r\n<td> site_start </td>\r\n<td> 1 : The id of the document where your site starts.<br /> </td></tr>\r\n<tr>\r\n<td> error_page </td>\r\n<td> 3 : The id of the 404 error page document.<br /> </td></tr>\r\n<tr>\r\n<td> site_status </td>\r\n<td> 1 : 0=offline | 1=online<br /> </td></tr>\r\n<tr>\r\n<td> site_unavailable_message </td>\r\n<td> Message to display, or script to run, when the site is offline.<br /> </td></tr>\r\n<tr>\r\n<td> track_visitors </td>\r\n<td> 0 : 0=don''t log visitors | 1=log visitors<br /> </td></tr>\r\n<tr>\r\n<td> resolve_hostnames </td>\r\n<td> 1 : Resolve hostnames rather than simply storing host IP in logs. 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> top_howmany </td>\r\n<td> 10 : The number of entries to display in statistics reporting.<br /> </td></tr>\r\n<tr>\r\n<td> default_template </td>\r\n<td> 3 : Default template pre-selected when creating new documents.<br /> </td></tr>\r\n<tr>\r\n<td> publish_default </td>\r\n<td> 1 : Default published status. 0=un-published | 1=published<br /> </td></tr>\r\n<tr>\r\n<td> search_default </td>\r\n<td> 1 : Default searchable status. 0=don''t include  1=include<br /></td></tr>\r\n<tr>\r\n<td> cache_default </td>\r\n<td> 1 : Default cacheable status. 0=non-cacheable | 1=cacheable<br /> </td></tr>\r\n<tr>\r\n<td> syncsitecheck_default </td>\r\n<td> 1 : Default site synchronization setting for documents. 0=no sync | 1=sync<br /> </td></tr>\r\n<tr>\r\n<td> showinmenu_default </td>\r\n<td> 0 : Whether a document should have a menu item created. 0=Hide | 1=Show<br /> </td></tr>\r\n<tr>\r\n<td> friendly_urls </td>\r\n<td> 0 : Enable Friendly URL''s. 0=Disabled | 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> friendly_url_prefix </td>\r\n<td>&nbsp;: FURL prefix to prepend onto document id''s<br /></td></tr>\r\n<tr>\r\n<td> friendly_url_suffix </td>\r\n<td> .html : FURL suffix to append onto document id''s<br /> </td></tr>\r\n<tr>\r\n<td> friendly_alias_urls </td>\r\n<td> 0 : Enable Friendly Aliases. 0=Disabled | 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> use_udperms </td>\r\n<td> 0 : Use user document/group permissions. 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> use_uvperms </td>\r\n<td> 0 : Use visitor document/group permissions. 0=No 1=Yes </td></tr>\r\n<tr>\r\n<td> access_denied_message </td>\r\n<td>Default access denied message to display for permissions violations.<br /></td></tr>\r\n<tr>\r\n<td> udperms_allowroot </td> \r\n<td> 0 : Should users be able to create documents in the doc root? 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> use_mgr_logging </td>\r\n<td> 0 : Should a manager audit trail be kept? 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> max_attempts </td>\r\n<td> 3 : Maximum login attempts before the account is blocked.<br /> </td></tr>\r\n<tr>\r\n<td> use_captcha </td>\r\n<td> 0 : Require CAPTCHA code authentication for manager logins? 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> captcha_words </td> \r\n<td>Comma delimited list of words to be used for CAPTCHA authentication.<br /></td></tr>\r\n<tr>\r\n<td> signupemail_message </td>\r\n<td>The message which is used to send new user login details.<br /></td></tr>\r\n<tr>\r\n<td> emailsender </td>\r\n<td>The From email address for emails.<br /> </td></tr>\r\n<tr>\r\n<td> emailsubject </td>\r\n<td>The system email Subject line.<br /> </td></tr>\r\n<tr>\r\n<td> number_of_logs </td>\r\n<td> 100 : Default number of log entries to display per page.<br /> </td></tr>\r\n<tr>\r\n<td> number_of_messages </td>\r\n<td> 30 : Default number of internal mesages to display per page.<br /> </td></tr>\r\n<tr>\r\n<td> show_doc_data_preview </td> \r\n<td> 1 : Controls status of document previews. 0=Disabled 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> use_doc_editor </td>\r\n<td> 1 : Controls whether a WYSIWYG editor can be used. 0=Disabled 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> which_editor </td>\r\n<td> 5 : Index of the WYSIWYG editor to use.<br /> </td></tr>\r\n<tr>\r\n<td> use_code_editor </td>\r\n<td> 1 : Controls whether EditArea can be used for HTML mode editing. 0=Disabled 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> code_highlight </td> \r\n<td> 0 : Controls whether EditAre should use code highlighting<br /> </td></tr> \r\n<tr>\r\n<td> strip_image_paths </td>\r\n<td> 0 : Controls whether absolute paths should be converted to relative paths.<br /> </td></tr>\r\n<tr>\r\n<td> filemanager_path </td> \r\n<td>Default root for the file manager.<br /> </td></tr>\r\n<tr>\r\n<td> upload_files </td>\r\n<td>Comma delimited list of allowable upload file types.<br /></td></tr>\r\n<tr>\r\n<td> inlineview_files </td>\r\n<td>Comma delimited list of allowable inline viewable (code view) file types for the file manager.<br /> </td></tr>\r\n<tr>\r\n<td> view_files </td>\r\n<td>Comma delimited list of viewable (image view) file types for the file manager.<br /> </td></tr>\r\n<tr>\r\n<td> edit_files </td>\r\n<td>Comma delimited list of file types which can be edited from within the file manager. <br /></td></tr>\r\n<tr>\r\n<td> exclude_paths </td>\r\n<td>Comma delimited list of file paths to exclude from the file manager<br /></td></tr>\r\n<tr>\r\n<td> maxuploadsize </td>\r\n<td> Maximum upload file size for the file manager <br /></td></tr>\r\n<tr>\r\n<td> manager_layout </td>\r\n<td> 1 : Frame based or IE drop-down based manager main menu.<br /> </td></tr>\r\n<tr>\r\n<td> release </td>\r\n<td> 1.0 : Current software release number.<br /> </td></tr>\r\n<tr>\r\n<td> patch_level </td>\r\n<td> .0 : Current software release patch level.<br /> </td></tr>\r\n<tr>\r\n<td> code_name </td>\r\n<td> Prelude : Current release branch code name.<br /> </td></tr>\r\n<tr>\r\n<td> full_appname </td>\r\n<td> Etomite Content Management System 1.0 (Prelude) </td></tr>\r\n<tr>\r\n<td> small_version </td>\r\n<td> 1 : Small version of the release number.<br /> </td></tr>\r\n<tr>\r\n<td> slogan </td>\r\n<td> Fast, Free, Infinitely Flexible : The current software release slogan.<br /> </td></tr></tbody></table><br />\r\n<table class="varList"><caption style="font-weight: bold;">Etomite Parser Results</caption>\r\n<tbody>\r\n<tr>\r\n<th>Tag</th>\r\n   \r\n<th>Description</th>\r\n</tr>\r\n<tr>\r\n<td>[ ^q^ ]</td>\r\n<td>Number of queries run</td></tr>\r\n<tr>\r\n<td>[ ^qt^ ]</td>\r\n<td>Total query time for page</td></tr>\r\n<tr>\r\n<td>[ ^p^ ]</td>\r\n<td>Total PHP time for page</td></tr>\r\n<tr>\r\n<td>[ ^t^ ]</td>\r\n<td>Total time to render page</td></tr>\r\n<tr>\r\n<td>[ ^s^ ]</td>\r\n<td>Document source - cache or database</td></tr></tbody></table>\r\n\r\n', '\r\n\r\n<p>System tags contain Etomite configuration settings, which can be helpful at times, and can be used several different ways. Using the proper method at the proper time it is possible to either display the contents of a setting or to access it from within snippet code to make logic decisions.</p>\r\nSeveral of the tags can come in handy when creating documents for your site. For this mode of use you would wrap the setting name within opening [ ( and closing ) ] system variable tags. As an example, [ (site_name) ] would display <span style="font-weight: bold;">"[(site_name)]"</span> in place of the tag. These settings are also available for use within Snippets by using a call similar to <span style="font-weight: bold;">$etomite-&gt;config[''site_name'']</span> to access a specific variable. The list below has been abbreviated by excluding WYSIWYG editor specific settings and is subject to change without notice.<br /><br />\r\n<table class="varList"><caption style="font-weight: bold;">Etomite Configuration Settings</caption>\r\n<tbody>\r\n<tr>\r\n<th>Configuration Setting </th>\r\n\r\n<th>Description </th>\r\n</tr>\r\n<tr>\r\n<td> absolute_base_path </td>\r\n<td>Installation path calculated from the server root.<br /> </td></tr>\r\n<tr>\r\n<td> relative_base_path </td>\r\n<td> Installation path calculated from the working directory. </td></tr>\r\n<tr>\r\n<td> www_base_path </td>\r\n<td>Installation URL path to the working directory.<br /> </td></tr>\r\n<tr>\r\n<td> settings_version </td>\r\n<td> 1.0 : Currently installed version number.<br /> </td></tr>\r\n<tr>\r\n<td> date_format </td>\r\n<td> %Y-%m-%d : strftime() Date format string.<br /> </td></tr>\r\n<tr>\r\n<td> time_format </td> \r\n<td> %I:%M %p : strftime() Time format string. </td></tr>\r\n<tr>\r\n<td> server_offset_time </td>\r\n<td> 0 : Time offset between server and local times in +/-.<br /> </td></tr>\r\n<tr> \r\n<td> server_protocol </td>\r\n<td> http : Server protocol can be http or https.<br /> </td></tr>\r\n<tr>\r\n<td> manager_language </td>\r\n<td> english : The deafult manager language.<br /> </td></tr>\r\n<tr>\r\n<td> etomite_charset </td>\r\n<td> iso-8859-1 : The default character set.<br /> </td></tr>\r\n<tr>\r\n<td> site_name </td>\r\n<td> My Etomite Site : The name/title of your site.<br /> </td></tr>\r\n<tr>\r\n<td> site_start </td>\r\n<td> 1 : The id of the document where your site starts.<br /> </td></tr>\r\n<tr>\r\n<td> error_page </td>\r\n<td> 3 : The id of the 404 error page document.<br /> </td></tr>\r\n<tr>\r\n<td> site_status </td>\r\n<td> 1 : 0=offline | 1=online<br /> </td></tr>\r\n<tr>\r\n<td> site_unavailable_message </td>\r\n<td> Message to display, or script to run, when the site is offline.<br /> </td></tr>\r\n<tr>\r\n<td> track_visitors </td>\r\n<td> 0 : 0=don''t log visitors | 1=log visitors<br /> </td></tr>\r\n<tr>\r\n<td> resolve_hostnames </td>\r\n<td> 1 : Resolve hostnames rather than simply storing host IP in logs. 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> top_howmany </td>\r\n<td> 10 : The number of entries to display in statistics reporting.<br /> </td></tr>\r\n<tr>\r\n<td> default_template </td>\r\n<td> 3 : Default template pre-selected when creating new documents.<br /> </td></tr>\r\n<tr>\r\n<td> publish_default </td>\r\n<td> 1 : Default published status. 0=un-published | 1=published<br /> </td></tr>\r\n<tr>\r\n<td> search_default </td>\r\n<td> 1 : Default searchable status. 0=don''t include  1=include<br /></td></tr>\r\n<tr>\r\n<td> cache_default </td>\r\n<td> 1 : Default cacheable status. 0=non-cacheable | 1=cacheable<br /> </td></tr>\r\n<tr>\r\n<td> syncsitecheck_default </td>\r\n<td> 1 : Default site synchronization setting for documents. 0=no sync | 1=sync<br /> </td></tr>\r\n<tr>\r\n<td> showinmenu_default </td>\r\n<td> 0 : Whether a document should have a menu item created. 0=Hide | 1=Show<br /> </td></tr>\r\n<tr>\r\n<td> friendly_urls </td>\r\n<td> 0 : Enable Friendly URL''s. 0=Disabled | 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> friendly_url_prefix </td>\r\n<td>&nbsp;: FURL prefix to prepend onto document id''s<br /></td></tr>\r\n<tr>\r\n<td> friendly_url_suffix </td>\r\n<td> .html : FURL suffix to append onto document id''s<br /> </td></tr>\r\n<tr>\r\n<td> friendly_alias_urls </td>\r\n<td> 0 : Enable Friendly Aliases. 0=Disabled | 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> use_udperms </td>\r\n<td> 0 : Use user document/group permissions. 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> use_uvperms </td>\r\n<td> 0 : Use visitor document/group permissions. 0=No 1=Yes </td></tr>\r\n<tr>\r\n<td> access_denied_message </td>\r\n<td>Default access denied message to display for permissions violations.<br /></td></tr>\r\n<tr>\r\n<td> udperms_allowroot </td> \r\n<td> 0 : Should users be able to create documents in the doc root? 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> use_mgr_logging </td>\r\n<td> 0 : Should a manager audit trail be kept? 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> max_attempts </td>\r\n<td> 3 : Maximum login attempts before the account is blocked.<br /> </td></tr>\r\n<tr>\r\n<td> use_captcha </td>\r\n<td> 0 : Require CAPTCHA code authentication for manager logins? 0=No 1=Yes<br /> </td></tr>\r\n<tr>\r\n<td> captcha_words </td> \r\n<td>Comma delimited list of words to be used for CAPTCHA authentication.<br /></td></tr>\r\n<tr>\r\n<td> signupemail_message </td>\r\n<td>The message which is used to send new user login details.<br /></td></tr>\r\n<tr>\r\n<td> emailsender </td>\r\n<td>The From email address for emails.<br /> </td></tr>\r\n<tr>\r\n<td> emailsubject </td>\r\n<td>The system email Subject line.<br /> </td></tr>\r\n<tr>\r\n<td> number_of_logs </td>\r\n<td> 100 : Default number of log entries to display per page.<br /> </td></tr>\r\n<tr>\r\n<td> number_of_messages </td>\r\n<td> 30 : Default number of internal mesages to display per page.<br /> </td></tr>\r\n<tr>\r\n<td> show_doc_data_preview </td> \r\n<td> 1 : Controls status of document previews. 0=Disabled 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> use_doc_editor </td>\r\n<td> 1 : Controls whether a WYSIWYG editor can be used. 0=Disabled 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> which_editor </td>\r\n<td> 5 : Index of the WYSIWYG editor to use.<br /> </td></tr>\r\n<tr>\r\n<td> use_code_editor </td>\r\n<td> 1 : Controls whether EditArea can be used for HTML mode editing. 0=Disabled 1=Enabled<br /> </td></tr>\r\n<tr>\r\n<td> code_highlight </td> \r\n<td> 0 : Controls whether EditAre should use code highlighting<br /> </td></tr> \r\n<tr>\r\n<td> strip_image_paths </td>\r\n<td> 0 : Controls whether absolute paths should be converted to relative paths.<br /> </td></tr>\r\n<tr>\r\n<td> filemanager_path </td> \r\n<td>Default root for the file manager.<br /> </td></tr>\r\n<tr>\r\n<td> upload_files </td>\r\n<td>Comma delimited list of allowable upload file types.<br /></td></tr>\r\n<tr>\r\n<td> inlineview_files </td>\r\n<td>Comma delimited list of allowable inline viewable (code view) file types for the file manager.<br /> </td></tr>\r\n<tr>\r\n<td> view_files </td>\r\n<td>Comma delimited list of viewable (image view) file types for the file manager.<br /> </td></tr>\r\n<tr>\r\n<td> edit_files </td>\r\n<td>Comma delimited list of file types which can be edited from within the file manager. <br /></td></tr>\r\n<tr>\r\n<td> exclude_paths </td>\r\n<td>Comma delimited list of file paths to exclude from the file manager<br /></td></tr>\r\n<tr>\r\n<td> maxuploadsize </td>\r\n<td> Maximum upload file size for the file manager <br /></td></tr>\r\n<tr>\r\n<td> manager_layout </td>\r\n<td> 1 : Frame based or IE drop-down based manager main menu.<br /> </td></tr>\r\n<tr>\r\n<td> release </td>\r\n<td> 1.0 : Current software release number.<br /> </td></tr>\r\n<tr>\r\n<td> patch_level </td>\r\n<td> .0 : Current software release patch level.<br /> </td></tr>\r\n<tr>\r\n<td> code_name </td>\r\n<td> Prelude : Current release branch code name.<br /> </td></tr>\r\n<tr>\r\n<td> full_appname </td>\r\n<td> Etomite Content Management System 1.0 (Prelude) </td></tr>\r\n<tr>\r\n<td> small_version </td>\r\n<td> 1 : Small version of the release number.<br /> </td></tr>\r\n<tr>\r\n<td> slogan </td>\r\n<td> Fast, Free, Infinitely Flexible : The current software release slogan.<br /> </td></tr></tbody></table><br />\r\n<table class="varList"><caption style="font-weight: bold;">Etomite Parser Results</caption>\r\n<tbody>\r\n<tr>\r\n<th>Tag</th>\r\n   \r\n<th>Description</th>\r\n</tr>\r\n<tr>\r\n<td>[ ^q^ ]</td>\r\n<td>Number of queries run</td></tr>\r\n<tr>\r\n<td>[ ^qt^ ]</td>\r\n<td>Total query time for page</td></tr>\r\n<tr>\r\n<td>[ ^p^ ]</td>\r\n<td>Total PHP time for page</td></tr>\r\n<tr>\r\n<td>[ ^t^ ]</td>\r\n<td>Total time to render page</td></tr>\r\n<tr>\r\n<td>[ ^s^ ]</td>\r\n<td>Document source - cache or database</td></tr></tbody></table>\r\n\r\n', 1, 1, 6, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(29, 'document', 'text/html', 'DateTime', 'DateTime Snippet Example', '', '', 1, 0, 0, 31, 0, '<p>This document last edited: [!DateTime?timestamp=[*editedon*]!]</p>\r\n<p>The current date and time: [!DateTime!]</p>\r\n[!DisplayCode?type=snippet&name=DateTime!]\r\n', 'This document last edited: [!DateTime?timestamp=[*editedon*]!]\r\n\r\nThe current date and time: [!DateTime!]\r\n[!DisplayCode?type=snippet&name=DateTime!]\r\n\r\n', 0, 1, 0, 1, 0, 2, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(30, 'document', 'text/html', 'sideBanner2', 'Second sideBanner', 'This document is intended to be displayed by the getSideBar snippet.', 'sideBanner2', 0, 0, 0, 20, 0, '<p>This is another sideBanner which is being displayed by the <span style="font-weight: bold;">getSideBar</span> snippet. The longtitle field is being displayed as the header for this entry.</p> <div style="text-align: center;"><img src="assets/images/button-eto.png" /></div>\r\n', 'This is another sideBanner which is being displayed by the **getSideBar** snippet. The longtitle field is being displayed as the header for this entry.\r\n\r\n [* assets/images/button-eto.png *]\r\n', 1, 1, 1, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(31, 'document', 'text/html', 'Snippets', 'Snippet Resources', 'Snippets are internal PHP scripts that extend the functionality of Etomite.', 'snippets', 1, 0, 0, 20, 1, '\r\n<p>Snippets are actually Etomite-specific PHP scripts which can be used to extend&nbsp; its capabilities. Snippets might only contain one or several lines of code which perform a simple task, or they can be hundreds or even thousands of lines long and perform complex data management tasks. Your needs and creativity is the only limiting factor.</p>\r\n<p>\r\n  The Etomite API provides many class functions which can be used to speed your productivity. Although it is possible to hand code every component of your snippets from scratch it is best to become familiar with the available API functions and their use as not only do thay make your programming task eaiser but they also help with error handling and debugging.</p>\r\n\r\n<p>You can learn more about <a href="http://docs.etomite.com/development-snippets.html" target="_blank">Snippets</a> on the documentation site.</p>\r\n  <br />\r\n\r\n', '\r\nSnippets are actually Etomite-specific PHP scripts which can be used to extend&nbsp; its capabilities. Snippets might only contain one or several lines of code which perform a simple task, or they can be hundreds or even thousands of lines long and perform complex data management tasks. Your needs and creativity is the only limiting factor.</p>\r\n<p>\r\n  The Etomite API provides many class functions which can be used to speed your productivity. Although it is possible to hand code every component of your snippets from scratch it is best to become familiar with the available API functions and their use as not only do thay make your programming task eaiser but they also help with error handling and debugging.\r\n\r\nYou can learn more about <a href="http://docs.etomite.com/development-snippets.html" target="_blank">Snippets</a> on the documentation site.\r\n  \r\n\r\n', 1, 1, 4, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(32, 'document', 'text/html', 'sideBanner', '', 'sideBanner for the Resources section', '', 0, 0, 0, 20, 0, '<p>This section gives an overview of the different resource components that are available to the Etomite developer. Each type of resource can be used several ways, depending on when and where it is being used.</p>\r\n', 'This section gives an overview of the different resource components that are available to the Etomite developer. Each type of resource can be used several ways, depending on when and where it is being used.\r\n', 0, 1, 2, 0, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 0);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(33, 'document', 'text/html', 'Links', 'Links to other sites', 'Links to various external resources', 'links', 1, 0, 0, 0, 1, '\r\n\r\n<p>The links in the left menu, which are child-documents of this folder-document, will redirect a visitor to external sites. They are considered WebLink content resources within the Etomite manager and can be utilized in much the same manner as documents.<br /></p>\r\n<br />\r\n\r\n', '\r\n\r\nThe links in the left menu, which are child-documents of this folder-document, will redirect a visitor to external sites. They are considered WebLink content resources within the Etomite manager and can be utilized in much the same manner as documents.\r\n\r\n\r\n', 1, 1, 4, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(34, 'document', 'text/html', 'HTML Example', 'Chunk example using HTML markup', 'Displays links to W3C code validators and displays the Chunk source.', 'chunk-html-example', 1, 0, 0, 27, 0, '\r\n\r\n<p>The images below, validation links, are an example of a Chunk. The chunks HTML markup is displayed below the images/links. The chunk call to render thsi output is:&nbsp; <span style="font-weight: bold;">{ {W3C Validation} }</span></p>\r\n{{W3C Validation}}<span style="text-decoration: underline;"><br /></span><span style="width: 200px;"><span style="text-decoration: underline;"></span></span>[!DisplayCode?type=chunk&name=W3C Validation!]<br />\r\n\r\n', '\r\n\r\nThe images below, validation links, are an example of a Chunk. The chunks HTML markup is displayed below the images/links. The chunk call to render thsi output is:&nbsp; <span style="font-weight: bold;">{ {W3C Validation} }</span>\r\n\r\n{{W3C Validation}}<span style="text-decoration: underline;"><br /></span><span style="width: 200px;"><span style="text-decoration: underline;"></span></span>[!DisplayCode?type=chunk&name=W3C Validation!]\r\n\r\n', 1, 1, 0, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(35, 'document', 'text/html', 'Javascript Example', 'Chunk example using Javascript', 'This document shows a small Javascript example as well as the Chunk code.', 'chunk-javascript-example', 1, 0, 0, 27, 0, '\r\n<p>The text below is the actual description for this document and was rendered by Javascript stored as a Chunk. The chunk call to render this output is: <span style="font-weight: bold;">{ {Javascript Example} }</span></p>\r\n\r\n<p><span style="font-weight: bold;">Document Description:</span> <span style="font-style: italic;">{{Javascript Example}}</span></p>\r\n   <span style="width: 200px;"><span style="text-decoration: underline;"></span></span>[!DisplayCode?type=chunk&name=Javascript Example!]<br />\r\n\r\n', '\r\n<p>The text below is the actual description for this document and was rendered by Javascript stored as a Chunk. The chunk call to render this output is: <span style="font-weight: bold;">{ {Javascript Example} }</span></p>\r\n\r\n<p><span style="font-weight: bold;">Document Description:</span> <span style="font-style: italic;">{{Javascript Example}}</span></p>\r\n   <span style="width: 200px;"><span style="text-decoration: underline;"></span></span>[!DisplayCode?type=chunk&name=Javascript Example!]<br />\r\n\r\n', 1, 1, 0, 1, 1, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(36, 'document', 'text/html', 'FixInertTags', 'Chunk example using Javascript in the page template.', 'This example demonstrates how Javascripts can be embedded in the page template using a Chunk.', 'fix-inert-tags', 1, 0, 0, 27, 0, '\r\n<div id="test">\r\n<p> </p>\r\n\r\n<p>The variable tags below are explained elsewhere within the resources documentation. The tags are being displayed instead of being processed by the Etomite parser because blank spaces have been entered between each of the opening and closing tag pair characters. The reason the spaces don''t appear is due to the Javascript listed immediately below them. The chunk call for this code is located at the bottom of the page template,&nbsp; just above the closing <span style="font-weight: bold;">body</span> tag, and it looks like: <span style="font-weight: bold;">{ {FixInertTags} }</span></p>\r\n\r\n<div style="text-align: center;"><span style="width: 200px;"><span style="text-decoration: underline;"></span></span>[ [cacheable_snippet] ]<br />[ !non-cacheable_snippet! ]<br />[ (system_setting_tag) ]<br />[ *document_object_tag* ]<br />{ !parseChunk_tag! }<br /></div><br /> [!DisplayCode?type=chunk&name=FixInertTags!]<br /></div>\r\n\r\n', '\r\n<div id="test">\r\n<p> </p>\r\n\r\n<p>The variable tags below are explained elsewhere within the resources documentation. The tags are being displayed instead of being processed by the Etomite parser because blank spaces have been entered between each of the opening and closing tag pair characters. The reason the spaces don''t appear is due to the Javascript listed immediately below them. The chunk call for this code is located at the bottom of the page template,&nbsp; just above the closing <span style="font-weight: bold;">body</span> tag, and it looks like: <span style="font-weight: bold;">{ {FixInertTags} }</span></p>\r\n\r\n<div style="text-align: center;"><span style="width: 200px;"><span style="text-decoration: underline;"></span></span>[ [cacheable_snippet] ]<br />[ !non-cacheable_snippet! ]<br />[ (system_setting_tag) ]<br />[ *document_object_tag* ]<br />{ !parseChunk_tag! }<br /></div><br /> [!DisplayCode?type=chunk&name=FixInertTags!]<br /></div>\r\n\r\n', 1, 1, 0, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(37, 'reference', 'text/html', 'Etomite Documentation', ' Etomite Documentation Homepage', 'Leran more about how to get the most out of the Etomite CMS.', 'etomite-documentation', 1, 0, 0, 33, 0, 'http://docs.etomite.com/', 'http://docs.etomite.com/', 0, 0, 0, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(38, 'reference', 'text/html', 'Etomite Homepage', 'www.etomite.com', 'This link points to the main Etomite CMS Project website.', 'etomite-home', 1, 0, 0, 33, 0, 'http://www.etomite.com', 'http://www.etomite.com', 0, 0, 0, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(39, 'document', 'text/html', 'Templates', 'Page templates provide site layout structure.', 'This is a brief overview of template resources.', 'templates', 1, 0, 0, 20, 0, '\r\n\r\n<p>Templates provide the overall page layout structure for your site. You can use as many different templates as you need to provide the proper layout structure for each section of your site, or you can use a single template for the entire site. The listing below is the HTML markup for the template being used for this default installation.</p>\r\n\r\n<p>You can learn more about <a href="http://docs.etomite.com/development-templates.html">Templates</a> on the documentation site.</p>\r\n\r\n<p>As you preview the template markup you will notice that all resources have been disabled by inserting a blank space within the opening tags. This has been done so that those resource calls are not processed. The actual template code does not contain these extra spaces.</p>\r\n  [!DisplayCode?type=template&name=Etomite v1.0!]<br /> \r\n\r\n', '\r\n\r\n<p>Templates provide the overall page layout structure for your site. You can use as many different templates as you need to provide the proper layout structure for each section of your site, or you can use a single template for the entire site. The listing below is the HTML markup for the template being used for this default installation.</p>\r\n\r\n<p>You can learn more about <a href="http://docs.etomite.com/development-templates.html">Templates</a> on the documentation site.</p>\r\n\r\n<p>As you preview the template markup you will notice that all resources have been disabled by inserting a blank space within the opening tags. This has been done so that those resource calls are not processed. The actual template code does not contain these extra spaces.</p>\r\n  [!DisplayCode?type=template&name=Etomite v1.0!]<br /> \r\n\r\n', 1, 1, 2, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` (`id`, `type`, `contentType`, `pagetitle`, `longtitle`, `description`, `alias`, `published`, `pub_date`, `unpub_date`, `parent`, `isfolder`, `content`, `texy`, `richtext`, `template`, `menuindex`, `searchable`, `cacheable`, `createdby`, `createdon`, `editedby`, `editedon`, `deleted`, `deletedon`, `deletedby`, `authenticate`, `showinmenu`) VALUES(40, 'document', 'text/html', 'API Functions', 'Application Programming Interface Functions', 'The Etomite API gives developers the power they need to create customized applications within Etomite.', 'api-functions', 1, 0, 0, 20, 0, '\r\n\r\n<p>The Application Programming Interface (API) provides many Etomite class functions which make programming within Etomite a whole lot easier. If you are familiar with PHP, and want to create custom snippets, then becoming familiar with the API will be of great benefit to your programming endeavors. If you have already checked out the Snippets section then you may have  already noticed some of the Etomite class API functions already... All of the API function calls are written in a format similar to:</p>\r\n\r\n<p><span style="font-weight: bold;">$result = $etomite-&gt;functionName($param1, $param2, etc.);</span><br /></p>\r\n\r\n<p>We won''t go into a long  list of the functions here, this is just a good place to inform you of the API and to provide a link to the <a href="http://docs.etomite.com/development-apifunctions.html" target="_blank">API Functions</a> section of the documentation site. While this section of the documentation is in need of some major improvement, it is a good starting place.</p>\r\n<br />\r\n\r\n', '\r\n\r\n<p>The Application Programming Interface (API) provides many Etomite class functions which make programming within Etomite a whole lot easier. If you are familiar with PHP, and want to create custom snippets, then becoming familiar with the API will be of great benefit to your programming endeavors. If you have already checked out the Snippets section then you may have  already noticed some of the Etomite class API functions already... All of the API function calls are written in a format similar to:</p>\r\n\r\n<p><span style="font-weight: bold;">$result = $etomite-&gt;functionName($param1, $param2, etc.);</span><br /></p>\r\n\r\n<p>We won''t go into a long  list of the functions here, this is just a good place to inform you of the API and to provide a link to the <a href="http://docs.etomite.com/development-apifunctions.html" target="_blank">API Functions</a> section of the documentation site. While this section of the documentation is in need of some major improvement, it is a good starting place.</p>\r\n<br />\r\n\r\n', 1, 1, 7, 1, 0, 1, {TIMESTAMP}, 1, {TIMESTAMP}, 0, 0, 0, 0, 1);

-- END::INSERT site_content DATA


-- START::INSERT site_htmlsnippets DATA

INSERT INTO `{PREFIX}site_htmlsnippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(1, 'W3C Validation', 'Displays W3C Markup Validation Service Icon/Link', '<p class="textcenter">\r\n    <a href="http://validator.w3.org/check?uri=referer"\r\n        onclick="window.open(''http://validator.w3.org/check?uri=referer''); return false;"><img\r\n        src="http://www.w3.org/Icons/valid-xhtml10"\r\n        alt="Valid XHTML 1.0 Strict" height="31" width="88" />\r\n    </a>\r\n    <a href="http://jigsaw.w3.org/css-validator/check/referer"\r\n        onclick="window.open(''http://jigsaw.w3.org/css-validator/check/referer''); return false;">\r\n        <img style="border:0;width:88px;height:31px"\r\n            src="http://jigsaw.w3.org/css-validator/images/vcss"\r\n            alt="Valid CSS!" />\r\n    </a>\r\n</p>', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(2, 'Javascript Example', '', '<span id="JSExample"></span>\r\n\r\n<script type="text/javascript">\r\n<!--\r\n  document.getElementById(''JSExample'').innerHTML = "[*description*]";\r\n//-->\r\n</script>\r\n', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(3, 'FixInertTags', 'Fixes inert tag appearance for documentation purposes.', '<script type="text/javascript">\r\n<!--\r\n\r\nfunction FixInertTags(t)\r\n{\r\n  /*\r\n  Created: 2008-04-18 by Ralph A. Dahlgren\r\n  Purpose: This function converts inert tags, containing un-natural spaces,\r\n  which have been entered for demonstation purposes, into natural looking\r\n  inert tags by using a blank image.\r\n  */\r\n  \r\n  // check to see if an element id was sent\r\n  if(t != null)\r\n  {\r\n    // if an id was sent, use that element\r\n    var e = document.getElementById(t);\r\n  }\r\n  else\r\n  {\r\n    // if no id was sent, use the body element\r\n    var e = document.getElementsByTagName(''body'')[0];\r\n  }\r\n\r\n  // fetch the element contents\r\n  var s = e.innerHTML;\r\n\r\n  // define the blank image to use, with width and height set to zero\r\n  var b = ''<img src="manager/media/images/blank.png" style="width:0; height:0;" alt="blank"/>'';\r\n\r\n  // perform sequential replacements\r\n  s = s.replace(/\\[ \\!/g, ''[''+b+''!'');\r\n  s = s.replace(/\\! \\]/g, ''!''+b+'']'');\r\n  s = s.replace(/\\[ \\[/g, ''[''+b+''['');\r\n  s = s.replace(/\\] \\]/g, '']''+b+'']'');\r\n  s = s.replace(/\\{ \\{/g, ''{''+b+''{'');\r\n  s = s.replace(/\\} \\}/g, ''}''+b+''}'');\r\n  s = s.replace(/\\[ \\*/g, ''[''+b+''*'');\r\n  s = s.replace(/\\* \\]/g, ''*''+b+'']'');\r\n  s = s.replace(/\\[ \\(/g, ''[''+b+''('');\r\n  s = s.replace(/\\) \\]/g, '')''+b+'']'');\r\n  s = s.replace(/\\[ \\~/g, ''[''+b+''~'');\r\n  s = s.replace(/\\~ \\]/g, ''~''+b+'']'');\r\n  s = s.replace(/\\{ \\!/g, ''{''+b+''!'');\r\n  s = s.replace(/\\! \\}/g, ''!''+b+''}'');\r\n  s = s.replace(/\\[ \\^/g, ''[''+b+''^'');\r\n  s = s.replace(/\\^ \\]/g, ''^''+b+'']'');\r\n\r\n  // write modified contents back to element\r\n  e.innerHTML = s;\r\n}\r\n\r\n// call the fixInertTags function\r\nFixInertTags();\r\n\r\n//-->\r\n</script>', 0);

-- END::INSERT site_htmlsnippets DATA


-- START::INSERT site_snippets DATA

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(1, 'PoweredBy', 'A little link to Etomite', '// Snippet name: PoweredBy\r\n// Snippet description: A little link to Etomite.\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n\r\n$version = $etomite->getVersionData();\r\nreturn ''<a href="http://www.etomite.com" title="Etomite Website">Powered by Etomite <b>''.$version[''version''].$version[''patch_level''].''</b> <i>(''.$version[''code_name''].'')</i>.</a>'';', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(2, 'PageTrail', 'Outputs the page trail, based on Bill Wilson''s script', '// Snippet name: PageTrail\r\n// Snippet description: Outputs the page trail, based on Bill Wilson''s script\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n\r\n$sep = " &raquo; ";\r\n\r\n// end config\r\n$ptarr = array();\r\n$pid = $etomite->documentObject[''parent''];\r\n$ptarr[] = "<a href=''[~".$etomite->documentObject[''id'']."~]''>".$etomite->documentObject[''pagetitle'']."</a>";\r\n\r\nwhile ($parent=$etomite->getParent($pid)) {\r\n    $ptarr[] = "<a href=''[~".$parent[''id'']."~]''>".$parent[''pagetitle'']."</a>";\r\n    $pid = $parent[''parent''];\r\n}\r\n\r\n$ptarr = array_reverse($ptarr);\r\nreturn join($ptarr, $sep);', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(3, 'SearchForm', 'All-in-one snippet to search the site', '// Snippet name: SearchForm\r\n// Snippet description: All-in-one snippet to search the site\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n$searchString = \r\nisset($_POST[''search'']) && \r\n$_POST[''search'']!= "{{" && \r\n$_POST[''search'']!= "[[" && \r\n$_POST[''search'']!= "[(" && \r\n$_POST[''search'']!= "[~" && \r\n$_POST[''search'']!= "[*" ?\r\n$_POST[''search''] : "" ;\r\n\r\n\r\n$SearchForm .= ''<form name="SearchForm" action="" method="post">''."\\n"; \r\n$SearchForm .= ''<input type="text" name="search" class="text" value="''.$searchString.''" /><br />''."\\n"; \r\n$SearchForm .= ''<input type="submit" name="sub" class="button" value="Search" />''."\\n"; \r\n$SearchForm .= ''</form>''; \r\n\r\nif(isset($_POST[''search'']) && $_POST[''search'']!='''') { \r\n   $search = explode(" ", $_POST[''search'']); \r\n   $tbl = $etomite->dbConfig[''dbase''].".".$etomite->dbConfig[''table_prefix'']."site_content";\r\n   $sql = "SELECT id, pagetitle, parent, description FROM $tbl WHERE ($tbl.content LIKE ''%".$search[0]."%''"; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND $tbl.content like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR $tbl.pagetitle LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND $tbl.pagetitle like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR $tbl.description LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND $tbl.description like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= ") AND $tbl.published = 1 AND $tbl.searchable=1 AND $tbl.deleted=0;"; \r\n   $rs = $etomite->dbQuery($sql); \r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit>0) { \r\n      $SearchForm .= "<p>The following results were found:</p>\\n";\r\n      $SearchForm .= "<table cellspacing=\\"0\\" cellpadding=\\"0\\">\\n"; \r\n      for ($y = 0; $y < $limit; $y++) { \r\n         $SearchFormsrc=$etomite->fetchRow($rs); \r\n         $SearchForm.="<tr><td style=\\"padding: 1px\\"><a href=\\"[~".$SearchFormsrc[''id'']."~]\\"><b>".$SearchFormsrc[''pagetitle'']."</b></a></td>\\n";\r\n         $SearchForm.="<td style=\\"padding: 1px\\">"; \r\n         $SearchForm.=$SearchFormsrc[''description'']!='''' ? " - <small>".$SearchFormsrc[''description'']."</small>" : "" ; \r\n         $SearchForm .= "</td></tr>";\r\n      } \r\n      $SearchForm .= "</table>";\r\n   } else { \r\n      $SearchForm.="<p>Sorry, couldn''t find anything!</p>"; \r\n   } \r\n} \r\n\r\nreturn $SearchForm;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(4, 'GetStats', 'Fetches the visitor statistics totals from the database', '// Snippet name: GetStats\r\n// Snippet description: Fetches the visitor statistics totals from the database\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n$tmpArray = $etomite->getSiteStats();\r\n\r\n$output = "\r\n<table>\r\n  <thead>\r\n    <tr style=\\"text-align:right;\\">\r\n        <td width=\\"25%\\">&nbsp;</td>\r\n        <td width=\\"25%\\"><b>Pages</b></td>\r\n        <td width=\\"25%\\"><b>Visits</b></td>\r\n        <td width=\\"25%\\"><b>Visitors</b></td>\r\n    </tr>\r\n  </thead>\r\n    <tr style=\\"text-align:right;\\">\r\n        <td><b>Today</b></td>\r\n        <td>".number_format($tmpArray[''piDay''])."</td>\r\n        <td>".number_format($tmpArray[''viDay''])."</td>\r\n        <td>".number_format($tmpArray[''visDay''])."</td>\r\n    </tr>\r\n    <tr style=\\"text-align:right;\\">\r\n        <td><b>This Month</b></td>\r\n        <td>".number_format($tmpArray[''piMonth''])."</td>\r\n        <td>".number_format($tmpArray[''viMonth''])."</td>\r\n        <td>".number_format($tmpArray[''visMonth''])."</td>\r\n    </tr>\r\n    <tr style=\\"text-align:right;\\">\r\n        <td><b>All Time</b></td>\r\n        <td>".number_format($tmpArray[''piAll''])."</td>\r\n        <td>".number_format($tmpArray[''viAll''])."</td>\r\n        <td>".number_format($tmpArray[''visAll''])."</td>\r\n    </tr>\r\n</table>\r\n";\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(5, 'DateTime', 'Adjusts and formats document or current Date/Time', '// Snippet: DateTime\r\n// Purpose: Adjusts and formats document or current Date/Time\r\n// Revision: 1.2 ships with Etomite Prelude v1.0\r\n// Credit: 2004-09-12 -- Alex Butter\r\n// Credit: ????-??-?? -- Bill Wilson\r\n// Credit: 2005-02-07 -- Lloyd Borrett\r\n// Credit: 2008-04-14 -- Ralph A. Dahlgren\r\n\r\n/*\r\n   For such a small piece of code, this is an exceedingly \r\n   powerful and handy snippet. The snippet accepts the\r\n   parameter, ''timestamp''. If this isn''t set, the snippet \r\n   will display the current date and time. If you pass a \r\n   timestamp (UNIX-style), it will convert that instead. \r\n   Probably the most useful way of using this snippet is \r\n   by writing something like the following in your template \r\n   or document:\r\n\r\n   Last edited on: [!DateTime?timestamp=[*editedon*]!]\r\n\r\n   This will display the date and time at which the document \r\n   was last altered on your page!\r\n\r\n  Available document related timestamps:\r\n  [*createdon*]  = timestamp when document was originally created\r\n  [*editedon*]   = timestamp when document was last edited\r\n  [*pub_date*]   = timestamp when document should be published\r\n  [*unpub_date*] = timestamp when document should be unpublished\r\n  Sending without [*...*] is also allowed\r\n\r\n  Additional examples:\r\n  [!DateTime?format=%Y-%m-%d %r!] returns formatted like 2008-12-31 12:59:00 pm\r\n  [!DateTime!] returns the current time based on the date and time formats set\r\n  in the configuration panel.\r\n  [!DateTime?timestamp=[*editedon*]&format=%Y-%m-%d %r!] is a full featured example\r\n  [!DateTime?timestamp=editedon!] tells the snippet to use the document object\r\n  \r\n  for more strftime() date formatting options see:\r\n    http://us.php.net/manual/en/function.strftime.php\r\n*/\r\n\r\n// optionally, timestamp document objects can be sent without tags\r\nif(in_array($timestamp, array(''createdon'', ''editedon'', ''pub_date'', ''unpub_date'')))\r\n{\r\n  $timestamp = $etomite->documentObject[$timestamp];\r\n}\r\n\r\n// if an invalid timestamp was sent, reurn an error\r\nif(isset($timestamp) && empty($timestamp))\r\n{\r\n  return "(timestamp error)";\r\n}\r\n// if $format was sent, use it, otherwise use the configuration panel format\r\n$format = isset($format) ? $format : $etomite->config[''date_format'']." ".$etomite->config[''time_format''];\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\n// if server offset time is null, set to zero\r\nif(!$server_offset_time)\r\n{\r\n  $server_offset_time = 0;\r\n}\r\n// if no timestamp was supplied, use current time\r\nif(!isset($timestamp))\r\n{\r\n  $timestamp=time();\r\n}\r\n// return formatted timestamp to caller\r\nreturn strftime($format, $timestamp + $server_offset_time);\r\n// the end\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(6, 'GetKeywords', 'Fetches the keywords attached to the document.', '// Snippet: GetKeywords\r\n// Purpose: Fetches the keywords attached to the document.\r\n// Revision: 1.1\r\n\r\n$results = $etomite->getKeywords();\r\n\r\nif(count($results) > 0)\r\n{\r\n  $keywords = join($results, ",");\r\n  return "<meta http-equiv=\\"keywords\\" content=\\"{$keywords}\\" />";\r\n}\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(7, 'NewsListing', 'Displays news. Rev 04 by Ian Smith', '// --------------------\r\n// Snippet: NewsListing\r\n// --------------------\r\n// Originated as NewsListing v1.0 by Alex\r\n// Revised as NewsListingRevised by mrruben5\r\n// Revised as NewsListingRev02 by LePrince\r\n// Revised as NewsListingRev03 v1.0 by Lloyd Borrett (lloyd@borrett.id.au)\r\n// Revised as NewsListingRev04 v1.0 by Ian Smith (www.n-vent.com)\r\n//\r\n// Showing the date-time is now optional.\r\n//\r\n// Option to output dates and times as local time.\r\n// This would be typically done using the Etomite configuration \r\n// "server offset time" value. But you can specify a different value.\r\n//\r\n// Option to get only active documents, or all documents, in the folder.\r\n\r\n// Revised as NewsListingRev03 v1.1 by Lloyd Borrett (lloyd@borrett.id.au)\r\n// Added options to specify the sort field and sort direction as arguments.\r\n//\r\n// Revised as NewsListingRev04 by Ian Smith (www.n-vent.com)\r\n// Changed output to be semantically correct unordered list.\r\n// Last Modified: 02-Oct-2007\r\n\r\n\r\n//===== STYLES: ==============\r\n// .newsList -the class of the unordered news list\r\n// .newsLi -the class of each newslist LI item\r\n// .newsTitle -the class of the H1 news title\r\n// .postInfo -the class of the paragraph containing the date and author information for each post\r\n// .oldernewsheading -the h2 class for the "older news" heading\r\n// .oldnews -the class of the unordered "older news" list\r\n\r\n//===== USAGE: ===============\r\n// [[NewsListing]] \r\n// [[NewsListing?newsid=8]]\r\n// [[NewsListing?newsid=8&complete_news_id=10]]\r\n// and so on for all the acceptable arguments.\r\n\r\n//===== ARGUMENTS: ===============\r\n\r\n// the folder that contains news entries\r\n// passed as argument "newsid" or default to current document id \r\n$resourceparent = isset($newsid) ? $newsid : $etomite->documentIdentifier;\r\n\r\n// set this to the id of the document which contains the \r\n// snippetcall where ALL news-articles are to be shown.\r\n// the "Older news" text serves as hyperlink\r\n// -1 = ignore this\r\nif (!isset($complete_news_id)) {$complete_news_id = 8;}\r\n\r\n// should the author be displayed?   1=yes,   0=no\r\nif (!isset($show_author)) {$show_author =1;}\r\n\r\n// should the date-time be displayed?   1=yes,   0=no\r\nif (!isset($show_date)) {$show_date = 1;}\r\n\r\n// how many "older news" shall be displayed\r\n// -1 = all of them\r\nif (!isset($older_news)) {$older_news = 20;}\r\n\r\n// should the pagetitle, which is used as heading, be clickable?\r\nif (!isset($title_as_link)) {$title_as_link = 1;}\r\n\r\n// should the news item text be omitted?   1=yes,   0=no\r\n// goes nicely with $title_as_link!\r\nif (!isset($title_only)) {$title_only = 0;}\r\n\r\n// should only active documents be displayed?   1=yes,   0=no\r\n// yes - returns only active documents (i.e. published and not deleted) in the folder\r\n// no - returns all documents (i.e. published, unpublished, deleted) in the folder\r\nif (!isset($show_only_active)) {$show_only_active = 1;}\r\n\r\n// What field should the news items be sorted on?\r\n// Typically this would be ''createdon'', but there may be\r\n// times where ''menuindex'' or another field is preferred.\r\nif (!isset($sortfield)) {$sortfield = ''createdon'';}\r\n\r\n// What direction should the news items be sorted on?\r\n// Typically this would be ''DESC'' descending, but there may\r\n// be times when ''ASC'' is preferred.\r\nif (!isset($sortdir)) {$sortdir = ''DESC'';}\r\n\r\n//===== end of arguments =========\r\n\r\n//===== CONFIGURATION: ===============\r\n\r\n// number of news items to show a "short story" of\r\n$nrblogs = 5;\r\n\r\n// total number of news items to retrieve\r\n// archives is $nrblogstotal minus $nrblogs\r\n$nrblogstotal = 25;\r\n\r\n// how many characters to show of news item if splitter not being used\r\n$lentoshow = 256; \r\n\r\n// what indicates the "full story", i.e. the end of the \r\n// short portion and the beginning of the\r\n// "full story" - this has to be "written" manually in \r\n// the article''s text in HTML-mode (without the apostrophes of course)!\r\n// the <!-- --> makes it a comment which is automatically \r\n// invisible within the article.\r\n$splitter = "<!--FullStory-->";\r\n\r\n// the text to show as full story link\r\n$fullstorytext = "Full Story";\r\n\r\n// shall the article be cut off at the *splitter*?   1=yes,   0=no\r\n$use_splitter = 0;\r\n\r\n// the text to show for no entries found\r\n$noentriestext = "No entries found.";\r\n\r\n// the text to show as heading for older news \r\n// Note that you must write special characters as html entities. \r\n$oldernewstext = "News Archives";\r\n\r\n// the default author name\r\n$noauthortext = "";\r\n// the date-time format to display based on strftime() \r\n$timeformat = "%A, %d-%b-%Y %H:%M %p";  #  ( Thursday, 08-Oct-2005 02:00 PM )\r\n\r\n// get server offset time in hours\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n} else {\r\n  $server_offset_time = ($server_offset_time / 60 / 60);\r\n}\r\n \r\n// default time offset (+/-) in hours to use\r\n// typically set to the Etomite configuration "server offset time" value\r\n// using the $server_offset_time value calculated above\r\n$default_time_diff = $server_offset_time;\r\n\r\n//===== end of configuration =========\r\n\r\n// initialise the news variable \r\n$output = '''';\r\n$output = "<ul class=\\"newsList\\">";\r\n\r\n// time adjustment\r\n$timeadjust = ($default_time_diff * 60 * 60);\r\n\r\nif ($show_only_active == 1) {\r\n  $resource = $etomite->getActiveChildren($resourceparent, $sortfield, $sortdir, $fields=''id, pagetitle, description, content, createdon, createdby'');\r\n} else {\r\n  $resource = $etomite->getAllChildren($resourceparent, $sortfield, $sortdir, $fields=''id, pagetitle, description, content, createdon, createdby'');\r\n}\r\n\r\n$limit = count($resource);\r\nif ($limit < 1) { \r\n   $output .= $noentriestext."<br />\\n"; \r\n} \r\n\r\n$nrblogs = $nrblogs<$limit ? $nrblogs : $limit; \r\nif ($limit > 0) { \r\n   for ($x = 0; $x < $nrblogs; $x++) { \r\n    $tbl = $this->dbConfig[''dbase''].".".$this->dbConfig[''table_prefix'']."manager_users";\r\n      $sql = "SELECT username FROM $tbl WHERE $tbl.id = ".$resource[$x][''createdby'']; \r\n      $rs2 = $etomite->dbQuery($sql);\r\n      $limit2 = $etomite->recordCount($rs2); \r\n      if ($limit2 < 1) { \r\n         $username .= $noauthortext; \r\n      } else { \r\n         $resourceuser = $etomite->fetchRow($rs2); \r\n         $username = $resourceuser[''username'']; \r\n\r\n//====== Splitter to be used? =====\r\n         if ($use_splitter == 1) {\r\n           if (is_string(strstr ($resource[$x][''content''], $splitter))) {\r\n           // Does the content contain the socalled "splitter"?\r\n             $rest = array();\r\n\r\n             // HTMLarea/XINHA encloses it in paragraph''s\r\n             $rest = explode(''<p>''.$splitter.''</p>'',$resource[$x][''content'']);\r\n\r\n             // For TinyMCE or if it isn''t wrapped inside paragraph tags\r\n             $rest = explode($splitter,$rest[''0'']);\r\n\r\n             $rest = $rest[''0''].''<p><a class="readmore" href="[~''.$resource[$x][''id''].''~]">''.$fullstorytext."</a></p>\\n";\r\n           } else {\r\n             $rest = $resource[$x][''content'']; \r\n           }\r\n//======= End of splitter part ===\r\n\r\n         } else { \r\n//=== no splitter ... normal behaviour: ===\r\n           // strip the content \r\n           if (strlen($resource[$x][''content'']) > $lentoshow) { \r\n             $rest = substr($resource[$x][''content''], 0, $lentoshow); \r\n             $rest .= "...<br />\\n";\r\n             $rest .= "<a href=\\"[~".$resource[$x][''id'']."~]\\">Read more...</a>"; \r\n           } else { \r\n             $rest = $resource[$x][''content'']; \r\n           } \r\n//======= End of no splitter part ===\r\n         }\r\n\r\n         $output .= "\\n<li class=\\"newsLi\\"><h1 class=\\"newsTitle\\">";\r\n         if ($title_as_link == 1) {\r\n           $output .= "<a href=\\"[~".$resource[$x][''id'']."~]\\">";\r\n         }\r\n         $output .= $resource[$x][''pagetitle''];\r\n         if ($title_as_link == 1) {\r\n           $output .= "</a>";\r\n         }\r\n         $output .= "</h1>\\n";\r\n      \r\n         if ($title_only != 1) {\r\n           $output .= $rest."</p>\\n";\r\n         }\r\n\r\n         if (($show_author == 1) || ($show_date == 1)) {\r\n           $output .= "<p class=\\"postInfo\\">Posted ";\r\n           if ($show_author == 1) {\r\n             $output .= "by ".$username." ";\r\n           }\r\n           if ($show_date == 1) {\r\n             $output .= "on ".strftime($timeformat, $resource[$x][''createdon''] + $timeadjust);\r\n           }\r\n           $output .= "</p>";\r\n         } \r\n         $output .= "</li>\\n";\r\n      } \r\n   } \r\n} \r\n$output .= "</ul>\\n"; \r\nif ($limit > $nrblogs) { \r\n   $output .= "<h2 class=\\"oldernewsheading\\">";\r\n\r\n   //=== is there a document where *all* news are to be displayed? If so\r\n   //=== here is the hyperlink\r\n   if ($complete_news_id != -1) {\r\n     $output .= "<a href=\\"[~$complete_news_id~]\\">";\r\n   }\r\n\r\n   //=== older news text:\r\n   $output .= "$oldernewstext"; \r\n\r\n   //=== is there a document where *all* news are to be displayed? If so\r\n   //=== close the hyperlink\r\n   if ($complete_news_id != -1) {\r\n     $output .= "</a>";\r\n   }\r\n   $output .= "</h2>\\n";\r\n\r\n   //=== count of older news to be shown:\r\n   if ($older_news == -1) {\r\n     $older_news = $limit;\r\n   } else {\r\n     $older_news += $nrblogs;\r\n   }\r\n\r\n   \r\n   $output .= "<ul class=\\"oldnews\\">\\n"; \r\n   for ($x = $nrblogs; $x < $limit; $x++) { \r\n\r\n      //=== show only a certain amount of older news:\r\n      if ($x < $older_news) {\r\n        $output .= "<li><a href=\\"[~".$resource[$x][''id'']."~]\\"";\r\n        if (($show_author == 1) || ($show_date == 1)) {\r\n          $output .= " title=\\"Posted ";\r\n          if ($show_author == 1) {\r\n            $output .= "by ".$username." ";\r\n          }\r\n          if ($show_date == 1) {\r\n            $output .= "on ".strftime($timeformat, $resource[$x][''createdon''] + $timeadjust);\r\n          }\r\n          $output .= "\\"";\r\n        } \r\n        $output .= ">".$resource[$x][''pagetitle'']."</a></li>\\n";\r\n      }          \r\n   }\r\n   $output .= "</ul>\\n";\r\n}\r\n\r\nreturn $output;\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(8, 'GetAuthorData', 'Returns author information based on sent parameters', '//  Snippet: GetAuthorData\r\n//  Purpose: Returns author information based on sent parameters \r\n// Revision: 1.2 ships with Etomite Prelude v1.0\r\n//   Author: Ralph A. Dahlgren - rad14701@yahoo.com\r\n// Modified: 2008-04-17\r\n\r\n// Usage: [[GetAuthorData?internalKey=[*createdby*]&field=fullname]]\r\n// internalKey=[*editedby*] will return data about the user who last edited a document\r\n// internalKey subset: ([*createdby*], [*editedby*], or a numeric internalKey)\r\n// field can be any column in the user_attributes database table\r\n// field subset: (fullname,email,phone,mobilephone)\r\n\r\n// if both parameters were passed, process the request\r\nif(($internalKey != "") && ($field != ""))\r\n{\r\n  // process the request (returns false on failure)\r\n  if($author = $etomite->getAuthorData($internalKey))\r\n  {\r\n    // if the request was successful, return the requested data\r\n    return $author[$field];\r\n  }\r\n}\r\n\r\n// if all else fails, return empty\r\nreturn;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(9, 'SiteUpdate', 'Returns date of most recent document update', '// Snippet name: SiteUpdate\r\n// Snippet description: Returns date of most recent published document update\r\n// Revision: 1.2 ships with Etomite Prelude v1.0\r\n\r\n// Author: Ralph A. Dahlgren -- 2005-07-13\r\n// Usage: [!SiteUpdate?dateFormat=%B %e, %Y!] Returns date formatted: July 13, 2005 \r\n// See strftime() documentation for additional formatting options\r\n\r\n// Changes:\r\n//   v1.1 by Lloyd Borrett -- 2006-04-07\r\n//     Return local time based on Etomite server offset time\r\n//   v1.2 by Ralph A. Dahlgren -- 2008-04-12\r\n//     Ignore unpublished and deleted documents\r\n//     Use Date and Time formats from configuration\r\n\r\n// was $dateFormat sent in snippet call?\r\nif(isset($dateFormat))\r\n{\r\n  // use $dateFormat sent in snippet call\r\n  $format = $dateFormat;\r\n}\r\nelse\r\n{\r\n  // use default Date & Time formats from configuration\r\n  $format = $etomite->config[''date_format'']." ".$etomite->config[''time_format''];\r\n}\r\n\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\n// if no server offset time was found, use zero\r\nif(!$server_offset_time)\r\n{\r\n  $server_offset_time = 0;\r\n}\r\n\r\n// define our database query\r\n$sql = <<<QUERY\r\n  SELECT editedon \r\n  FROM {$etomite->db}site_content \r\n  WHERE published=1\r\n  AND deleted=0\r\n  ORDER BY editedon DESC\r\nQUERY;\r\n\r\n// perform the database query\r\n$rs = $etomite->dbQuery($sql);\r\n\r\n// check to see if results were returned\r\nif($etomite->recordCount($rs) > 0)\r\n{\r\n  // fetch the first data row (last edited)\r\n  $row = $etomite->fetchRow($rs);\r\n  // add server offset to timestamp\r\n  $update = strftime($format,$row[''editedon''] + $server_offset_time);\r\n}\r\nelse\r\n{\r\n  // no results returned so set to null\r\n  $update = null;\r\n}\r\n\r\n// return formatted timestamp to caller\r\nreturn $update;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(10, 'SearchPrompt', 'Search prompt snippet for use with SearchResults', '// Snippet name: SearchPrompt\r\n// Snippet description: Search prompt snippet for use with SearchResults\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n// Use: [!SearchPrompt?resultsid=###!] snippet call where ### is the\r\n//   document id of the page which contains the [!SearchResults!] snippet call\r\n\r\n$resultsDefault = "14";  // Document id to use if $resultsid not sent\r\n$resultsid = isset($resultsid) ? $resultsid : $resultsDefault;\r\n\r\n$prompt = "Search this site";  // Search box label text\r\n$submit = "Search";  // Submit button label\r\n\r\n$output = \r\n<<<END\r\n<form id="SearchForm" action="[~{$resultsid}~]" method="post"> \r\n  <div class="searchbox" style="text-align:center;">\r\n    <p>{$prompt}</p>\r\n    <p><input type="text" name="search" value="" /></p>\r\n    <p><input type="submit" name="sub" class="button" value="{$submit}" /></p>\r\n  </div>\r\n</form>\r\nEND;\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(11, 'SearchResults', 'Displays results of SearchPrompt snippet', '//  SearchResults\r\n//  Displays results of SearchPrompt snippet\r\n\r\n$noResults = "<p>No search results were found.</p>";\r\n$resultsText = "<p>The following results were found:</p>";\r\n$searchString = \r\nisset($_POST[''search'']) && \r\n$_POST[''search'']!= "{{" && \r\n$_POST[''search'']!= "[[" && \r\n$_POST[''search'']!= "[(" && \r\n$_POST[''search'']!= "[~" && \r\n$_POST[''search'']!= "[*" ?\r\n$_POST[''search''] : "" ;\r\n\r\nif(isset($_POST[''search'']) && $_POST[''search'']!='''') { \r\n   $search = explode(" ", $_POST[''search'']); \r\n   $sql = "SELECT id, pagetitle, parent, description FROM ".$etomite->db.site_content." WHERE (content LIKE ''%".$search[0]."%''"; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND content like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR pagetitle LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND pagetitle like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR description LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND description like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= ") AND published = 1 AND searchable=1 AND deleted=0;"; \r\n   $rs = $etomite->dbQuery($sql); \r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit>0) { \r\n      $SearchForm .= $resultsText."<p><table cellspacing=''0'' cellpadding=''0''>"; \r\n      for ($y = 0; $y < $limit; $y++) { \r\n         $SearchFormsrc=$etomite->fetchRow($rs); \r\n         $SearchForm.="<tr><td style=''padding: 1px''><a href=''[~".$SearchFormsrc[''id'']."~]''><b>".$SearchFormsrc[''pagetitle'']."</b></a></td><td style=''padding: 1px''>"; \r\n         $SearchForm.=$SearchFormsrc[''description'']!='''' ? " - <small>".$SearchFormsrc[''description'']."</small>" : "" ; \r\n         $SearchForm .= "</td></tr>";\r\n      } \r\n      $SearchForm .= "</table>";\r\n   } else { \r\n      $SearchForm .= $noResults; \r\n   } \r\n} \r\n\r\nreturn $SearchForm;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(12, 'ListDocuments', 'Displays document listings based on provided criteria', '// Snippet name: ListDocuments\r\n// Snippet description: Displays document listings based on provided criteria \r\n// Revision: 1.2 ships with Etomite 0.6.1-Final\r\n\r\n// Advanced version of the NewsListing snippet created by Ralph A. Dahlgren\r\n//   from the earlier version by Alex Butter\r\n\r\n// Displays brief listing of new article summaries with links to full articles\r\n// All passed variable assignments are optional and can be customized as needed\r\n// Usage: [!ListDocuments?ids=123&numListings=5&maxListings=20&maxChars=200!]\r\n///   Or: [!ListDocuments!] to use default settings for curent folder document\r\n//    Or: [!ListDocuments?ids=11,27,34,119&numListings=5&maxListings=5&maxChars=400!]\r\n//    Or: [!ListDocuments?createdby=1&createdon=20050514!]\r\n// Note:  createdon = YYYYMMDD or MM/DD/YY[YY] formats\r\n//        createdby = user/manager internalKey number\r\n\r\n// Changes:\r\n//   v1.1 by Ralph A. Dahlgren -- 2005-07-13\r\n\r\n//   v1.2 by Lloyd Borrett -- 2006-04-07\r\n//     Return local time based on Etomite server offset time\r\n\r\n//----------  Start of inline style variables  ----------//\r\n//  can be changed to use CSS by using: $object_css = "class=''object_class_name''";\r\n\r\n$entry_box_css = "style=\\"background-color:#F0F8FF; padding:5px; border:1px solid black;\\"";\r\n$title_css = "style=\\"color:red; font-weight:bold; display:block;\\"";\r\n$author_css = "style=\\"color:green; font-weight:bold; display:inline;\\"";\r\n$date_css = "style=\\"color:green; display:inline;\\"";\r\n$parent_css = "style=\\"color:#FFA500; font-weight:bold\\"";\r\n$text_css = "style=\\"color:black; font-weight:normal; margin-top:.5em;\\"";\r\n$more_css = "style=\\"float:right; color:#FFA500; font-weight:bold;\\"";\r\n \r\n//----------  Start of configuration variable assignments  ----------//\r\n\r\n// array of folder id''s that contain news listings, or current folder document (default)\r\n$ids = isset($ids) ? $ids : $etomite->documentIdentifier;\r\n\r\n// number of news listings to summarize\r\n$numListings = isset($numListings) ? $numListings : 3;\r\n\r\n// maximum number of news listings to display\r\n$maxListings = isset($maxListings) ? $maxListings : 100;\r\n \r\n//  maximum character count of news listing summaries to display\r\n$maxChars = isset($maxChars) ? $maxChars : 150;\r\n\r\n// assign message to return if no news listings are found\r\n$noResults = "No entries were found.<br />";\r\n \r\n// Date & Time format based on PHP function strftime() {"%d-%m-%y %H:%M:%S"}\r\n$date_time_format = "%Y-%m-%d";\r\n \r\n// text for author label\r\n$author = "Author: ";\r\n\r\n// Text to display as link to full news listing\r\n$more = "Read the complete article &raquo;";\r\n\r\n// Text to display above additional articles list\r\n$olderNews = "Additional Recent Articles:";\r\n\r\n// Text to display between Author and Date fields\r\n$between = "&#8212;";\r\n \r\n//----------  End of configuration variable assignments  ----------//\r\n\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n\r\n// initialize the data variable to be returned\r\n$output = '''';\r\n\r\n// assign which data fields to extract from table rows\r\n\r\n$fields = ''\r\n  id,\r\n  pagetitle,\r\n  description,\r\n  content,\r\n  createdon,\r\n  createdby\r\n'';\r\n\r\n// assign selection criteria for WHERE clause\r\n$where = "parent IN($ids) AND published=1 AND deleted=0";\r\n\r\n// if $createdon was sent, convert it to a timestamp and use it\r\nif(isset($createdon)) $where .= " AND createdon=".strtotime($createdon);\r\n\r\n// if $createdby (user internalKey) was sent, add to where clause\r\nif(isset($createdby)) $where .= " AND createdby=".$createdby;\r\n\r\n// retrieve child documents that are published and not deleted using getIntTableRows() API function\r\n$rs = $etomite->getIntTableRows(\r\n  $fields,\r\n  $from="site_content",\r\n  $where,\r\n  $sort="createdon",\r\n  $dir="DESC",\r\n  $limit\r\n);\r\n\r\n// return a message if no listings were found\r\n$limit = count($rs);\r\nif($limit < 1) {\r\n  $output .= $noResults;\r\n} else {\r\n  \r\n  // determine how many listings to process\r\n  $numListings = ($numListings < $limit) ? $numListings : $limit;\r\n  \r\n  // process the proper number of listings\r\n  for ($x = 0; $x < $numListings; $x++) {\r\n    \r\n    // retrieve the authors full username using getAuthorData() API function\r\n    $userdata = $etomite->getAuthorData($rs[$x][''createdby'']);\r\n    $username = $userdata[''fullname''];\r\n    \r\n    // if the listing is longer than $maxChars, strip the HTML tags from the content \r\n    $stripped = strip_tags($rs[$x][''content'']);\r\n    if(strlen($stripped)>$maxChars) {\r\n      $rest = substr($stripped, 0, $maxChars);\r\n      $rest .= "...<br />"; \r\n    } else {\r\n      $rest = $rs[$x][''content''];\r\n    }\r\n    \r\n    // format the news listing for display\r\n    $output .= "\r\n    <div ".$entry_box_css.">\r\n      \r\n      <div ".$title_css.">\r\n        ".$rs[$x][''pagetitle'']."\r\n      </div>\r\n      \r\n      <div ".$text_css.">\r\n        \r\n        ".$rest."\r\n        <div style=\\"clear:both; margin-bottom:.5em;\\"></div>\r\n        \r\n        <div style=\\"text-align:left; float:left;\\">\r\n          ".$author."\r\n          <div ".$author_css.">\r\n            ".$username."\r\n          </div>\r\n          ".$between." ".strftime($date_time_format, $rs[$x][''createdon''] + $server_offset_time)."\r\n        </div>\r\n        <div style=''text-align:right; float:right;''>\r\n          <a href=\\"[~".$rs[$x][''id'']."~]\\">".$more."</a>\r\n        </div>\r\n      \r\n      </div>\r\n      \r\n      <br />\r\n    \r\n    </div>\r\n    <br />";\r\n  }\r\n}\r\n\r\n// display list of links to older news articles\r\nif(($limit > $numListings) && ($numListings < $maxListings)) {\r\n  $output .= "<br /><br /><b>".$olderNews."</b><br />";\r\n  for ($x = $numListings; $x < $limit; $x++) {\r\n    $output .= "<a href=\\"[~".$rs[$x][''id'']."~]\\">".$rs[$x][''pagetitle'']."</a><br />";          \r\n  }\r\n}\r\n\r\n// return snippet results for display\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(13, 'ListMenu', 'Feature-rich menu snippet', '// --------------------\r\n// Snippet: ListMenu\r\n// --------------------\r\n// Version: 0.6f\r\n// Date: 2005.08.04\r\n// jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show navigation\r\n// in a nested lists of arbitrary depth.\r\n\r\n// Configuration Settings\r\n\r\n   // $removeNewLines\r\n   // This setting will remove white space from between <ul> and <li> \r\n   // items so the list can be styled in IE. This makes it hard to read\r\n   // the source code- set to false for troubleshooting before launch. \r\n   // False is also handy if the list will be horizontal.\r\n   $removeNewLines = true;\r\n\r\n   // $currentAsLink\r\n   // If you would like to turn off the link for the\r\n   // current page, set to false.\r\n   $currentAsLink = false;\r\n\r\n   // $LM_node [ int ]\r\n   // Settable in snippet call only. Allows you to set an arbitrary\r\n   // anchor for this menu. Should be id number of initial document.\r\n   // For ListMenu this is typically the current page so that the\r\n   // snippet will generate a list back to the site root.\r\n   // [[ListMenu?LM_node=56]]\r\n\r\n   // $levelsDeep [ int ]\r\n   // Specifies how many levels of menu you want to show starting\r\n   // with the children of current document working back to root. For\r\n   // example, 3 levels would give you the children of the current \r\n   // page, the current page and its siblings, and the current page''s \r\n   // parent and its siblings. The child generation is counted regardless\r\n   // of wether or not there are children. \r\n   //\r\n   // You can also specify negative  values. Negative values indicate\r\n   // how many levels NOT to include, starting at the root. For example,\r\n   // if you want all BUT the root level showing, you can declare -1.\r\n   // This would be a main section menu - but without the "global" options.\r\n   //\r\n   // The default of 0 will show current children all the  back to root.\r\n   // This represents the complete menu. You can also set this in a snippet\r\n   // call with LM_levels:\r\n   // [[ListMenu?LM_levels=1]]\r\n   $levelsDeep = 0;\r\n\r\n   // $directGeneology [ true | false ]\r\n   // Set this option if you only want to show the direct geneolgy. For\r\n   // instance, with this set to true, and you were on examplePage 5\r\n   // levels deep, you would see all of examplePage''s child pages (if\r\n   // any), examplePage''s parent, but NOT siblings of any parent above\r\n   // the current page.\r\n   $directGeneology = false;\r\n   \r\n   // $showGlobals [ true | false ]\r\n   // Leave the root level folders showing, even if $directGeneology is\r\n   // true. NOTE- this will NOT override a set $levelsDeep. Settable in \r\n   // snippet call with LM_globals (0=false, 1=true)\r\n   // [[ListMenu?LM_globals=1]]\r\n   $showGlobals = true;\r\n\r\n   // $sortWiz [ array ]\r\n   // You can specify any number of sort columns and directions, so you\r\n   // are not limited to menuindex - for instance you might want alphabetic\r\n   // or folders first or whatever. Format each sort like this:\r\n   // $sortWiz[] = array("sortColumn","direction");\r\n   // Where sortColumn is the sort column like isfolder, pagetitle, etc.\r\n   // and direction is "ASC" for ascending and "DESC" is descending.\r\n   // Default is:\r\n   // $sortWiz[] = array("menuindex","ASC");\r\n   // If you wanted folders first, THEN contents in alphabetical order:\r\n   // $sortWiz[] = array("isfolder","ASC");\r\n   // $sortWiz[] = array("pagetitle","ASC");\r\n   $sortWiz[] = array("menuindex","ASC");\r\n   \r\n   // $alternateRows [ true | false ]\r\n   // Append "_alt" to style class of alternate rows (true)\r\n   $alternateRows = false;\r\n   \r\n   // $showDescription [ true | false ]\r\n   // Show the description under the link- usually not necessary\r\n   // Set in snippet call with LM_desc:\r\n   // [[ListMenu?LM_desc=1]]\r\n   $showDescription = false;\r\n\r\n// STYLES used\r\n//\r\n// #LM_level_N      menu level where N is the number of the depth\r\n//                  starting at 0\r\n// #LM_youAreHere   menu item of current location\r\n// .LM_expanded     expanded menu item with children\r\n// .LM_collapsed    menu item with childen, but not expanded\r\n// .LM_endPage      menu item with children\r\n// .LM_description  menu item description\r\n// \r\n\r\n// ########################################\r\n// End Config\r\n// The rest takes care of itself\r\n// ########################################\r\n\r\n// Adjust for snippet variables\r\n$showGlobals = (isset($LM_globals))? $LM_globals : $showGlobals ;\r\n$levelsDeep = (isset($LM_levels))? $LM_levels : $levelsDeep ;\r\n$showDescription = (isset($LM_desc))? $LM_desc : $showDescription ;\r\n\r\n// Make adjustment for new lines \r\n$ieSpace = ($removeNewLines)? "" : "\\n";\r\n\r\n// Create Geneology\r\n\r\n$fullGeneology = array();\r\n$geneologyMarker = (isset($LM_node))? $LM_node : $etomite->documentIdentifier;\r\nwhile ($currentMarker=$etomite->getPageInfo($geneologyMarker, null, ''id,parent'')){\r\n    $fullGeneology[] = $currentMarker[''id''];\r\n    $geneologyMarker = $currentMarker[''parent''];\r\n}\r\n$fullGeneology[] = 0;\r\n\r\n// alter geneology for correct depth\r\n$geneology = array();\r\nif (($levelsDeep > 0) && (count($fullGeneology) > $levelsDeep)){\r\n    for($i = 0; $i < $levelsDeep; $i++){\r\n        $geneology[] = $fullGeneology[$i];\r\n    }\r\n} elseif (($levelsDeep) < 0 && (count($fullGeneology) > abs($levelsDeep))){\r\n    for ($i = 0; $i < -$levelsDeep; $i++){\r\n        array_pop($fullGeneology);\r\n    }\r\n    $geneology = $fullGeneology;\r\n} else {\r\n    $geneology = $fullGeneology;\r\n}\r\n\r\n// Build lists\r\n\r\n// Initialize\r\n$currentParent = $geneology[0];\r\n\r\n\r\n$listSoFar = '''';\r\n$lookForChild = 0;\r\n// Assemble sort string\r\n$sortString = '''';\r\nforeach($sortWiz as $sortCriteria){\r\n  $sortString .= $sortCriteria[0] . " " . $sortCriteria[1] . ", ";\r\n}\r\n$sortString = substr($sortString,0,strlen($sortString)-2);\r\n\r\nfor($geneCount=0;$geneCount < count($geneology);$geneCount++){\r\n    $childrenList = $etomite->getActiveChildren($geneology[$geneCount], $sortString, null,''id, pagetitle, longtitle, parent, isfolder, description'');\r\n    if ($childrenList){\r\n        $currentLevelList = ''<ul id="LM_level_''.(count($geneology)-$geneCount).''">''."\\n".$ieSpace;\r\n        $listPosition = 0;\r\n        foreach ($childrenList as $childItem){\r\n          if (!$directGeneology || $geneCount==0 || (($geneCount==1)&&(!$etomite->getActiveChildren($geneology[0]))) || ($directGeneology && in_array($childItem[''id''],$geneology)) || ($showGlobals && ($geneology[$geneCount]==0))){\r\n                if ($childItem[''isfolder'']){\r\n                    $cssStyle = (in_array($childItem[''id''], $geneology))? '' class="LM_expanded'': '' class="LM_collapsed'';\r\n                } else {\r\n                    $cssStyle = '' class="LM_endPage'';\r\n                }\r\n      $cssStyle .= ($alternateRows && ($listPosition%2))? ''_alt"'' : ''"'';\r\n                $currentLevelList .= ''<li''.$cssStyle.''>'';       \r\n                if((!$currentAsLink) && ($childItem[''id''] == $etomite->documentIdentifier)){\r\n                    $currentLevelList .= ''<span id="LM_youAreHere">'';\r\n                    $currentLevelList .= $childItem[''pagetitle''].''</span>'';\r\n                } else {\r\n                    $linkTitle = ($childItem[''longtitle''])? $childItem[''longtitle''] : $childItem[''pagetitle''] ;\r\n                    $currentLevelList .= ''<a href="[~''.$childItem[''id''].''~]" title="'' . $linkTitle .''">'';\r\n                    $currentLevelList .= $childItem[''pagetitle''].''</a>'';\r\n                }\r\n     $currentLevelList .= ($showDescription)? ''<div class="LM_description">''.$childItem[''description''].''</div>'' : '''' ;\r\n                if ($lookForChild == $childItem[''id'']) {\r\n                    $currentLevelList .= $listSoFar;\r\n                }\r\n                $currentLevelList .= "</li>\\n".$ieSpace;\r\n          }\r\n          $listPosition++;\r\n        }\r\n        $currentLevelList .= "</ul>\\n".$ieSpace;\r\n      }\r\n    $listSoFar = $currentLevelList;\r\n    $lookForChild = $geneology[$geneCount];   \r\n}\r\n\r\n// send to parser\r\nreturn $listSoFar;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(14, 'GetDocContent', 'Returns additional document content for inclusion in a page', '# Snippet:  GetDocContent -- Etomite Prelude v1.0\r\n# Author:   Ralph A. Dahlgren\r\n# Created:  2005-04-17\r\n# Modified: 2008-04-17\r\n# Purpose:  Returns additional document content for inclusion in a page\r\n# Usage: [[GetDocContent?id=nn]] where nn = id of the document being requested\r\n\r\n// if a document id was sent, fetch the document content\r\nif(isset($id))\r\n{\r\n  // we only want the content column\r\n  $fields = "content";\r\n  // query the database for our record\r\n  $doc = $etomite->getDocument($id, $fields);\r\n  // if our record was found, return the content\r\n  if($doc)\r\n  {\r\n    return $doc[''content''];\r\n  }\r\n}\r\n\r\n// if all else fails, return empty\r\nreturn;\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(15, 'ListSiteMap', 'Output a nested list site map', '// --------------------\r\n// Snippet: ListSiteMap\r\n// --------------------\r\n// Version: 1.0\r\n// Date: 2008-04-11\r\n// Ralph A. Dahlgren\r\n//\r\n\r\n// NOTE: This snippet should use a non-cacheable snippet call\r\n// Use: [!ListSiteMap!] instead of [[ListSiteMap]]\r\n\r\n// Based On:\r\n// Version: 0.6h.1\r\n// addapted by TraXas to support authentication and deleted documents\r\n// Date: 2007.11.08\r\n// jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show a nested\r\n// list site map with each pagetitle being a\r\n// link to that page. It will not include\r\n// unpublished folders/pages OR its children,\r\n// even if the children ARE published.\r\n\r\n// Configuration\r\n//\r\n// $siteMapRoot [int]\r\n// The parent ID of your root. Default 0. Can be set in\r\n// snippet call with LSM_root (to doc id 10 for example):\r\n// [!ListSiteMap?LSM_root=10!]\r\n$siteMapRoot = 0;\r\n\r\n// $showDescription [true | false]\r\n// Specify if you would like to include the description\r\n// with the page title link.\r\n$showDescription = true;\r\n\r\n// $titleOfLinks [ string ]\r\n// What database field do you want the title of your links to be?\r\n// The default is pagetitle because it is always a valid (not empty)\r\n// value, but if you prefer it can be any of the following:\r\n// id, pagetitle, description, parent, alias, longtitle\r\n$titleOfLinks = ''pagetitle'';\r\n\r\n// $removeNewLines [ true | false ]\r\n// If you want new lines removed from code, set to true. This is generally\r\n// better for IE when lists are styled vertically.\r\n$removeNewLines = false;\r\n\r\n// $maxLevels [ int ]\r\n// Maximum number of levels to include. The default 0 will allow all\r\n// levels. Also settable with snippet variable LSM_levels:\r\n// [!ListSiteMap?LSM_levels=2!]\r\n$maxLevels = 0;\r\n\r\n// $selfAsLink [ true | false ]\r\n// Define if the current page should be a link (true) or not\r\n// (false)\r\n$selfAsLink = false;\r\n\r\n// $showUnpubs [ true | false ]\r\n// Decide to include items in unpublished folders. This will show the\r\n// unpublished items as well. No links will be made for the unpublished items\r\n// but they will be shown in the structure. You will not likely want to do\r\n// this but the option is yours.\r\n$showUnpubs = false;\r\n\r\n// Styles\r\n//\r\n// .LSM_currentPage    span surrounding current page if $selfAsLink is false\r\n// .LSM_description    description of page\r\n// .LSM_N              ul style where N is the level of nested list- starting at 0\r\n\r\n// ###########################################\r\n// End config, the rest takes care of itself #\r\n// ###########################################\r\n\r\n// Initialize\r\n$siteMapRoot = (isset($LSM_root))? $LSM_root : $siteMapRoot ;\r\n$maxLevels = (isset($LSM_levels))? $LSM_levels : $maxLevels ;\r\n$ie = ($removeNewLines) ? "" : "\\n" ;\r\n\r\n// Overcome single use limitation on functions\r\nglobal $MakeMapDefined;\r\n\r\nif(!isset($MakeMapDefined))\r\n{\r\n  function MakeMap($listParent, $listLevel, $description, $titleOfLinks, $maxLevels, $su, $ie)\r\n  {\r\n    global $etomite;\r\n    $children = $etomite->getAllChildren($listParent, ''menuindex'', ''ASC'', ''id, pagetitle, description, parent, alias, longtitle, published'');\r\n    $output .= $ie."<ul class=\\"LSM_{$listLevel}\\">".$ie;\r\n    foreach($children as $child)\r\n    {\r\n      // Checks if the document doesn''t require authentication or is deleted\r\n      if(( ($etomite->checkPermissions($child[''id''])) || (!$child[''authenticate''] )) && (!$child[''deleted''] ))\r\n      {\r\n        // skip unpubs unless desired\r\n        if(!$su && !$child[''published''])\r\n        {\r\n          continue;\r\n        }\r\n        // for XHTML compliance we need to insert &nbsp; in empty descriptions\r\n        if($child[''description''] == null)\r\n        {\r\n          $child[''description''] = "&nbsp;";\r\n        }\r\n        $descText = ($description) ? "&nbsp;:&nbsp;<span class=\\"LSM_description\\">{$child[''description'']}</span>" : "";\r\n        $output .= ''<li>'';\r\n        if(!$selfAsLink && ($child[''id''] == $etomite->documentIdentifier))\r\n        {\r\n          $output .= "<span class=\\"LSM_currentPage\\">{$child[''pagetitle'']}</span>";\r\n        }\r\n        elseif(!$child[''published''])\r\n        {\r\n          $output .= "<span class=\\"LSM_unpubPage\\">{$child[''pagetitle'']}</span>";\r\n        }\r\n        else\r\n        {\r\n          $output .= "<a href=\\"[~{$child[''id'']}~]\\" title=\\"{$child[$titleOfLinks]}\\">{$child[''pagetitle'']}</a>";\r\n        }\r\n        $output .= $descText;\r\n        if ($etomite->getAllChildren($child[''id'']) && (($maxLevels == 0) || ($maxLevels > $listLevel+1 )))\r\n        {\r\n          $output .= MakeMap($child[''id''], $listLevel++, $description, $titleOfLinks, $maxLevels, $su, $ie);\r\n        }\r\n        $output .= "</li>".$ie;\r\n      }\r\n    }\r\n    $output .= "</ul>".$ie;\r\n    return $output;\r\n  }\r\n  $MakeMapDefined = true;\r\n}\r\n\r\n$output .= $ie."<!-- BEGIN::Site Map -->";\r\n$output .= MakeMap($siteMapRoot, 0, $showDescription, $titleOfLinks, $maxLevels, $showUnpubs, $ie);\r\n$output .= "<!-- END::Site Map -->".$ie;\r\nreturn $output;\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(16, 'Copyright', 'Returns a copyright statement', '/*\r\nSnippet name: Copyright\r\nSnippet description: Returns a copyright statement\r\nRevision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\nDescription:\r\n  Returns a copyright statement of the form:\r\n    ''Copyright (c) 2006 by Lloyd Borrett. All rights reserved.''\r\n    ''Copyright (c) 2005-2006 by Lloyd Borrett. All rights reserved.''\r\n    ''Copyright (c) 2005-2006. All rights reserved.''\r\n\r\n  (Note: the (c) is replaced with the actual copyright symbol character.\r\n         the ''-'' is replaced with an en dash.)\r\n\r\n  The year range being from either a site start year (if provided) \r\n  to the current year, or from the year the document was created \r\n  to the current year. All year values are based on local time \r\n  using the Etomite server offset time configuration setting.\r\n  The copyright holder can be the one entity for the \r\n  whole web site (if provided), or the author of the current\r\n  document (if provided).\r\n\r\nSnippet Author:\r\n  Lloyd Borrett (lloyd@borrett.id.au)\r\n  \r\nSnippet Category:\r\n  Miscellaneous\r\n\r\nSee in use at:\r\n  www.raydon.com.au           \r\n\r\nUsage:\r\n  Insert [[Copyright]] anywhere in the appropriate section\r\n  of your template. (Usually the footer.)\r\n*/\r\n\r\n// *** Configuration Settings ***\r\n\r\n// Start Year of the web site.\r\n// To use the document creation date, set this to ''''\r\n$site_start_year = '''';\r\n\r\n// Copyright holder for the whole web site.\r\n// To use the document author details of each document, set this to ''''\r\n$site_copyholder = $etomite->config[''site_name''];\r\n\r\n// *** Start\r\n\r\n// Get the document details.\r\n\r\n$docInfo = $etomite->getDocument($etomite->documentIdentifier);\r\n\r\n// *** AUTHOR ***\r\nif ($site_copyholder == '''') {\r\n   $authorid = $docInfo[''createdby''];\r\n   $tbl = $etomite->dbConfig[''dbase''].".".$etomite->dbConfig[''table_prefix'']."user_attributes";\r\n   $query = "SELECT fullname FROM $tbl WHERE $tbl.id = $authorid"; \r\n   $rs = $etomite->dbQuery($query);\r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit=1) {\r\n      $resourceauthor = $etomite->fetchRow($rs); \r\n      $authorname = $resourceauthor[''fullname''];  \r\n   }\r\n   // Trim and replace double quotes with entity\r\n   $copyholder = str_replace(''"'', ''&#34;'', trim($authorname));\r\n} else {\r\n   $copyholder = $site_copyholder;\r\n}\r\n\r\n// *** COPYRIGHT ***\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n// get the current time and apply the offset\r\n$timestamp = time() + $server_offset_time;\r\n// Set the current year\r\n$today_year = date(''Y'',$timestamp);\r\n$createdon = date(''Y'',$docInfo[''createdon'']);\r\nif ($site_start_year == '''') {\r\n   if ($today_year != $createdon) {\r\n      $copydate = $createdon."&#8211;".$today_year;\r\n   } else {\r\n      $copydate = $today_year;\r\n   }\r\n} else {\r\n   if ($today_year != $site_start_year) {\r\n      $copydate = $site_start_year."&#8211;".$today_year;\r\n   } else {\r\n      $copydate = $today_year;\r\n   }\r\n}\r\nif ($copyholder == '''') {\r\n   $copyname = $copyholder;\r\n} else {\r\n   $copyname = " by ".$copyholder;\r\n}\r\n\r\n// *** BUILD COPYRIGHT STATEMENT & RETURN RESULTS ***\r\n\r\n$Copyright = "Copyright &#169; ";\r\n$Copyright .= $copydate.$copyname.". All rights reserved.";\r\n\r\nreturn $Copyright;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(17, 'GoogleSiteMap_XML', 'Output a Google XML site map', '/**\r\n * GoogleSiteMap_XML Snippet for Etomite CMS\r\n * Version 0.8 2006-11-17\r\n *\r\n * Parameters:\r\n * [!GoogleSiteMap_XML?validate=true!] or [!GoogleSiteMap_XML?validate=1!]\r\n * tells the snippet to output the additional headers required to validate \r\n * your Sitemap file against a schema.\r\n *\r\n * Useage:\r\n * Create a snippet: GoogleSiteMap_XML\r\n * with the content of this file.\r\n * Update the configuration options below to suit your needs.\r\n * Create a template: GoogleSiteMap_Template \r\n * with the content "[!GoogleSiteMap_XML!]".\r\n * Create a page in your repository: Google Site Map\r\n * with no content, the alias "google-sitemap",\r\n * using the GoogleSiteMap_Template, not searchable,\r\n * not cacheable, with content type "text/xml".\r\n *\r\n * Goto the Google Webaster Tools site at https://www.google.com/webmasters/tools/\r\n * Create an account, or login using your existing account.\r\n * Enter http://www.<your domain name>/ in the add site box and click OK.\r\n * Click on "Verify your site".\r\n * Choose "Add a META tag" as your verification option.\r\n * Add the generated meta tag to the head section of your home page template.\r\n * Back in Google Webmaster Tools, click on "Verify".\r\n * Click on the "Sitemaps" button.\r\n * Click on "Add a Sitemap".\r\n * Select "Add General Web Sitemap".\r\n * Enter "http://www.<your domain name>/google-sitemap.htm" as your sitemap URL.\r\n * Click on "Add Web Sitemap".\r\n *\r\n * \r\n * Ryan Nutt - http://blog.nutt.net\r\n * v0.1 - June 4, 2005\r\n * v0.2 - June 5, 2005 - Fixed a stupid mistake :-)\r\n * \r\n * Changes by Lloyd Borrett - http://www.borrett.id.au\r\n *\r\n * v0.3 - Sep 22, 2005\r\n * Only list searchable pages (Mod suggested by mplx)\r\n * Added configuration settings.\r\n * Made the site URL a configuration option.\r\n * Made displaying lastmoddate, priority and/or changefreq optional.\r\n * Added ability to display long date & time for lastmoddate\r\n * Made the long or short timeformat optional.\r\n * \r\n * v0.4 - 05-Feb-2006\r\n * Changed the snippet to output the local time for all date values\r\n * based on the Etomite server offset time\r\n * \r\n * v0.5 - 15-Feb-2006\r\n * Fixed incorrect local GMT offset value\r\n * \r\n * v0.6 - 7-Apr-2006\r\n * Get the base URL from Etomite instead of it being a configuration option.\r\n * \r\n * v0.7 - 30-Apr-2006\r\n * Get the base URL from Etomite using the new available \r\n * method built in to Etomite 0.6.1 Final. If using an earlier\r\n * version of Etomite, you''ll still need to provide the URL\r\n * as a configuration option.\r\n * \r\n * v0.8 - 17-Nov-2006\r\n * Updated to identify itself as using the Sitemap 0.9 protocol.\r\n * Added ability to force the change frequency to a set value for all documents.\r\n * Added ability to output the additional headers required to validate the sitemap format.\r\n * Additional comments added.\r\n * Code layout made consistent.\r\n * \r\n * Based on the ListSiteMap snippet by\r\n * JaredDC\r\n * \r\n * datediff function from\r\n * www.ilovejackdaniels.com\r\n */ \r\n\r\n// Overcome single use limitation on functions\r\nglobal $MakeMapDefined;\r\n\r\n// Get the validate parameter, if any\r\n$validateschema = false;\r\nif (isset($validate)) {\r\n   if (($validate == "1") || ($validate == "true")) {\r\n       $validateschema = true;\r\n   }\r\n}\r\n\r\n// Determine values required to convert the lastmod date and\r\n// time to local time. \r\n// get the Etomite server offset time in seconds\r\nglobal $server_offset_time;\r\nglobal $GMT_value;\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n    $server_offset_time = 0;\r\n} \r\n\r\n// Get the server GMT offset in seconds\r\n$GMT_offset = date("O");\r\n$GMT_hr = substr($GMT_offset, 1, 2);\r\n$GMT_min = substr($GMT_offset, 4, 2);\r\n$GMT_sign = substr($GMT_offset, 0, 1);\r\n$GMT_secs = (intval($GMT_hr) * 3600) + (intval($GMT_min) * 60);\r\nif ($GMT_sign == ''-'') {\r\n    $GMT_secs = $GMT_secs * (-1);\r\n} \r\n\r\n// Get the local GMT offset in seconds\r\n$GMT_local_seconds = $GMT_secs + $server_offset_time;\r\n$GMT_local_secs = abs($GMT_local_seconds); \r\n// round down to the number of hours\r\n$GMT_local_hours = intval($GMT_local_secs / 3600); \r\n// round down to the number of minutes\r\n$GMT_local_minutes = intval(($GMT_local_secs - ($GMT_local_hours * 3600)) / 60);\r\nif ($GMT_local_seconds < 0) {\r\n    $GMT_value = "-";\r\n} else {\r\n    $GMT_value = "+";\r\n} \r\n$GMT_value .= sprintf("%02d:%02d", $GMT_local_hours, $GMT_local_minutes);\r\n\r\nif (!function_exists(datediff)) {\r\n    function datediff($interval, $datefrom, $dateto, $using_timestamps = false)\r\n    {\r\n        /**\r\n         * $interval can be:\r\n         * yyyy - Number of full years\r\n         * q - Number of full quarters\r\n         * m - Number of full months\r\n         * y - Difference between day numbers\r\n         * (eg 1st Jan 2004 is "1", the first day. 2nd Feb 2003 is "33". The datediff is "-32".)\r\n         * d - Number of full days\r\n         * w - Number of full weekdays\r\n         * ww - Number of full weeks\r\n         * h - Number of full hours\r\n         * n - Number of full minutes\r\n         * s - Number of full seconds (default)\r\n         */\r\n\r\n        if (!$using_timestamps) {\r\n            $datefrom = strtotime($datefrom, 0);\r\n            $dateto = strtotime($dateto, 0);\r\n        } \r\n\r\n        $difference = $dateto - $datefrom; // Difference in seconds\r\n        \r\n        switch ($interval) {\r\n            case ''yyyy'': // Number of full years\r\n                $years_difference = floor($difference / 31536000);\r\n                if (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom), date("j", $datefrom), date("Y", $datefrom) + $years_difference) > $dateto) {\r\n                    $years_difference--;\r\n                } \r\n                if (mktime(date("H", $dateto), date("i", $dateto), date("s", $dateto), date("n", $dateto), date("j", $dateto), date("Y", $dateto) - ($years_difference + 1)) > $datefrom) {\r\n                    $years_difference++;\r\n                } \r\n                $datediff = $years_difference;\r\n                break;\r\n\r\n            case "q": // Number of full quarters\r\n                $quarters_difference = floor($difference / 8035200);\r\n                while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom) + ($quarters_difference * 3), date("j", $dateto), date("Y", $datefrom)) < $dateto) {\r\n                    $months_difference++;\r\n                } \r\n                $quarters_difference--;\r\n                $datediff = $quarters_difference;\r\n                break;\r\n\r\n            case "m": // Number of full months\r\n                $months_difference = floor($difference / 2678400);\r\n                while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom) + ($months_difference), date("j", $dateto), date("Y", $datefrom)) < $dateto) {\r\n                    $months_difference++;\r\n                } \r\n                $months_difference--;\r\n                $datediff = $months_difference;\r\n                break;\r\n\r\n            case ''y'': // Difference between day numbers\r\n                $datediff = date("z", $dateto) - date("z", $datefrom);\r\n                break;\r\n\r\n            case "d": // Number of full days\r\n                $datediff = floor($difference / 86400);\r\n                break;\r\n\r\n            case "w": // Number of full weekdays\r\n                $days_difference = floor($difference / 86400);\r\n                $weeks_difference = floor($days_difference / 7); // Complete weeks\r\n                $first_day = date("w", $datefrom);\r\n                $days_remainder = floor($days_difference % 7);\r\n                $odd_days = $first_day + $days_remainder; // Do we have a Saturday or Sunday in the remainder?\r\n                if ($odd_days > 7) { // Sunday\r\n                    $days_remainder--;\r\n                } \r\n                if ($odd_days > 6) { // Saturday\r\n                    $days_remainder--;\r\n                } \r\n                $datediff = ($weeks_difference * 5) + $days_remainder;\r\n                break;\r\n\r\n            case "ww": // Number of full weeks\r\n                $datediff = floor($difference / 604800);\r\n                break;\r\n\r\n            case "h": // Number of full hours\r\n                $datediff = floor($difference / 3600);\r\n                break;\r\n\r\n            case "n": // Number of full minutes\r\n                $datediff = floor($difference / 60);\r\n                break;\r\n\r\n            default: // Number of full seconds (default)\r\n                $datediff = $difference;\r\n                break;\r\n        } \r\n\r\n        return $datediff;\r\n    } \r\n} \r\n\r\nif (!isset($MakeMapDefined)) {\r\n    function MakeMap($funcEtomite, $listParent)\r\n    {\r\n        global $server_offset_time;\r\n        global $GMT_value;\r\n\r\n        // ***********************************\r\n        // Configuration Settings \r\n        // ***********************************\r\n\r\n        // $websiteURL [string]\r\n        // Provide the full base path URL of your web site,\r\n        // or let Etomite get it (v0.6.1 Final).\r\n        // For example: http://www.yourdomain.com/\r\n        // NOTE: You must put a / on the end of the web site URL.\r\n        //\r\n        // Original hard coded way to specify $websiteURL\r\n        // $websiteurl = ''http://www.<your domain name>/''; \r\n        //\r\n        // Early Etomite way to get $websiteURL automatically\r\n        // $websiteurl = $etomite->config[''www_base_path''];\r\n        //\r\n        // Etomite 0.6.1 Final way to get $websiteURL automatically\r\n        global $ETOMITE_PAGE_BASE;\r\n        $websiteurl = $ETOMITE_PAGE_BASE[''www''];\r\n\r\n        // $showlastmoddate [true | false]\r\n        // You can choose to disable providing the last modification\r\n        // date, or get it from the documents.\r\n        // true  - Get time from documents\r\n        // false - Disabled, do not write it\r\n        $showlastmoddate = true; \r\n\r\n        // $showlongtimeformat [ true | false ]\r\n        // You can choose to provide the time format as:\r\n        // true  - Long time format (with time, e.g. 2006-09-29T13:43:51+11:00)\r\n        // false - Short time format (date only, e.g. 2006-11-17)\r\n        $showlongtimeformat = true; \r\n\r\n        // $showpriority [ true | false ]\r\n        // You can choose to disable prividing the priority\r\n        // of a document relative to the whole set of documents,\r\n        // or calculate it based on the date difference.\r\n        // true  - Provide the priority\r\n        // false - Disabled, do not write it\r\n        $showpriority = true; \r\n\r\n        // $showchangefreq [true | false]\r\n        // You can choose to disable prividing the update\r\n        // (change) frequency of a document relative to the\r\n        // whole set of documents, or calculate it based on\r\n        // the date difference.\r\n        // true  - Provide the change frequency\r\n        // false - Disabled, do not write it\r\n        $showchangefreq = true;\r\n\r\n        // $forcechangefreq [string]\r\n        // You can choose to force the change frequency for all \r\n        // documents to one of the valid values.\r\n        // By specifying nothing, the snippet will calculate the \r\n        // change frequency of a document relative to the\r\n        // whole set of documents, or calculate it based on\r\n        // the date difference.\r\n        // "always", "hourly", "daily", "weekly", "monthly",\r\n        // "yearly", "never" - Force this value for every document\r\n        // "" - Calculate change frequency from last mod date\r\n        $forcechangefreq = "";\r\n\r\n        // ***********************************\r\n        // END CONFIG SETTINGS\r\n        // THE REST SHOULD TAKE CARE OF ITSELF\r\n        // ***********************************\r\n\r\n        $children = $funcEtomite->getActiveChildren($listParent, "menuindex", "ASC", "id, editedon, searchable");\r\n        foreach($children as $child) {\r\n            $id = $child[''id''];\r\n            $url = $websiteurl . "[~" . $id . "~]";\r\n\r\n            $date = $child[''editedon''];\r\n            $lastmoddate = $date;\r\n            $date = date("Y-m-d", $date);\r\n\r\n            $searchable = $child[''searchable''];\r\n            if ($searchable) {\r\n                // Get the date difference\r\n                $datediff = datediff("d", $date, date("Y-m-d"));\r\n                if ($datediff <= 1) {\r\n                    $priority = "1.0";\r\n                    $update = "daily";\r\n                } elseif (($datediff > 1) && ($datediff <= 7)) {\r\n                    $priority = "0.75";\r\n                    $update = "weekly";\r\n                } elseif (($datediff > 7) && ($datediff <= 30)) {\r\n                    $priority = "0.50";\r\n                    $update = "weekly";\r\n                } else {\r\n                    $priority = "0.25";\r\n                    $update = "monthly";\r\n                } \r\n\r\n                $output .= "<url>\\n";\r\n\r\n                $output .= "<loc>$url</loc>\\n";\r\n\r\n                if ($showlastmoddate) {\r\n                    if (!$showlongtimeformat) {\r\n                        $lastmoddate = date("Y-m-d", $lastmoddate + $server_offset_time);\r\n                    } else {\r\n                        $lastmoddate = date("Y-m-d\\TH:i:s", $lastmoddate + $server_offset_time) . $GMT_value;\r\n                    } \r\n                    $output .= "<lastmod>$lastmoddate</lastmod>\\n";\r\n                } \r\n\r\n                if ($showchangefreq) {\r\n                    if ($forcechangefreq == "") {\r\n                        $output .= "<changefreq>$update</changefreq>\\n";\r\n                    } else {\r\n                        $output .= "<changefreq>$forcechangefreq</changefreq>\\n";\r\n                    }\r\n                } \r\n\r\n                if ($showpriority) {\r\n                    $output .= "<priority>$priority</priority>\\n";\r\n                } \r\n\r\n                $output .= "</url>\\n";\r\n            } \r\n\r\n            if ($funcEtomite->getActiveChildren($child[''id''])) {\r\n                $output .= MakeMap($funcEtomite, $child[''id'']);\r\n            } \r\n        } \r\n        return $output;\r\n    } \r\n    $MakeMapDefined = true;\r\n} \r\n\r\n$out = "<?xml version=\\"1.0\\" encoding=\\"UTF-8\\"?>\\n";\r\nif ($validateschema) {\r\n    $out .= "<urlset xmlns:xsi=\\"http://www.w3.org/2001/XMLSchema-instance\\"\\n";\r\n    $out .= "         xsi:schemaLocation=\\"http://www.sitemaps.org/schemas/sitemaps/0.9\\n";\r\n    $out .= "         http://www.sitemaps.org/schemas/sitemaps/sitemap.xsd\\"\\n";\r\n    $out .= "         xmlns=\\"http://www.sitemaps.org/schemas/sitemap/0.9\\">\\n";\r\n} else {\r\n    // $out .= "<urlset xmlns=\\"http://www.google.com/schemas/sitemap/0.84\\">\\n";\r\n    $out .= "<urlset xmlns=\\"http://www.sitemaps.org/schemas/sitemap/0.9\\">\\n";\r\n}\r\n\r\n// Produce the sitemap for the main web site\r\n$out .= MakeMap($etomite, 0);\r\n\r\n// To also list documents in unpublished repository folders,\r\n// place an additional call to MakeMap here for each one, e.g. \r\n// $out .= MakeMap($etomite, 8);\r\n// where 8 is the document id of the unpublished repository folder.\r\n\r\n$out .= "</urlset>";\r\n\r\nreturn $out;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(18, 'ListGlobal', 'A menu snippet that shows only the top level pages', '// ------------------------\r\n// Snippet: ListGlobal\r\n// ------------------------\r\n// Version 1.0\r\n// Date: 2008-03-28\r\n// By Ralph A Dahlgren\r\n// Added LGlob_isfolder indicator class support\r\n//\r\n// Version: 0.6e\r\n// Date: 2005.07.01\r\n// jaredc@honeydewdesign.com\r\n//\r\n// Snippet for listing global list of links or sections\r\n// (Published pages who''s parent is root). Highlight ability\r\n// for current section.\r\n\r\n// $node [ int ]\r\n// Id of what you want to consider the "root" of the site or section.\r\n// For instance, if you branch off several sections from the 0 root level\r\n// based on languages, you might want to set the language home page as\r\n// the root. Otherwise it will default to 0 which is the site root. It\r\n// will also default to 0 when 0 is the literal root. Settable in snippet\r\n// call with $LGlob_node:\r\n// [[ListGlobal?LGlob_node=7]]\r\n   $node = 0;\r\n\r\n// STYLES\r\n// .LGlob_list     ul element of list\r\n// .LGlob_active   li of section you are in\r\n// .LGlob_isfolder displays an indicator that this item is a folder\r\n\r\n// -----------------------\r\n// END CONFIG\r\n// -----------------------\r\n\r\n// Override default node with snippet call if necessary\r\n$node = (isset($LGlob_node)) ? $LGlob_node : $node;\r\n\r\n// Determine correct node to consider parent\r\n$tempPageInfo = $etomite->getPageInfo($etomite->documentIdentifier,0,''parent'');\r\n$thisParent = $tempPageInfo[''parent''];\r\n\r\n// Change root node if necessary\r\nif ($node && !$thisParent){\r\n  $node = 0;\r\n}\r\n\r\n$globalKids = $etomite->getActiveChildren\r\n(\r\n  $id=$node,\r\n  $sort=''menuindex'',\r\n  $dir='''',\r\n  $fields=''id, pagetitle, longtitle, description, alias, parent, isfolder, showinmenu'',\r\n  $limit="",\r\n  $showhidden=false\r\n);\r\n$sectionId = $etomite->documentIdentifier;\r\nwhile ( ($pageInfo = $etomite->getPageInfo($sectionId,0,''parent'')) && ($pageInfo[''parent''] != $node ) ) {\r\n  $sectionId = $pageInfo[''parent''];\r\n}\r\n$output = ''<ul class="LGlob_list">'';\r\n$globalCount = 0;\r\nforeach ($globalKids as $kid)\r\n{\r\n  $output .= ''<li'';\r\n  // empty the $class variable\r\n  $class = "";\r\n  // START:conditional class assignments\r\n  // conditionally assign $active\r\n  $active = ($kid[''id''] == $sectionId) ? "LGlob_active " : "";\r\n  // conditionally assign $isfolder\r\n  $isfolder = ($kid[''isfolder''] == 1) ? "LGlob_isfolder " : "";\r\n  // combine $active and $isfolder and remove any leading or trailing spaces\r\n  $class = trim($active.$isfolder);\r\n  // if both $isfolder and $active are set, assign a combined class\r\n  if($isfolder != "" && $active != "") $class = "LGlob_isfolder_active";\r\n  // if there is a class assignment, create the class, otherwise assign null\r\n  $class = ($class != "") ? " class=\\"$class\\"" : null;\r\n  // END:conditional class assignments\r\n  $output .= $class.''><a href="[~''.$kid[''id''].''~]" '';\r\n  $output .= ''title="''.$kid[''longtitle''].''">'';\r\n  $output .= $kid[''pagetitle''].''</a></li>'';\r\n  $globalCount++;\r\n}\r\n$output .= ''</ul>'';\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(19, 'RelatedInfo', 'Output a related chunk into the document', '// Snippet name: RelatedInfo\r\n// Snippet description: Outputs a related chunk into the document\r\n// Revision: 1.0 ships with Etomite 0.6.1-Final\r\n// Author: Lloyd Borrett - 2006-04-09\r\n\r\n// Description:\r\n//   Outputs a chunk into the document based on the \r\n//   document''s alias/id, and optionally, a prefix \r\n//   passed to the chunk.\r\n\r\n// Usage:\r\n//   Insert [[RelatedInfo]] or [[RelatedInfo?prefix=<YourPrefix>]]\r\n//   in your template where you want the required document \r\n//   specific content to appear.\r\n//   e.g. [[RelatedInfo]], [[RelatedInfo?prefix=RightColumn]],\r\n//   [[RelatedInfo?prefix=MiddleColumn]] etc.\r\n//   Create a chunk called "RelatedInfo-<value>" and/or \r\n//   "<YourPrefix>-<value>" for each document where you want \r\n//   to display document related content.\r\n\r\n//   "<value>" is the document alias (if specified), or the \r\n//   document id number if there is no alias value.\r\n//   "<YourPrefix>" is a prefix value passed to the chunk.\r\n\r\n//   For example: "RelatedInfo-home", "RelatedInfo-1",\r\n//   "MiddleColumn-home", "MiddleColumn-1" etc.\r\n\r\n//   The snippet will insert the content of your "RelatedInfo-<value>" and/or\r\n//   "<YourPrefix>-<value>" chunks into the appropriate document.\r\n\r\n//   If there is no output from "RelatedInfo-<value>" and/or "<YourPrefix>-<value>",\r\n//   typically because the chunks don''t exist, the you can request that the default\r\n//   "RelatedInfo" or "<YourPrefix>" chunks are used, if they exist.\r\n\r\n// Problem 1:\r\n//   You want to be able to put some content into a section of \r\n//   your document template. But you would like to be able to have \r\n//   different content for different documents.\r\n//   Typically this might be document related content for another \r\n//   column or something similar.\r\n\r\n// Solution 1:\r\n//   Insert [[RelatedInfo]] into your template where you want the content to appear.\r\n//   Now create a chunk called "RelatedInfo-<value>" for each document where you want\r\n//   document specific content to appear.\r\n//   For example, if you have a document with an alias "productx", \r\n//   the chunk would be called "RelatedInfo-productx".\r\n//   If the document has no alias, then it''s id value is used, \r\n//   for example "RelatedInfo-23".\r\n//   Into the "RelatedInfo-<value>" chunk you can put the content you want,\r\n//   and/or calls to other chunks and snippets.\r\n//   If you don''t have document specific content for that document, \r\n//   then you can let the default content from the "RelatedInfo" chunk \r\n//   be output, if it exists.\r\n//   If there is no "RelatedInfo-<value>" or "RelatedInfo" chunks, \r\n//   then nothing is output.\r\n\r\n// Problem 2:\r\n//   Okay so you can use [[RelatedInfo]] to do document specific \r\n//   content for say your middle column.\r\n//   But on some documents you might also might want some page \r\n//   specific extra content in another part of the document. \r\n//   For example, the right column.\r\n\r\n// Solution 2:\r\n//   Insert [[RelatedInfo?prefix=<YourPrefix>]] into your template \r\n//   where you want the content to appear.\r\n//   Now create a chunk called "<YourPrefix>-<value>" for each page \r\n//   where you want this document specific content to appear.\r\n//   For example, you want to put some content into the right \r\n//   column of your template.\r\n//   So you put [[RelatedInfo?prefix=RightColumn]] into your template.\r\n//   And if you have a document with an alias "productx", the chunk would be\r\n//   called "RightColumn-productx". If the document has no alias, \r\n//   then it''s id value is used, for example "RightColumn-23".\r\n//   Into the "<YourPrefix>-<value>" chunk you can put the content you want,\r\n//   and/or calls to other chunks and snippets.\r\n//   If you don''t have document specific content for that document, \r\n//   you can let the default content from the "<YourPrefix>" chunk \r\n//   be output, if it exists.\r\n//   If there is no "<YourPrefix>-<alias>" or "<YourPrefix>" chunks, \r\n//   then nothing is output.\r\n\r\n// Explanation:\r\n//   The power of this snippet is that a chunk doesn''t have to just \r\n//   contain raw HTML code.\r\n//   The chunk can also have calls to other chunks, and even calls to snippets.\r\n//   Thus each document specific chunk you create can be extremely \r\n//   flexible in what gets  put into your document, with you having \r\n//   to duplicate raw HTML code here, there and everywhere.\r\n\r\n//   (So much to explain such a simple snippet!)\r\n\r\n\r\n// Configuration Setting\r\n\r\n// $showDefaultCrumb [true | false]\r\n// If there is no output from calling the crumb for the specific document, \r\n// which typically occurs if you haven''t created the crumb, \r\n// instead of getting nothing you can ask for a default crumb \r\n// to be used by setting this value to true. \r\n// Of course, if you don''t set up a default crumb, you still get nothing. \r\n// If you don''t want to have this feature enabled just set this value to false.\r\n$showDefaultCrumb = true;\r\n\r\n$output = "";\r\n\r\nif (!isset($prefix)) {\r\n $prefix = "RelatedInfo";\r\n} else {\r\n  if ($prefix == "") {\r\n    $prefix = "RelatedInfo";\r\n  }\r\n}\r\n\r\n$alias = $etomite->documentObject[''alias''];\r\nif ($alias == "") {\r\n  $alias = $etomite->documentIdentifier;\r\n}\r\n\r\n$output .= $etomite->putChunk($prefix.''-''.$alias);\r\nif ($output == "" && $showDefaultCrumb) {\r\n  $output .= $etomite->putChunk($prefix);\r\n}\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(20, 'ListChildOrSibs', 'Menu Snippet to show all child pages, or siblings', '// ------------------------\r\n// Snippet: ListChildOrSibs\r\n// ------------------------\r\n// Version: 0.6k\r\n// Date: 2005.07.22\r\n// jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show all child pages, or siblings\r\n// if there are no children pages, with or without descriptions, in a\r\n// list.\r\n\r\n// Configuration Settings\r\n\r\n   // $removeNewLines [ true | false ]\r\n   // This setting will remove white space from between <ul> and <li>\r\n   // items in HORIZONTAL lists, so the list can be styled in IE.\r\n   // This makes it hard to read the source code- set to false for\r\n   // troubleshooting or if your CSS doesn''t quite seem to work.\r\n   $removeNewLines = true;\r\n\r\n  // $titleOfList [ string ]\r\n  // If you would like to give your list a generic title this is the place to do it.\r\n  // If you don''t want a title, set this to be an empty string\r\n  // $titleOfList = '''';\r\n  // If you want to use the current page title as the title\r\n  // then set to ''p''\r\n  // $titleOfList = ''p'';\r\n  // Or set in the snippet call with $title:\r\n  // [[ListChildOrSibs?title=Your title here]]\r\n  $titleOfList = '''';\r\n\r\n  // $includeDescription [ true | false ]\r\n  // Set to true if you want to include the description, can be\r\n  // overridden by snippet variable $LCOS_showDesc [ 0 | 1 ]\r\n  $includeDescription = false;\r\n  \r\n  // $linkTitle [ ''pagetitle'' | ''description'' | ''longtitle'' ]\r\n  // The title of links (in the <a> tag) can be set to use either the\r\n  // description, the longtitle, or pagetitle. The title will default to\r\n  // pagetitle if the desired field is empty.\r\n  $linkTitle = ''description'';\r\n\r\n  // $maxChildSibs [ int ]\r\n  // Don''t let lists of links get away from you. If you want to limit\r\n  // them, provide a max number. 0 = unlimited.\r\n  $maxChildSibs = 0;\r\n\r\n  // $subSibsForChildren [ true | false ]\r\n  // If you want to substitute sibling documents for children when\r\n  // there are no children, set to true.\r\n  $subSibsForChildren = true;\r\n  \r\n  // $showSibsOfUnPubParent [ true | false ]\r\n  // Sometimes when you have an archive folder (unpublished) filled with\r\n  // LOTS of documents, you don''t want all those documents appearing as\r\n  // siblings (assuming the current document has no children of its own).\r\n  // This option, when set to false, will first try to show children as \r\n  // usual. If there are no children, it will look at the parent (to\r\n  // show siblings). If the parent is unpublished however, it will move\r\n  // to its parent and so on until it finds a published folder with\r\n  // published children to list.\r\n  $showSibsOfUnPubParent = false;\r\n  \r\n  // $showSelfAsSib [ true | false ]\r\n  // When a document has no children, and no other siblings, this variable\r\n  // will determine if the menu shows itself (sibling mode,\r\n  // $showSelfAsSib = true) or all children of the next higher folder\r\n  // ($showSelfAsSib = false).\r\n  $showSelfAsSib = true;\r\n  \r\n  // $titleAsLink [ true | false ]\r\n  // If the title document is not the current document, true will make the\r\n  // title a link to the title document. This happens on lists showing \r\n  // siblings of current page.\r\n  $titleAsLink = true;\r\n\r\n\r\n// Styles\r\n  // These are the styles used in this snippet:\r\n\r\n  //\r\n  // .LCOS_box           A <div> surrounding the entire thing, list and title\r\n  // .LCOS_title         Title of the list\r\n  // .normal          The class of the <ul> itself\r\n  // .LCOS_child         The class of the <li>\r\n  // .LCOS_current       A <span> wrapped around the current page if in list\r\n  //                     instead of an <a> tag.\r\n  // .LCOS_description   The <span> surrounding the description\r\n\r\n// -------------------------------\r\n// End Config\r\n// The rest takes care of itself\r\n// -------------------------------\r\n\r\n// Initialize things\r\n$nonIeSpace = "\\n";\r\n$nlSpace = ($removeNewLines)? "" : $nonIeSpace ;\r\n$showDescription = (isset($LCOS_showDesc))? $LCOS_showDesc :$includeDescription ;\r\n$titleOfList = isset($title)? $title : $titleOfList;\r\n$lcosOutput = '''';\r\n\r\n// Get current page info if page is cached\r\n$pageCached = ($etomite->documentObject)? false : true ;\r\nif ($pageCached){\r\n  $currentPageInfo = $etomite->getPageInfo($etomite->documentIdentifier,0,''pagetitle,parent'');\r\n}\r\n$currentPagetitle = ($pageCached)? $currentPageInfo[''pagetitle''] : $etomite->documentObject[''pagetitle''] ;\r\n$currentPageParent = ($pageCached)? $currentPageInfo[''parent''] : $etomite->documentObject[''parent''] ;\r\n\r\n// Build lists\r\n$children = $etomite->getActiveChildren($etomite->documentIdentifier, ''menuindex ASC,pagetitle'', ''ASC'', ''id,pagetitle,description,longtitle'');\r\n$useParent = false;\r\n\r\nif (!$children && $subSibsForChildren && $currentPageParent!=0){\r\n\r\n  if (!$showSibsOfUnPubParent){\r\n    $goodParentId = $currentPageParent;\r\n    do {\r\n      // get parent document info\r\n      $pDoc = $etomite->getPageInfo($goodParentId, 0, $fields=''id, pagetitle, published, deleted, parent'');\r\n      // check for pub status and children\r\n      $children = $etomite->getActiveChildren($pDoc[''id''], ''menuindex ASC,pagetitle'', ''ASC'', ''id,pagetitle,description,longtitle'');\r\n      if (\r\n          $pDoc[''published''] && \r\n          !$pDoc[''deleted''] && \r\n          (\r\n          count($children) > 1 ||\r\n          $children && $showSelfAsSib || \r\n          (count($children) == 1 && !$showSelfAsSib && $etomite->documentIdentifier != $children[0][''id''] ) ||\r\n          (count($children) > 1 && !$showSelfAsSib)\r\n          )\r\n        ){\r\n        $pubParent = true; // trigger end of searching\r\n        $useParent = true; // to use correct page title\r\n        $parentName = $pDoc[''pagetitle'']; // assign correct page title\r\n        $parentId = $pDoc[''id''];\r\n      } else {\r\n        $goodParentId = $pDoc[''parent''];\r\n        $pubParent = false;\r\n        $children = '''';\r\n      }\r\n    } while (!$pubParent && $goodParentId != 0);\r\n    \r\n  } else { // end if !$showSibsOfUnPubParent\r\n    $children = $etomite->getActiveChildren($currentPageParent, ''menuindex ASC,pagetitle'', ''ASC'', ''id,pagetitle,description,longtitle'');\r\n    $useParent = true;\r\n    $parentId = $currentPageParent;\r\n    $parent = $etomite->getPageInfo($currentPageParent);\r\n    $parentName = $parent[''pagetitle''];    \r\n  }\r\n}\r\n\r\nif ($children){\r\n  if (!$useParent){\r\n    $titleOfList = ($titleOfList == ''p'')? $currentPagetitle : $titleOfList ;\r\n  } else {\r\n    if ($titleOfList == ''p''){\r\n      $titleOfList = ($titleAsLink)? ''<a href="[~''.$parentId.''~]" title="''.$parentName.''">'' . $parentName . ''</a>'' : $parentName ;\r\n    } else {\r\n      $titleOfList = $titleOfList;\r\n    }\r\n  }\r\n  // Div around the whole\r\n  $lcosOutput .= ''<div class="LCOS_box">''.$nonIeSpace;\r\n  // Title if any\r\n  $lcosOutput .= ($titleOfList)? ''<div class="LCOS_title">''. $titleOfList.''</div>''.$nonIeSpace : '''' ;\r\n  // Start list\r\n  $lcosOutput .= ''<ul class="normal">''.$nlSpace;\r\n\r\n  for ($c=0; ($c < count($children)) && (!$maxChildSibs || ($c < $maxChildSibs)) ; $c++){\r\n    $onCurrentPage = ($children[$c][''id'']==$etomite->documentIdentifier)? true : false ;\r\n    $lcosOutput .= ''<li class="LCOS_child">'';\r\n    if ($onCurrentPage){\r\n      $lcosOutput .= ''<span class="LCOS_current">'';\r\n    } else {\r\n      $lcosOutput .= ''<a href="[~''.$children[$c][''id''].''~]" '';\r\n      $useLinkTitle =($children[$c][$linkTitle])? $children[$c][$linkTitle] : $children[$c][''pagetitle''] ;\r\n      $lcosOutput .= ''title="''.$useLinkTitle.''">'';\r\n    }\r\n    $lcosOutput .= $children[$c][''pagetitle''];\r\n    $lcosOutput .= ($onCurrentPage)? ''</span>'' : ''</a>'';\r\n    $lcosOutput .= ($showDescription )?''<span class="LCOS_description">''.$children[$c][''description''].''</span>'' : '''';\r\n    $lcosOutput .= ''</li>''.$nlSpace;\r\n  } // end foreach\r\n  $lcosOutput .= ''</ul>''.$nlSpace; //end list\r\n  $lcosOutput .= ''</div>''.$nonIeSpace;\r\n\r\n} // end if children exist\r\n\r\n// send to parser\r\nreturn $lcosOutput;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(21, 'getSidebar', 'Queries for and displays sidebar content stored in unpublished documents.', '// Snippet: getSidebar\r\n// Author: Ralph A. Dahlgren\r\n// Origin: Conceptual design by Ian Smith (cathode) of http://www.n-vent.com\r\n// Created: 2007-03-01\r\n// Revised: Lloyd Borrett on 2007-03-16\r\n// Revision: 20070316\r\n// Revised: Ralph A. Dahlgren on 2008-04-17\r\n// Revision: 20080417\r\n//\r\n// Purpose: Displays sidebar content stored in unpublished documents.\r\n//\r\n// Usage: [ !getSidebar\r\n//          ?doc=sidebar\r\n//          &chunk=chunk_name\r\n//          &class=[false|0] | someclass\r\n//            if not specified then class = column\r\n//            if false|0 then the div isn''t output\r\n//          &column=pagetitle\r\n//          &folder=123\r\n//          &recursive=[false|0] (anything else equates to true|1)\r\n//          &wildcard=[true|1] (anything else equates to false|0)\r\n//          &wrapper=[false|0] | somewrapper\r\n//            if not specified then wrapper = "sidebar_wrapper"\r\n//            if false|0 then the div isn''t output\r\n//        ! ]\r\n/*\r\nTypical snippet call: [ !getSidebar?doc=sidebar! ]\r\n\r\nThis snippet looks for an unpublished child document with a page title of "sidebar".\r\nIf not found, it looks above for an unpublished sibling titled "sidebar".\r\nIf not found, it looks for an unpublished doc adjacent to it''s parent...\r\nand so-on to the topmost level.\r\n\r\nAn example: Picture a website with 4 top level sections, each section has\r\nmultiple documents underneath it. Each section needs a single sidebar of\r\nrelated information, examples would be "downloads", "links" or "more info."\r\nEvery document in each section needs this same sectional sidebar. To make this\r\nwork, just put [ !getSidebar?doc=downloads! ] into the template. Then, within\r\neach section, create an unpublished document with the page title of "downloads."\r\nThis will display the proper downloads sidebar for every document in the\r\nwebsite. If one section doesn''t need a sidebar, simply do not create one for\r\nthat section. Also, if a single document needs it''s own version of a sidebar,\r\njust give it a child document with the same title and it''ll override the\r\nparent sidebar.\r\n\r\nOther possible uses: Using CSS and customized snippet call parameters you can\r\ndo quite a bit with this snippet. The snippet can be used in page Templates,\r\nin Documents, or within Chunks. Use it to display multiple category specific\r\nimages. Use it to display content related information. Configure it via\r\nsnippet call parameters to do whatever you need it to do - it''s that flexible.\r\n*/\r\n\r\n// Define what to look for as part of a wildcard search (default="sidebar")\r\n// This will cause the query to look for "sidebar", "sidebar2", "somesidebar", etc...\r\n// Example: doc=MoreInfo would find "MoreInfo1", "MoreInfo2", etc...\r\n$doc = isset($doc) ? $doc : "sidebar";\r\n\r\n// Define the table column to use for lookups (default="pagetitle")\r\n// Example: column=longtitle would cause the longtitle column to be used for querying\r\n$column = isset($column) ? $column : "pagetitle";\r\n\r\n// Define an optional folder id to use instead of the current parent folder\r\n// Example: folder=123 would force the query to search folder id 123 for results\r\n$folder = isset($folder) ? $folder : $etomite->documentIdentifier;\r\n\r\n// Define the css class to assign to each sidebar item (defaults to the value of $column)\r\n// If $column is used then each item can have its own css style\r\n// CSS Example: .sidebar{...} .sidebar2{...} .somesidebar{...}\r\n// Example: class=sideBar would cause .sideBar to be used for all items\r\n$class = isset($class) ? $class : "";\r\nif(in_array($class, array("false","0")))\r\n{\r\n  $class = "false";\r\n}\r\nif($class == "")\r\n{\r\n  $class = "{".$column."}";\r\n}\r\n\r\n// Determine whether or not a recursive search back to the docroot should be performed\r\n// The only values that will stop recursion are recursive=[false|0]\r\n$recursive = (isset($recursive) && in_array($recursive, array("false","0"))) ? false : true;\r\n\r\n// Determine whether or not a wildcard search should be performed\r\n// The only values that will stop a wildcard search are wildcard=[true|1]\r\n$wildcard = (isset($wildcard) && in_array($wildcard, array("true","1"))) ? true : false;\r\n\r\n// Define optional wrapper open and close markup which will surround all sidebar markup\r\n// The default action is to use the wrapper code below which can be modifed as needed\r\n$wrapper = isset($wrapper) ? $wrapper : "";\r\nif(in_array($wrapper, array("false","0")))\r\n{\r\n  $wrapper = "false";\r\n}\r\nif ($wrapper == "")\r\n{\r\n  $wrapper = "sidebar_wrapper";\r\n}\r\n\r\nif($wrapper = "false")\r\n{\r\n  $wrapper_open = "";\r\n  $wrapper_close = "";\r\n}\r\nelse\r\n{\r\n  $wrapper_open = "<div class=\\"" . $wrapper . "\\">";\r\n  $wrapper_close = "</div> <!-- end " . $wrapper . " -->";\r\n}\r\n\r\n// Define the template markup to be used in rendering each resultset item\r\n// Note: an alternate method would be to use $tpl = $etomite->getChunk("chunk_name");\r\n// to retrieve markup stored in a Chunk.\r\nif(isset($chunk))\r\n{\r\n  $tpl = $etomite->getChunk($chunk);\r\n}\r\nelse\r\n{\r\n  if($class == "false")\r\n  {\r\n    $tpl =\r\n<<<END\r\n<h1>{longtitle}</h1>\r\n{content}\r\nEND;\r\n  }\r\n  else\r\n  {\r\n    $tpl =\r\n<<<END\r\n<div class="$class">\r\n<h1>{longtitle}</h1>\r\n{content}\r\n</div> <!-- end $class -->\r\nEND;\r\n  }\r\n}\r\n\r\n// Define the document columns to be returned in the result set\r\n// Examples: "*" for all columns OR "alias,content"\r\n$fields = "id,pagetitle,longtitle,description,alias,content";\r\n\r\n// Look for sidebars by recursively moving back towards the doc root\r\nwhile(($folder >= 0) && (count($rs) < 1))\r\n{\r\n  // Define the MySQL WHERE clause to be used by the query\r\n  // If wildcard=[true|1] then we do a wildcard search, otherwise an exact search\r\n  if($wildcard)\r\n  {\r\n    $where =\r\n      "`parent`=$folder\r\n        AND `$column` LIKE ''%$doc%''\r\n        AND `published`=0"\r\n    ;\r\n  }\r\n  else\r\n  {\r\n    $where =\r\n      "`parent`=$folder\r\n        AND `$column`=''$doc''\r\n        AND `published`=0"\r\n    ;\r\n  }\r\n  // Perform the actual database query\r\n  // Variables such as $from, $sort, and $dir have been hard-coded but could\r\n  // be made dynamic if needed\r\n  // See getIntTableRows() API function documentation for more information\r\n  $rs = $etomite->getIntTableRows\r\n  (\r\n    $fields,\r\n    $from="site_content",\r\n    $where,\r\n    $sort="alias",\r\n    $dir="ASC",\r\n    $limit="",\r\n    $push=true,\r\n    $addPrefix=true\r\n  );\r\n  // Retrieve the next parent if $recursive=true and $folder > 0, otherwise\r\n  // set to -1 to stop the loop\r\n  $folder = ($folder > 0 && $recursive) ? $etomite->parents[$folder] : -1;\r\n}\r\n\r\n// If results were returned process them using our template markup\r\n// See mergeCodeVariables() API function documentation for more information\r\nif($rs)\r\n{\r\n  // START::Pre-processing routines\r\n  // Example: (Not exactly a practical example, but it gets the idea across.)\r\n  /*\r\n  foreach($rs as $row) {\r\n    // Capitalize the first character of each word in pagetitle\r\n    $row[''pagetitle''] = ucwords(strtolower($row[''pagetitle'']));\r\n    ... additional per-record pre-processing code ...\r\n  }\r\n  */\r\n  // END::Pre-processing routines\r\n\r\n  $output .= ($wrapper_open != "") ? $wrapper_open : "";\r\n  $output .= $etomite->mergeCodeVariables\r\n  (\r\n    $tpl,\r\n    $rs,\r\n    $prefix="{",\r\n    $suffix="}",\r\n    $oddStyle="",\r\n    $evenStyle="",\r\n    $tag=""\r\n  );\r\n  $output .= ($wrapper_close != "") ? $wrapper_close : "";\r\n}\r\n\r\n// START::Post-processing routine(s)\r\n// Example:\r\n// Remove any empty header tags\r\n$output = str_replace("<h1></h1>","",$output);\r\n// END::Post-processing routine(s)\r\n\r\n// Return the rendered markup to caller\r\nreturn $output;\r\n// END::getSidebar\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(22, 'MetaTagsExtra', 'Returns XHTML for document meta tags', '/**\r\n * ---------------------------\r\n * Snippet: MetaTagsExtra\r\n * ---------------------------\r\n * Version: 2.6 2007-04-30\r\n * Etomite Version: 0.6 +\r\n * \r\n * Description:\r\n *  Returns XHTML for document meta tags: \r\n *   Content-Type, Content-Language, Generator,\r\n *   Title, Description, Keywords, Abstract, Author, Copyright, \r\n *   Robots, Googlebot, Cache-Control, Pragma, Expires, Last Modified,\r\n *   Google Map Key, Google and Yahoo Sitemap Verification Keys,\r\n *   SafeSurf / PICS-Label, No-Email-Collection, Distribution and Rating.\r\n *  Can also return XHTML for Dublin Core Metadata Initiative meta tags:\r\n *   DC.format, DC.language, DC.title, \r\n *   DC.description, DC.subject, DC.title.alternative,\r\n *   DC.publisher, DC.creator, DC.rights,\r\n *   DC.date.created, DC.date.modified, DC.date.valid and DC.identifier.\r\n *  Can also return the GeoURL and GeoTags meta tags:\r\n *   DC.title, ICBM, geo.position, geo.placename and geo.region.\r\n * \r\n * Snippet Author:\r\n *   Miels with mods by Lloyd Borrett (lloyd@borrett.id.au)\r\n * \r\n * Version History:\r\n * 1.3 - Lloyd Borrett added the Robots meta tag based \r\n * on the idea in the SearchableSE snippet by jaredc\r\n * \r\n * 1.4 - Lloyd Borrett added the Abstract meta tag\r\n * based on the Site Name and the Long Title.\r\n * Also added the Generator meta tag based on the Etomite version details.\r\n * The Robots meta tag is now only output if the document is non-searchable,\r\n * to reduce XHTML bloat. The Googlebot meta tag is now also output \r\n * when the document is non-searchable.\r\n * \r\n * 1.5 - Lloyd Borrett added no-cache directives via the Cache-Control \r\n * and Pragma meta tags if the document is non-cacheable.\r\n * Abstract meta tag uses the document description if long title not set.\r\n * Cleaned up some other tests.\r\n * \r\n * 1.6 - 2006-01-26 - Lloyd Borrett cleaned up some code.\r\n * \r\n * 1.7 - 2006-01-27 - Lloyd Borrett\r\n * Added support for the Distribution and Rating meta tags.\r\n * Copyright meta tag can now include a year range being from either \r\n * a site creation year to the current year, or from the year the \r\n * document was created to the current year, e.g. 2005-2006.\r\n * Added ability to specify a site wide author, and thus be able to\r\n * skip looking up document author details.\r\n * \r\n * 1.8 - 2006-01-27 - Lloyd Borrett\r\n * Current year now based on local time using the Etomite\r\n * Server Offset Time configuration setting\r\n * \r\n * 1.9 - 2006-03-08 - Lloyd Borrett\r\n * Dates in meta tags can be output in your choice of ISO 8601\r\n * or RFC 822 formats.\r\n * Dates in the meta tags are now corrected to local time.\r\n * Fixed problem with the generation of the "description" meta tag.\r\n * \r\n * 2.0 - 2006-03-10 - Lloyd Borrett\r\n * Moved the generation of the "content-type", "content-language" \r\n * and "title" meta tags into this snippet.\r\n * Added in support for the Dublin Core Metadata Initiative meta tags.\r\n * \r\n * 2.1 - 2006-03-15 - Lloyd Borrett\r\n * Dropped the choice of date formats. Dublin Core tags now use ISO dates. \r\n * Others tags use RFC 822 dates. This is what is properly supported.\r\n * Added in support for GeoURL (www.geourl.org) and \r\n * GeoTags (www.geotags.com) meta tags.\r\n * \r\n * 2.2 - 2006-04-07 - Lloyd Borrett\r\n * Get the base URL from Etomite instead of it being a configuration option.\r\n * \r\n * 2.3 - 2006-04-21 - Lloyd Borrett\r\n * Changed the way the "generator" meta tag is produced so that it\r\n * better reports the Etomite version details.\r\n * \r\n * 2.4 - 2006-05-04 - Lloyd Borrett\r\n * Couple of fixes as picked up by "bungo".\r\n * Put in the new way to get the base URL from Etomite 0.6.1 Prelude.\r\n * Dropped the use of HTML entities in the copyright details.\r\n * Added a sort to the keywords.\r\n * \r\n * 2.5 - 2006-10-25 - Lloyd Borrett\r\n * Made displaying the cache tags optional.\r\n * \r\n * 2.6 - 2007-04-30 - Lloyd Borrett\r\n * Added support for the no-email-collection meta tag.\r\n * Added support for the Google Map Key, plus the Google \r\n * and Yahoo Sitemap Verification keys.\r\n * Added support for SafeSurf / PICS-Label / ICRA Labels.\r\n * Get the content-type from Etomite system setting.\r\n * Added support for favicon links.  \r\n * \r\n * Snippet Category: Search Engines           \r\n * \r\n * Usage:\r\n * Insert [[MetaTagsExtra]] anywhere in the head section of your template.\r\n * Don''t forget to set the full name of all document authors.\r\n * You can find it at "Manage users" -> your username -> "full name".\r\n * This value is used for the Author and Copyright meta tags.\r\n * \r\n * When you mark a page as "NOT searchable" - a Robots meta tag \r\n * with "noindex, nofollow" is inserted to keep web search engines\r\n * from indexing that document. After all, there''s little value in \r\n * making your Etomite document unsearchable to Etomite, when \r\n * Google still knows where it is! For "searchable" documents, no\r\n * Robots meta tag is inserted. The default is "index, follow", so not\r\n * putting it in reduced HTML bloat.\r\n * A Googlebot meta tag with "noindex, nofollow, noarchive, nosnippet"\r\n * is also output, to tell Google to clean out its cache.\r\n * \r\n * When you mark a page as "non cacheable", no-cache directives \r\n * are inserted via the Cache-Control and Pragma meta tags.\r\n */\r\n\r\n// \r\n// ===== CONFIGURATION: ===================================\r\n\r\n// Provide the content type setting.\r\n// Can set this...\r\n// e.g. $content_type = "text/html; charset=iso-8859-1";\r\n// or have Etomite generate it for you\r\n$content_type = "[*contentType*]; charset=[(etomite_charset)]";\r\n\r\n// Provide the language setting.\r\n$language = "en-au";\r\n\r\n// Distribution can be "global", "local" or "iu"\r\n// If you want no Distribution meta tag use ''''\r\n$distribution = ''global'';\r\n\r\n// Rating can be "14 years", "general", "mature", "restricted" or "safe for kids"\r\n// If you want no Rating meta tag use ''''\r\n$rating = ''general'';\r\n\r\n// Start Date of the web site as used for the copyright meta tag\r\n// To use the document creation date, set this to ''''\r\n$site_start_year = ''2006'';\r\n\r\n// Site Author can be used for the Author and Copyright meta tags\r\n// To use the document author details of each document, set this to ''''\r\n$site_author = ''Insite Architects Pty Ltd'';\r\n\r\n// Provide the full URL of your web site.\r\n// For example: http://www.yourdomain.com/\r\n// NOTE: Please put a / on the end of the web site URL.\r\n// Used to build the DC.identifier tag\r\n// This code worked with 0.6.1 RTM\r\n// global $ETOMITE_PAGE_BASE;\r\n// $websiteurl = $ETOMITE_PAGE_BASE[''www''];\r\n// This code works with 0.6.1 Prelude\r\n$websiteurl = $etomite->config[''www_base_path''];\r\n\r\n// Legal Notice / Terms and Conditions Page\r\n// for the no-email-collection meta tag.\r\n// If you want no no-email-collection meta tag use ''''\r\n$legalterms = "legal-notices.htm";\r\n\r\n// Favicon file name for links\r\n// If you want no favicon links use ''''\r\n$favicon = "favicon.ico";\r\n\r\n// Google Map Key\r\n// If you want no Google Map meta tag use ''''\r\n$gmapkey = "ABQIAAAATHlEPcEjlaOVBbl3hAih5xSCipRF7c95Y7oXHbDT8JTwO0PaDRTU9loAjaq4zJ2Jof4w8k8ZFAcRVg";\r\n\r\n// Google Sitemap Verification Key\r\n// If you want no Google Sitemap Verification meta tag use ''''\r\n$gsitemapkey = "";\r\n\r\n// Yahoo Sitemap Verification Key\r\n// If you want no Yahoo Sitemap Verification meta tag use ''''\r\n$ysitemapkey = "";\r\n\r\n// Provide the latitude of the resource\r\n$latitude = "-37.76991667";\r\n\r\n// Provide the longitude of the resource\r\n$longitude = "145.04075";\r\n\r\n// Provide the place name of the resource\r\n$placename = "Ivanhoe, Victoria, Australia";\r\n\r\n// Provide the ISO 3166 region code of the resource\r\n$region = "au-vi";\r\n\r\n// Safesurf Tags is used to specify if the SafeSurf\r\n// meta tags should also be generated.\r\n// Set to true to generate them, false otherwise.\r\n$safesurf_tags = true;\r\n\r\n// Cache Tags is used to specify if the Cache and Pragma\r\n// meta tags should also be generated.\r\n// Set to true to generate them, false otherwise.\r\n$cache_tags = false;\r\n\r\n// DC Tags is used to specify if the Dublin Core Metadata Initiative\r\n// meta tags should also be generated.\r\n// Set to true to generate them, false otherwise.\r\n$dc_tags = true;\r\n\r\n// Geo Tags is used to specify if the Geo Tags\r\n// meta tags should also be generated.\r\n// Set to true to generate them, false otherwise.\r\n$geo_tags = true;\r\n\r\n// ===== end of configuration =========\r\n\r\n// ===== do not edit below except you know what you are doing ...\r\n// and always BACKUP before changing!!\r\n// ========================================================\r\n\r\n// Initialise variables\r\n$MetaType = "";\r\n$MetaLanguage = "";\r\n$MetaTitle = "";\r\n$MetaGenerator = "";\r\n$MetaDesc = "";\r\n$MetaKeys = "";\r\n$MetaAbstract = "";\r\n$MetaAuthor = "";\r\n$MetaCopyright = "";\r\n$MetaRobots = "";\r\n$MetaGooglebot = "";\r\n$MetaCache = "";\r\n$MetaPragma = "";\r\n$MetaExpires = "";\r\n$MetaEditedOn = "";\r\n$MetaDistribution = "";\r\n$MetaRating = "";\r\n$MetaNoEC = "";\r\n$MetaGMap = "";\r\n$MetaGSMV = "";\r\n$MetaYSMV = "";\r\n$MetaSS = "";\r\n$MetaFaviconLinks = "";\r\n\r\n// The data format of the resource\r\n$DC_format = "";\r\n\r\n// The language of the content of the resource\r\n$DC_language = "";\r\n\r\n// The name given to the resource\r\n$DC_title = "";\r\n\r\n// A textual description of the content and/or purpose of the resource\r\n// Equivalent to "description"\r\n$DC_description = "";\r\n\r\n// The subject and topic of the resource that succinctly\r\n// describes the content of the resource.\r\n// Equivalent to "keywords"\r\n$DC_subject = "";\r\n\r\n// Any form of the title used as a substitute or alternative\r\n// to the formal title of the resource.\r\n// Equivalent to "abstract"\r\n$DC_title_alternative = "";\r\n\r\n// The name of the entity responsible for making the resource available\r\n// Equivalent to "author"\r\n$DC_publisher = "";\r\n\r\n// An entity primarily responsible for making the content of the resource\r\n// Equivalent to "author"\r\n$DC_creator = "";\r\n\r\n// A statement or pointer to a statement about the\r\n// rights management information for the resource\r\n// Equivalent to "copyright"\r\n$DC_rights = "";\r\n\r\n// The date the resource was created in its current form\r\n$DC_date_created = "";\r\n\r\n// The date the resource was last modified or updated\r\n$DC_date_modified = "";\r\n\r\n// The date of validity of the resource.\r\n// Specified as from the creation date to the expiry date\r\n$DC_date_valid = "";\r\n\r\n// A unique identifier for the resource\r\n$DC_identifier = "";\r\n\r\n// The latitude and longitude of the resource\r\n$Geo_position = "";\r\n\r\n// The latitude and longitude of the resource\r\n$Geo_icbm = "";\r\n\r\n// The place name of the resource\r\n$Geo_placename = "";\r\n\r\n// The region of the resource\r\n$Geo_region = "";\r\n\r\n// *** FUNCTIONS ***\r\n\r\nfunction get_local_GMT_offset($server_offset_time) { \r\n // Get the local GMT offset when given the\r\n  // local to Etomite server offset time in seconds\r\n $GMT_offset = date("O");\r\n  $GMT_hr = substr($GMT_offset, 1, 2);\r\n  $GMT_min = substr($GMT_offset, 4, 2);\r\n $GMT_sign = substr($GMT_offset, 0, 1);\r\n  $GMT_secs = (intval($GMT_hr) * 3600) + (intval($GMT_min) * 60);\r\n if ($GMT_sign == ''-'') {\r\n   $GMT_secs = $GMT_secs * (-1);\r\n } \r\n\r\n  // Get the local GMT offset in seconds\r\n  $GMT_local_seconds = $GMT_secs + $server_offset_time;\r\n $GMT_local_secs = abs($GMT_local_seconds); \r\n\r\n // round down to the number of hours\r\n  $GMT_local_hours = intval($GMT_local_secs / 3600); \r\n\r\n // round down to the number of minutes\r\n  $GMT_local_minutes = intval(($GMT_local_secs - ($GMT_local_hours * 3600)) / 60);\r\n  if ($GMT_local_seconds < 0) {\r\n   $GMT_value = "-";\r\n } else {\r\n    $GMT_value = "+";\r\n } \r\n  $GMT_value .= sprintf("%02d:%02d", $GMT_local_hours, $GMT_local_minutes);\r\n return $GMT_value;\r\n} \r\n\r\nfunction get_local_iso_8601_date($int_date, $server_offset_time) { \r\n // Return an ISO 8601 style local date\r\n  // $int_date: current date in UNIX timestamp\r\n  $GMT_value = get_local_GMT_offset($server_offset_time);\r\n $local_date = date("Y-m-d\\TH:i:s", $int_date + $server_offset_time);\r\n $local_date .= $GMT_value;\r\n  return $local_date;\r\n} \r\n\r\nfunction get_local_rfc_822_date($int_date, $server_offset_time) { \r\n // return an RFC 822 style local date\r\n // $int_date: current date in UNIX timestamp\r\n  $GMT_value = get_local_GMT_offset($server_offset_time);\r\n $local_date = date("D, d M Y H:i:s", $int_date + $server_offset_time);\r\n  $local_date .= " " . str_replace('':'', '''', $GMT_value);\r\n  return $local_date;\r\n} \r\n\r\n// ########################################################\r\n// === here begins the actual work: ===\r\n\r\n// *** Start Creating Meta Tags ***\r\n\r\n// *** CONTENT-TYPE ***\r\n$MetaType = " <meta http-equiv=\\"content-type\\" content=\\"" . $content_type . "\\" />\\n";\r\n\r\n// *** DC.FORMAT ***\r\nif ($dc_tags) {\r\n $DC_format = " <meta name=\\"DC.format\\" content=\\"" . $content_type . "\\" />\\n";\r\n} \r\n\r\n// *** CONTENT-LANGUAGE ***\r\n$MetaLanguage = " <meta http-equiv=\\"content-language\\" content=\\"" . $language . "\\" />\\n";\r\n\r\n// *** DC.LANGUAGE ***\r\nif ($dc_tags) {\r\n  $DC_language = " <meta name=\\"DC.language\\" content=\\"" . $language . "\\" />\\n";\r\n} \r\n\r\n// *** GENERATOR ***\r\n$version = $etomite->getVersionData();\r\n$generator = trim($version[''full_appname'']);\r\nif (($generator != "")) {\r\n  $MetaGenerator = " <meta name=\\"generator\\" content=\\"";\r\n $MetaGenerator .= $generator . "\\" />\\n";\r\n} \r\n\r\n$docInfo = $etomite->getDocument($etomite->documentIdentifier);\r\n\r\n// *** DESCRIPTION ***\r\n// Trim and replace double quotes with entity\r\n$description = $docInfo[''description''];\r\n$description = str_replace(''"'', ''&#34;'', trim($description));\r\nif (!$description == "") {\r\n $MetaDesc = " <meta name=\\"description\\" content=\\"$description\\" />\\n";\r\n // *** DC.DESCRIPTION ***\r\n if ($dc_tags) {\r\n   $DC_description = " <meta name=\\"DC.description\\"";\r\n   $DC_description .= " content=\\"$description\\" />\\n";\r\n } \r\n} \r\n\r\n// *** KEYWORDS ***\r\n$keywords = $etomite->getKeywords();\r\nif (count($keywords) > 0) {\r\n  asort($keywords);\r\n $keys = join($keywords, ", ");\r\n  $MetaKeys = " <meta name=\\"keywords\\" content=\\"$keys\\" />\\n";\r\n // *** DC.SUBJECT ***\r\n if ($dc_tags) {\r\n   $keys = join($keywords, "; ");\r\n    $DC_subject = " <meta name=\\"DC.subject\\"";\r\n   $DC_subject .= " content=\\"$keys\\" />\\n";\r\n  } \r\n} \r\n\r\n// *** ABSTRACT ***\r\n// Use the Site Name and the documents Long Title (or Description)\r\n// to build an Abstract meta tag.\r\n$sitename = $etomite->config[''site_name''];\r\n\r\n// Trim and replace double quotes with entity\r\n$sitename = str_replace(''"'', ''&#34;'', trim($sitename));\r\n\r\n$abstract = trim($docInfo[''longtitle'']);\r\nif ($abstract == "") {\r\n  $abstract = $description;\r\n} \r\n\r\n// Replace double quotes with entity\r\n$abstract = str_replace(''"'', ''&#34;'', $abstract);\r\n\r\nif (($sitename != "") || ($abstract != "")) {\r\n $separator = " - ";\r\n if ($sitename == "") {\r\n    $separator = "";\r\n  } \r\n  $MetaAbstract = " <meta name=\\"abstract\\" content=\\"" . $sitename . $separator . $abstract . "\\" />\\n";\r\n\r\n  // *** DC.TITLE.ALTERNATIVE ***\r\n if ($dc_tags) {\r\n   $DC_title_alternative = " <meta name=\\"DC.title.alternative\\"";\r\n   $DC_title_alternative .= " content=\\"" . $sitename . $separator . $abstract . "\\" />\\n";\r\n } \r\n} \r\n\r\n// *** TITLE ***\r\n// Use the Site Name and the documents Page Title and Long Title\r\n// to build the Title meta tag.\r\n// Start with the site name\r\n$title = $sitename;\r\n\r\n// Get the pagetitle, trim and replace double quotes with entity\r\n$pagetitle = str_replace(''"'', ''&#34;'', trim($docInfo[''pagetitle'']));\r\nif ($pagetitle != "") {\r\n  if ($title == "") {\r\n   $title = $pagetitle;\r\n  } else {\r\n    $title .= " - " . $pagetitle;\r\n } \r\n} \r\n\r\n// Get the longtitle, trim and replace double quotes with entity\r\n$longtitle = str_replace(''"'', ''&#34;'', trim($docInfo[''longtitle'']));\r\nif ($longtitle != "") {\r\n if ($title == "") {\r\n   $title = $longtitle;\r\n  } else {\r\n    $title .= " - " . $longtitle;\r\n } \r\n} \r\nif ($title != "") {\r\n $MetaTitle = " <title>" . $title . "</title>\\n";\r\n // *** DC.TITLE ***\r\n if ($dc_tags || $geo_tags) {\r\n    $DC_title = " <meta name=\\"DC.title\\"";\r\n   $DC_title .= " content=\\"" . $title . "\\" />\\n";\r\n } \r\n} \r\n\r\n// *** AUTHOR ***\r\nif ($site_author == '''') {\r\n  $authorid = $docInfo[''createdby''];\r\n  $tbl = $etomite->dbConfig[''dbase''] . "." . $etomite->dbConfig[''table_prefix''] . "user_attributes";\r\n  $query = "SELECT fullname FROM " . $tbl . " WHERE " . $tbl . ".id = " . $authorid . ";";\r\n  $rs = $etomite->dbQuery($query);\r\n  $limit = $etomite->recordCount($rs);\r\n  if ($limit == 1) {\r\n    $resourceauthor = $etomite->fetchRow($rs);\r\n    $authorname = $resourceauthor[''fullname''];\r\n  } \r\n  // Trim and replace double quotes with entity\r\n $authorname = str_replace(''"'', ''&#34;'', trim($authorname));\r\n} else {\r\n $authorname = $site_author;\r\n} \r\nif (!$authorname == "") {\r\n  $MetaAuthor = " <meta name=\\"author\\" content=\\"$authorname\\" />\\n";\r\n // *** DC.PUBLISHER & DC.CREATOR ***\r\n  if ($dc_tags) {\r\n   $DC_publisher = " <meta name=\\"DC.publisher\\" content=\\"$authorname\\" />\\n";\r\n   $DC_creator = " <meta name=\\"DC.creator\\" content=\\"$authorname\\" />\\n";\r\n } \r\n} \r\n\r\n// *** COPYRIGHT ***\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n} \r\n\r\n// get the current time and apply the offset\r\n$timestamp = time() + $server_offset_time;\r\n\r\n// Set the current year\r\n$today_year = date(''Y'', $timestamp);\r\n$createdon = date(''Y'', $docInfo[''createdon'']);\r\nif ($site_start_year == '''') {\r\n  if ($today_year != $createdon) {\r\n    $copydate = $createdon . "-" . $today_year;\r\n } else {\r\n    $copydate = $today_year;\r\n  } \r\n} else {\r\n  if ($today_year != $site_start_year) {\r\n    $copydate = $site_start_year . "-" . $today_year;\r\n } else {\r\n    $copydate = $today_year;\r\n  } \r\n} \r\nif ($authorname == '''') {\r\n  $copyname = $authorname;\r\n} else {\r\n  $copyname = " by " . $authorname;\r\n} \r\n$MetaCopyright = " <meta name=\\"copyright\\" content=\\"Copyright (c) ";\r\n$MetaCopyright .= $copydate . $copyname . ". All rights reserved.\\" />\\n";\r\n\r\n// *** DC.RIGHTS ***\r\nif ($dc_tags) {\r\n $DC_rights = " <meta name=\\"DC.rights\\" content=\\"Copyright (c) ";\r\n $DC_rights .= $copydate . $copyname . ". All rights reserved.\\" />\\n";\r\n} \r\n\r\n// *** ROBOTS and GOOGLEBOT ***\r\n// Determine if this document has been set to non-searchable.\r\n// As the default for the Robots and Googlebot Meta Tags are index and follow,\r\n// these tags are only needed when we don''t want the document searched.\r\nif (!$etomite->documentObject[''searchable'']) {\r\n  $MetaRobots = " <meta name=\\"robots\\" content=\\"noindex, nofollow\\" />\\n";\r\n $MetaGooglebot = " <meta name=\\"googlebot\\" content=\\"noindex, nofollow, noarchive, nosnippet\\" />\\n";\r\n} \r\n\r\n// *** CACHE-CONTROL and PRAGMA ***\r\n// Output no-cache directives via the Cache-Control and Pragma meta tags\r\n// if this document is set to non-cacheable.\r\nif ($cache_tags) {\r\n  $cacheable = $docInfo[''cacheable''];\r\n if (!$cacheable) {\r\n    $MetaCache = " <meta http-equiv=\\"cache-control\\" content=\\"no-cache\\" />\\n";\r\n    $MetaPragma = " <meta http-equiv=\\"pragma\\" content=\\"no-cache\\" />\\n";\r\n  } \r\n} \r\n\r\n// *** DC.DATE.CREATED ***\r\nif ($dc_tags) {\r\n $createdon = get_local_iso_8601_date($docInfo[''createdon''], $server_offset_time);\r\n $created = substr($createdon, 0, 10);\r\n $DC_date_created = " <meta name=\\"DC.date.created\\" content=\\"";\r\n $DC_date_created .= $created . "\\" />\\n";\r\n} \r\n\r\n// *** EXPIRES ***\r\n$unpub_date = $docInfo[''unpub_date''];\r\nif ($unpub_date > 0) {\r\n  $unpubdate = get_local_rfc_822_date($unpub_date, $server_offset_time);\r\n  $MetaExpires = " <meta http-equiv=\\"expires\\" content=\\"$unpubdate\\" />\\n";\r\n  // *** DC.DATE.VALID ***\r\n  if ($dc_tags) {\r\n   $dcunpubdate = get_local_iso_8601_date($unpub_date, $server_offset_time);\r\n   $valid = substr($dcunpubdate, 0, 10);\r\n   $DC_date_valid = " <meta name=\\"DC.date.valid\\" content=\\"";\r\n   $DC_date_valid .= $created . "/" . $valid . "\\" />\\n";\r\n  } \r\n} \r\n\r\n// *** LAST MODIFIED ***\r\n$editedon = get_local_rfc_822_date($docInfo[''editedon''], $server_offset_time);\r\n$MetaEditedOn = " <meta http-equiv=\\"last-modified\\" content=\\"$editedon\\" />\\n";\r\n\r\n// *** DC.DATE.MODIFIED ***\r\nif ($dc_tags) {\r\n  $dceditedon = get_local_iso_8601_date($docInfo[''editedon''], $server_offset_time);\r\n $modified = substr($dceditedon, 0, 10);\r\n $DC_date_modified = " <meta name=\\"DC.date.modified\\" content=\\"";\r\n $DC_date_modified .= $modified . "\\" />\\n";\r\n} \r\n\r\n// *** DISTRIBUTION ***\r\nif (!$distribution == '''') {\r\n $MetaDistribution = " <meta name=\\"distribution\\" content=\\"" . $distribution . "\\" />\\n";\r\n} \r\n\r\n// *** RATING ***\r\nif (!$rating == '''') {\r\n $MetaRating = " <meta name=\\"rating\\" content=\\"" . $rating . "\\" />\\n";\r\n} \r\n\r\n// *** NO EMAIL COLLECTION ***\r\nif (!$legalterms == '''') {\r\n  $MetaNoEC = " <meta name=\\"no-email-collection\\" content=\\"" . $websiteurl . $legalterms . "\\" />\\n";\r\n} \r\n\r\n// *** GOOGLE MAP KEY ***\r\nif (!$gmapkey == '''') {\r\n $MetaGMap = " <meta name=\\"gmapkey\\" content=\\"" . $gmapkey . "\\" />\\n";\r\n} \r\n\r\n// *** GOOGLE SITEMAP VERIFICATION KEY ***\r\nif (!$gsitemapkey == '''') {\r\n $MetaGSMV = " <meta name=\\"verify-v1\\" content=\\"" . $gsitemapkey . "\\" />\\n";\r\n} \r\n\r\n// *** YAHOO SITEMAP VERIFICATION KEY ***\r\nif (!$ysitemapkey == '''') {\r\n  $MetaYSMV = " <meta name=\\"y_key\\" content=\\"" . $ysitemapkey . "\\" />\\n";\r\n} \r\n\r\n// *** SAFESURF CODE ***\r\n// Note: This is a default general SafeSurf and ICRA tag. If your web site requires\r\n// something different, you''ll need to change this.\r\nif ($safesurf_tags) {\r\n $MetaSS = "\\n <link rel=\\"meta\\" href=\\"" . $websiteurl . "labels.rdf\\" \r\n  type=\\"application/rdf+xml\\" title=\\"ICRA labels\\" />\r\n <meta http-equiv=\\"PICS-Label\\" content=''(PICS-1.1\r\n  \\"http://www.icra.org/pics/vocabularyv03/\\" l gen true \r\n  for \\"" . $websiteurl . "\\" r (n 0 s 0 v 0 l 0 oa 0 ob 0 oc 0 od 0 oe 0 of 0 og 0 oh 0 c 0) \r\n  gen true for \\"" . $websiteurl . "\\" r (n 0 s 0 v 0 l 0 oa 0 ob 0 oc 0 od 0 oe 0 of 0 og 0 oh 0 c 0)\r\n  \\"http://www.classify.org/safesurf/\\" L gen true \r\n  for \\"" . $websiteurl . "\\" r (SS~~000 1)\r\n )'' />\\n";\r\n} \r\n\r\n// *** FAVICON FILE LINKS ***\r\nif (!$favicon == '''') {\r\n  $MetaFaviconLinks = "\\n <link rel=\\"shortcut icon\\" href=\\"" . $favicon . "\\" type=\\"image/x-icon\\" />\\n";\r\n} \r\n\r\nif ($dc_tags) {\r\n // *** DC.IDENTIFIER ***\r\n  $url = $websiteurl . "[~" . $etomite->documentIdentifier . "~]";\r\n  $DC_identifier = " <meta name=\\"DC.identifier\\" content=\\"" . $url . "\\" />\\n";\r\n} \r\n\r\nif ($geo_tags) {\r\n  if (($latitude != "") && ($longitude != "")) {\r\n    // *** GEO.ICBM ***\r\n   $Geo_icbm = " <meta name=\\"ICBM\\"";\r\n   $Geo_icbm .= " content=\\"" . $latitude . ", " . $longitude . "\\" />\\n";\r\n    // *** GEO.POSITION ***\r\n   $Geo_position = " <meta name=\\"geo.position\\"";\r\n   $Geo_position .= " content=\\"" . $latitude . ";" . $longitude . "\\" />\\n";\r\n } \r\n\r\n  if ($region != "") {\r\n    // *** GEO.REGION ***\r\n   $Geo_region = " <meta name=\\"geo.region\\"";\r\n   $Geo_region .= " content=\\"" . $region . "\\" />\\n";\r\n  } \r\n\r\n  if ($placename != "") {\r\n   // *** GEO.PLACENAME ***\r\n    $Geo_placename = " <meta name=\\"geo.placename\\"";\r\n   $Geo_placename .= " content=\\"" . $placename . "\\" />\\n";\r\n  } \r\n} \r\n\r\n// *** RETURN RESULTS ***\r\n$output = $MetaType . $MetaLanguage . $MetaGenerator;\r\n$output .= $MetaTitle . $MetaDesc . $MetaKeys;\r\n$output .= $MetaAbstract . $MetaAuthor . $MetaCopyright;\r\n$output .= $MetaRobots . $MetaGooglebot;\r\n\r\nif ($cache_tags) {\r\n  $output .= $MetaCache . $MetaPragma;\r\n} \r\n\r\n$output .= $MetaExpires . $MetaEditedOn;\r\n$output .= $MetaDistribution . $MetaRating;\r\n$output .= $MetaNoEC . $MetaGMap;\r\n$output .= $MetaGSMV . $MetaYSMV;\r\n\r\nif ($dc_tags) {\r\n  $dc_output = $DC_format . $DC_language . $DC_title;\r\n $dc_output .= $DC_description . $DC_subject . $DC_title_alternative;\r\n  $dc_output .= $DC_publisher . $DC_creator . $DC_rights;\r\n $dc_output .= $DC_date_created . $DC_date_modified . $DC_date_valid;\r\n  $dc_output .= $DC_identifier;\r\n if ($dc_output != "") {\r\n   $output .= " \\n" . $dc_output;\r\n } \r\n} \r\n\r\nif ($geo_tags) {\r\n  $geo_output = "";\r\n if (!$dc_tags) {\r\n    $geo_output .= $DC_title;\r\n } \r\n  $geo_output .= $Geo_icbm;\r\n $geo_output .= $Geo_position . $Geo_region . $Geo_placename;\r\n  if ($geo_output != "") {\r\n    $output .= " \\n" . $geo_output;\r\n  } \r\n} \r\n\r\n$output .= $MetaSS;\r\n$output .= $MetaFaviconLinks;\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` (`id`, `name`, `description`, `snippet`, `locked`) VALUES(23, 'DisplayCode', 'Text display of Chunk, Snippet, or Template code', '// Snippet: DisplayCode\r\n// Purpose: Text display of Chunk, Snippet, or Template code\r\n// Created By: Ralph A. Dahlgren\r\n// Last Modified: 2008-04-17\r\n// Usage: [[DisplayCode?type=chunk|file|snippet|template&name=Name]]\r\n// Note: Remember that this snippet uses resource names instead of id''s so name changes will effect existing snippet calls\r\n// Also: Files use absolute paths so use ./path/from/Etomite/root\r\n\r\n// Snippet messages (the messages below were used for development purposes)\r\n$usage = "Error -- Usage: [ [DisplayCode?type=chunk|file|snippet|template&name=Name] ]";\r\n$error = "Error -- " . $type ." ''" . $name . "'' is either an invalid name or is empty.";\r\n\r\n// Set fieldset amd legend styles (can be inline style or reference to stylesheet components)\r\n// $fieldsetCSS = "class=''contentarea''"; // example using a CSS class\r\n$fieldsetCSS = "style=''background-color:#ffffff; border:1px solid #000000;''";\r\n$legendCSS = "style=''background-color:#ffffff; border:1px solid #000000;''";\r\n\r\n// Define which Etomite tags to be rendered non-functional in the returned code\r\n// $oldtags are listed in their original format\r\n$oldtags = array("[[","[!","[*","[(","[~","{{","[^");\r\n// $newtags are listed with a blank space between tag elements\r\n$newtags = array("[ [","[ !","[ *","[ (","[ ~","{ {","[ ^");\r\n\r\n// If Chunk or Template\r\nif(($type == "template") || ($type == "chunk"))\r\n{\r\n  if($name == '''')\r\n  {\r\n    return $usage;\r\n  }\r\n  else\r\n  {\r\n    // Set the appropriate field to extract from the record\r\n    $field = ($type == "template") ? "content" : "snippet";\r\n    // Query the appropriate database table for the desired record\r\n    if($type == "template")\r\n    {\r\n      $rs = $etomite->getIntTableRows($field,"site_templates","templatename=''$name''");\r\n    }\r\n    elseif($type == "chunk")\r\n    {\r\n      $rs = $etomite->getIntTableRows($field,"site_htmlsnippets","name=''$name''");\r\n    }\r\n    // If a record was returned then get the code\r\n    if(is_array($rs))\r\n    {\r\n      $code = str_replace($oldtags, $newtags,$rs[0][$field]);\r\n      $code = "<div class=\\"code\\">".nl2br(str_replace(" ","&nbsp;",htmlentities($code)))."</div>";\r\n    }\r\n    else\r\n    {\r\n      return $error;\r\n    }\r\n  }\r\n}\r\n\r\n// If Snippet\r\nif($type == "snippet")\r\n{\r\n  if($name == '''')\r\n  {\r\n    return $usage;\r\n  }\r\n  else\r\n  {\r\n    // Cache snippet code into a variable\r\n    $rs = $etomite->getIntTableRows("snippet","site_snippets","name=''$name''");\r\n    // If snippet code is not found, display message\r\n    if(!is_array($rs))\r\n    {\r\n      return $error;\r\n    }\r\n    // If snippet code exists, process it for display\r\n    else\r\n    {\r\n      // Add PHP Begin and End tags and use highlight_string() to colorize the code\r\n      $code = highlight_string("<?php\\n".chr(13).str_replace($oldtags, $newtags, $rs[0][''snippet''])."?>", true);\r\n      $code = str_replace("<code>","",$code);\r\n      $code = str_replace("</code>","",$code);\r\n    }\r\n  }\r\n}\r\n\r\n// If File\r\nif($type == "file")\r\n{\r\n  if($name == '''')\r\n  {\r\n    return $usage;\r\n  }\r\n  else\r\n  {\r\n    // If snippet code is not found, display message\r\n    $code = file_get_contents($name);\r\n    if($code == "")\r\n    {\r\n      return $error;\r\n    }\r\n    else\r\n    {\r\n      // If this is PHP then highlight the code\r\n      if((substr($name,-3) == "php") || (substr($name,-4) == "phps"))\r\n      {\r\n        $code = highlight_string(str_replace($oldtags, $newtags, $code), true);\r\n      }\r\n      // All other code gets processed for display\r\n      else\r\n      {\r\n        $code = "<code>".str_replace(" ","&nbsp;",htmlentities(str_replace($oldtags, $newtags,$code)))."</code>";\r\n      }\r\n    }\r\n  }\r\n}\r\n\r\n// Open a fieldset, insert code, and return\r\n$type = ucfirst($type);\r\nreturn "<fieldset><legend>{$type}: {$name}</legend>{$code}</fieldset>";\r\n', 0);

-- END::INSERT site_snippets DATA


-- START::INSERT site_templates DATA

INSERT INTO `{PREFIX}site_templates` (`id`, `templatename`, `description`, `content`, `locked`) VALUES(1, 'Etomite v1.0', 'New Default Page Template', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"\r\n "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<head>\r\n[!MetaTagsExtra!]\r\n<link rel="stylesheet" type="text/css" href="./templates/default/main.css" />\r\n<link rel="shortcut icon" href="./favicon.ico" />\r\n</head>\r\n<body>\r\n\r\n<div id="page">\r\n\r\n  <div id="header"><img src="templates/default/images/logo.jpg" id="mainlogo" alt="Etomite" />\r\n    <h1>[(site_name)]</h1>\r\n    <h2>fast, free, infinitely flexible</h2>\r\n  </div><!--= end header -->\r\n\r\n  <div id="menu">\r\n    [!ListGlobal!]\r\n  </div><!-- end menu -->\r\n\r\n  <div id="sidebar">\r\n    [!ListMenu?LM_levels=-1!]\r\n    [!getSidebar?doc=sideBanner&wildcard=1&class=sideBanner!]\r\n    [!SearchPrompt!]\r\n    {{W3C Validation}}\r\n  </div><!-- end sidebar -->\r\n\r\n  <div id="content">\r\n    <p id="pagetrail">[[PageTrail]]</p>\r\n    <h1 class="pagetitle">[*longtitle*]</h1>\r\n    [*content*]\r\n  </div><!-- end content -->\r\n\r\n  <div id="footer">\r\n    <div>Copyright &copy; [!DateTime?format=%Y!], [(site_name)]. All Rights Reserved. | [[PoweredBy]]</div>\r\n    <div>Page Last Edited: [!DateTime?timestamp=[*editedon*]!].</div>\r\n    <div>Site Last Edited: [!SiteUpdate!].</div>\r\n    <div>MySQL: [^qt^], [^q^] request(s), PHP: [^p^], total: [^t^], document retrieved from [^s^]</div>\r\n  </div><!-- end footer -->\r\n\r\n</div><!-- end page -->\r\n\r\n{{FixInertTags}}\r\n\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES(2, 'Blank', 'Used to display unformatted pages, or pages that render their own markup, like Google XML site map', '[*content*]\r\n', 0);

-- END::INSERT site_templates DATA
